angular.module('ngApp').controller('ticketListCtrl', function($scope, $state, $timeout, $http, $ionicModal, $ionicActionSheet, $ionicPopover, $ionicLoading, $localstorage) {

    $scope.backSearch = true;
    $scope.allTickets = [];
    $scope.page = 1;
    $scope.limit = 20;
    $scope.busy = true;
    $scope.addTicketBtnShow = false;
    var arrayLength = 0;
    $scope.search = {
        input: ""
    };

    $scope.pushCards = [];
    $scope.cardsKey = 0;
    $scope.firstLoad = true;
    var ticketList = [];
    var userId = $localstorage.getNoExpired('loginUserId');
    var roleId = $localstorage.getNoExpired('loginRoleId');
    var loginKey = $localstorage.getNoExpired('loginLoginKey');

    /*$ionicModal.fromTemplateUrl('my-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function() {
        $scope.modal.show();
    };
    $scope.closeModal = function() {
        $scope.modal.hide();
    };
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
    });
    $scope.$on('modal.hidden', function() {
    });
    $scope.$on('modal.removed', function() {
    });*/

    if(!checkNetConnection())
    {
        var success = function(message) {

        };
        var failure = function() {
            alert("عدم دسترسی به اینترنت");
        };
        if(typeof window.plugins != "undefined") {
        	window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
		}
    }

    $scope.$watch('sl', function(){
        $scope.getTickets();
    });

    $scope.getTickets = function()
    {
        if( !$.trim(userId) || !$.trim(roleId) || !$.trim(loginKey) )
        {
            if( $.trim(loginPageSlug) )
            {
                $state.go('nav.' + loginPageSlug);
                return false;
            }
        }

        if($scope.firstLoad) {
            $ionicLoading.show({
                noBackdrop: true
            });
        }
        // Load Tickets
        $http.get(
            url + '/api/v1/widget/get/ticket/getAllTickets?sl=' + $scope.sl + "&page=" + $scope.page + "&userId=" + userId + "&roleId=" + roleId
        ).then(function(resp)
        {
            arrayLength = resp.data['tickets'].length;
            //$scope.allTickets = resp.data['tickets'];
			if( $scope.allTickets.length > 0 )
            {
                for (var i=0; i<arrayLength; i++){
                    $scope.allTickets.push(resp.data['tickets'][i]);
                }
            }
            else
            {
                $scope.allTickets = resp.data['tickets'];
            }
			
			console.log($scope.allTickets);
			
            if( resp.data['roleUser'] === 'user' )
                $("#addTicketBtnShow").show();
            else
                $("#addTicketBtnShow").hide();

            $timeout(function()
            {
                if($scope.limit > arrayLength) {
                    $scope.page = 'end';
                    $scope.busy = true;
                }
                else
                    $scope.busy = false;

                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $ionicLoading.hide();
            }, 500);

        }, function(err) {
            $scope.busy = true;
        });
    };

    $scope.moreDataCanBeLoaded = function() {
        return !$scope.busy;
    };

    $scope.loadMoreData = function() {
        if($scope.busy || $scope.page == "end")
        {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return false;
        }
        $scope.page = $scope.page + 1;
        $scope.firstLoad = false;
        $scope.getTickets();
    };

    $scope.doRefresh = function() {
        $scope.page = 1;
        $scope.allTickets = [];
        $scope.pushCards = [];
        $scope.categories = [];
        $scope.cardsKey = 0;
        ticketList = [];
        $scope.busy = true;
        $scope.search.input = '';
        $scope.backSearch = true;
        $scope.firstLoad = false;
        $scope.getTickets();
    };

    /*$ionicPopover.fromTemplateUrl('popover.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });

    $scope.openPopover = function($event) {
        $scope.popover.show($event);
    };

    $scope.closePopover = function() {
        $scope.popover.hide();
    };

    $scope.$on('$destroy', function() {
        $scope.popover.remove();
    });

    $scope.$on('popover.hidden', function() {
    });

    $scope.$on('popover.removed', function() {
    });*/
});

angular.module('ngApp').controller('addTicketCtrl', function($scope, $timeout, $ionicPopup, $ionicLoading, $http, $localstorage){

    $scope.fileReaderSupported = window.FileReader != null;
    $scope.departmentArray = '';
    $scope.ticket = {};

    $scope.photoChanged = function(files)
    {
        if (files != null)
        {
            var file = files[0];
            var upload_file_size = $scope.upload_file_size * 1000 * 1024; /* convert to byte */
            if( upload_file_size < file.size )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: " بیشترین حجم مجاز آپلود " + $scope.upload_file_size + " مگابایت است ",
                    okText: "باشه"
                });
                return false;
            }
            if ($scope.fileReaderSupported && typeof file !== "undefined" && typeof file.type !== "undefined" && file.type.indexOf('image') > -1)
            {
                $timeout(function() {
                    var fileReader = new FileReader();
                    fileReader.readAsDataURL(file); // convert the image to data url.
                    fileReader.onload = function(e) {
                        $timeout(function() {
                            var check1 = e.target.result.indexOf( "image/png" );
                            var check2 = e.target.result.indexOf( "image/jpg" );
                            var check3 = e.target.result.indexOf( "image/jpeg" );
                            if( check1 > -1 || check2 > -1 || check3 > -1 )
                            {
                                $("#attachment").val(e.target.result);
                                $("#imageInfo").val(file.name);
                                $("#showAttachment").attr('src', e.target.result).show();
                            }
                            else {
                                $ionicPopup.alert({
                                    title: "خطا",
                                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                                    okText: "باشه"
                                });
                            }
                        });
                    }
                });
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        }
    };

    $scope.showCamera = function(field)
    {
        var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
        if ( is_app_call ) {
            $scope.field = field;
            navigator.camera.getPicture(onCameraSuccessTicket, onCameraFailTicket, { quality: 50,
                destinationType: Camera.DestinationType.DATA_URL });
        }
        else {
            alert('این کار فقط در فایل ساخته شده موبایل امکان پذیر است.');
        }
    };

    $scope.onCameraSuccess = function(imageUrlData)
    {
        $timeout(function()
        {
            var check1 = imageUrlData.indexOf( "image/png" );
            var check2 = imageUrlData.indexOf( "image/jpg" );
            var check3 = imageUrlData.indexOf( "image/jpeg" );
            if( check1 > -1 || check2 > -1 || check3 > -1 ) {
                $("#attachment").val(imageUrlData);
                $("#imageInfo").val("fromCamera"+Math.floor((Math.random() * 1000) + 1)+".jpg");
                $("#showAttachment").attr('src', imageUrlData).show();
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        });
    };

    $scope.onCameraFail = function(msg)
    {
        $ionicPopup.alert({
            title: "خطا",
            template: msg,
            okText: "باشه"
        });
    };

    $timeout(function ()
    {
        $scope.departmentArray = Base64.decode($scope.departments);
        $scope.departmentArray = JSON.parse($scope.departmentArray);
        $scope.ticket.department = $scope.departmentArray[0];
    }, 200);

    $scope.addNewTicket = function ()
    {
        if( typeof $scope.ticket.subject === 'undefined' || typeof $scope.ticket.content === 'undefined'
            || !$.trim($scope.ticket.subject) || !$.trim($scope.ticket.content) )
        {
            $ionicPopup.alert({
                title: "خطا",
                template: "لطفا موضوع و پیام را وارد نمایید",
                okText: "باشه"
            });
            return false;
        }

        var userId = $localstorage.getNoExpired('loginUserId');
        $ionicLoading.show();
        var sendData = $.param({
            attachment: $("#attachment").val(),
            imageInfo: $("#imageInfo").val(),
            department: $scope.ticket.department.id,
            subject: $scope.ticket.subject,
            content: $scope.ticket.content,
            priority: $scope.ticket.priority,
            user_userId: userId,
            sl: $scope.sl
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/ticket/addNewTicket',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config)
        {
            $ionicLoading.hide();
            if( data.status === 'success' )
            {
                $scope.ticket.subject = '';
                $scope.ticket.content = '';
                $("#attachment").val('');
                $("#imageInfo").val('');
                $("#showAttachment").attr('src', '');

                $ionicPopup.alert({
                    title: "موفقیت",
                    template: $scope.text_success_add_ticket,
                    okText: "باشه"
                });
            }
            else if( data.status === 'canNotUpload' )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "متاسفانه امکان ارسال فایل وجود ندارد لطفا پیام خود را بدون فایل ارسال کنید.",
                    okText: "باشه"
                });
            }
            else
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            }

        }).error(function (data, status, headers, config) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });
    };
});

angular.module('ngApp').controller('oneTicketCtrl', function($scope, $timeout, $http, $ionicLoading, $ionicPopup, $localstorage, $appetoToast, $ionicScrollDelegate)
{
    $scope.allTickewAnswers = [];
    $timeout(function ()
    {
        /*var answers = Base64.decode($scope.answers);
        answers = JSON.parse(answers);
        $scope.allTickewAnswers = answers;*/

        $ionicLoading.show();
        var sendData = $.param({
            ticketId: $scope.ticketId,
            sl: $scope.sl
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/ticket/getAnswersOfTicket',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config)
        {
            $ionicLoading.hide();
            $scope.allTickewAnswers = data;

        }).error(function (data, status, headers, config) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: "خطا",
                template: "لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });

    }, 200);

    $scope.fileReaderSupported = window.FileReader != null;
    $scope.departmentArray = '';
    $scope.ticket = {};

    $scope.photoChanged = function(files)
    {
        if (files != null)
        {
            var file = files[0];
            var upload_file_size = $scope.upload_file_size * 1000 * 1024; /* convert to byte */
            if( upload_file_size < file.size )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: " بیشترین حجم مجاز آپلود " + $scope.upload_file_size + " مگابایت است ",
                    okText: "باشه"
                });
                return false;
            }
            if ($scope.fileReaderSupported && typeof file !== "undefined" && typeof file.type !== "undefined" && file.type.indexOf('image') > -1)
            {
                $timeout(function() {
                    var fileReader = new FileReader();
                    fileReader.readAsDataURL(file); // convert the image to data url.
                    fileReader.onload = function(e) {
                        $timeout(function() {
                            var check1 = e.target.result.indexOf( "image/png" );
                            var check2 = e.target.result.indexOf( "image/jpg" );
                            var check3 = e.target.result.indexOf( "image/jpeg" );
                            if( check1 > -1 || check2 > -1 || check3 > -1 )
                            {
                                $("#attachment").val(e.target.result);
                                $("#imageInfo").val(file.name);
                                $appetoToast.make("فایل ضمیمه شد", 2000);
                            }
                            else {
                                $ionicPopup.alert({
                                    title: "خطا",
                                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                                    okText: "باشه"
                                });
                            }
                        });
                    }
                });
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        }
    };

    $scope.showCamera = function(field)
    {
        var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
        if ( is_app_call ) {
            $scope.field = field;
            navigator.camera.getPicture(onCameraSuccessTicket, onCameraFailTicket, { quality: 50,
                destinationType: Camera.DestinationType.DATA_URL });
        }
        else {
            alert('این کار فقط در فایل ساخته شده موبایل امکان پذیر است.');
        }
    };

    $scope.onCameraSuccess = function(imageUrlData)
    {
        $timeout(function()
        {
            var check1 = imageUrlData.indexOf( "image/png" );
            var check2 = imageUrlData.indexOf( "image/jpg" );
            var check3 = imageUrlData.indexOf( "image/jpeg" );
            if( check1 > -1 || check2 > -1 || check3 > -1 ) {
                $("#attachment").val(imageUrlData);
                $("#imageInfo").val("fromCamera"+Math.floor((Math.random() * 1000) + 1)+".jpg");
                $appetoToast.make("فایل ضمیمه شد", 2000);
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        });
    };

    $scope.onCameraFail = function(msg)
    {
        $ionicPopup.alert({
            title: "خطا",
            template: msg,
            okText: "باشه"
        });
    };

    $scope.addNewAnswer = function ()
    {
        var answer = $("#answer").val();
        if( !$.trim(answer) )
        {
            $ionicPopup.alert({
                title: "خطا",
                template: "لطفا متن را وارد نمایید",
                okText: "باشه"
            });
            return false;
        }

        var userId = $localstorage.getNoExpired('loginUserId');
        var roleId = $localstorage.getNoExpired('loginRoleId');
        var loginFullName = $localstorage.getNoExpired('loginFullName');
        var loginProfileImage = $localstorage.getNoExpired('loginProfileImage');

        $ionicLoading.show();
        var sendData = $.param({
            attachment: $("#attachment").val(),
            imageInfo: $("#imageInfo").val(),
            answer: answer,
            user_userId: userId,
            roleId: roleId,
            ticketId: $scope.ticketId,
            sl: $scope.sl
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/ticket/addNewAnswer',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config)
        {
            $ionicLoading.hide();
            if( data.status === 'success' )
            {
                var firstColorBg = '', userAdminName = '', ticketClass = '', newAnswer = new Array(), imgSrc = '';
                if( data.who_answer === 'user' )
                {
                    firstColorBg = 'first-color-bg';
                    ticketClass = 'right';
                }
                else
                {
                    firstColorBg = '';
                    ticketClass = 'left';
                }

                if( loginProfileImage === '' || loginProfileImage === null || loginProfileImage === 'null' )
                    imgSrc = data.default_profile_image;
                else
                    imgSrc = loginProfileImage;

                newAnswer['who_answer_id'] = userId;
                newAnswer['who_answer'] = data.who_answer;
                newAnswer['answer'] = answer;
                newAnswer['attachment'] = data.attachment;
                newAnswer['firstColorBg'] = firstColorBg;
                newAnswer['userAdminName'] = loginFullName;
                newAnswer['imgSrc'] = imgSrc;
                newAnswer['ticketClass'] = ticketClass;
                newAnswer['date_added'] = 'الان';
                $scope.allTickewAnswers.push(newAnswer);
                $ionicScrollDelegate.scrollBottom();

                $("#answer").val('');
                $("#attachment").val('');
                $("#imageInfo").val('');
            }
            else if( data.status === 'canNotUpload' )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "متاسفانه امکان ارسال فایل وجود ندارد لطفا پیام خود را بدون فایل ارسال کنید.",
                    okText: "باشه"
                });
            }
            else
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            }

        }).error(function (data, status, headers, config) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });
    };
});

var Base64 = {

    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
                this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

};

function onCameraSuccessTicket(imageURI) {
    var $scope = angular.element('[ng-controller=addTicketCtrl]').scope();
    $scope.onCameraSuccess("data:image/jpg;base64," + imageURI);
}

function onCameraFailTicket(message) {
    var $scope = angular.element('[ng-controller=addTicketCtrl]').scope();
    $scope.onCameraFail(message);
}