angular.module('ngApp').controller('FormsCtrl', function($scope, $timeout, $ionicPopup) {
    $scope.fileReaderSupported = window.FileReader != null;

    $scope.photoChanged = function(files, field)
    {
        if (files != null)
        {
            var file = files[0];
            if ($scope.fileReaderSupported && typeof file != "undefined" && typeof file.type != "undefined" && file.type.indexOf('image') > -1)
            {
                $timeout(function() {
                    var fileReader = new FileReader();
                    fileReader.readAsDataURL(file); // convert the image to data url.
                    fileReader.onload = function(e) {
                        $timeout(function() {
                            var check1 = e.target.result.indexOf( "image/png" );
                            var check2 = e.target.result.indexOf( "image/jpg" );
                            var check3 = e.target.result.indexOf( "image/jpeg" );
                            if( check1 > -1 || check2 > -1 || check3 > -1 ) {
                                $("#file"+field).val(e.target.result);
                                $("#imageInfo"+field).val(file.name);
                                $("#imageShow"+field).attr('src', e.target.result);
                                $("#imageShow"+field).show();
                            }
                            else {
                                $ionicPopup.alert({
                                    title: "خطا",
                                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png و jpg قابل استفاده هستند.",
                                    okText: "باشه"
                                });
                            }
                        });
                    }
                });
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png و jpg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        }
    };

    $scope.field = "";
    $scope.showCamera = function(field) {
        var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
        if ( is_app_call ) {
            $scope.field = field;
            navigator.camera.getPicture(onCameraSuccess, onCameraFail, { quality: 50,
                destinationType: Camera.DestinationType.DATA_URL });
        }
        else {
            alert('این کار فقط در فایل ساخته شده موبایل امکان پذیر است.');
        }
    };

    $scope.onCameraSuccess = function(imageUrlData) {
        $timeout(function() {
            var check1 = imageUrlData.indexOf( "image/png" );
            var check2 = imageUrlData.indexOf( "image/jpg" );
            var check3 = imageUrlData.indexOf( "image/jpeg" );
            if( check1 > -1 || check2 > -1 || check3 > -1 ) {
                $("#file"+$scope.field).val(imageUrlData);
                $("#imageInfo"+$scope.field).val("fromCamera"+Math.floor((Math.random() * 1000) + 1)+".jpg");
                $("#imageShow"+$scope.field).attr('src', imageUrlData);
                $("#imageShow"+$scope.field).show();
                $scope.field = "";
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png و jpg قابل استفاده هستند.",
                    okText: "باشه"
                });
                $scope.field = "";
            }
        });
    };

    $scope.onCameraFail = function(msg) {
        $ionicPopup.alert({
            title: "خطا",
            template: msg,
            okText: "باشه"
        });
    };

});

function onCameraSuccess(imageURI) {
    var $scope = angular.element('[ng-controller=FormsCtrl]').scope();
    $scope.onCameraSuccess("data:image/jpg;base64," + imageURI);
}

function onCameraFail(message) {
    var $scope = angular.element('[ng-controller=FormsCtrl]').scope();
    $scope.onCameraFail(message);
}