var wooNetwork = false;
var wooCurrentNetworkSiteUrl = "";
var wooCurrentNetworkSiteName = "";
var wooCurrentNetworkSiteId = 0;
angular.module('ngApp').controller('WoocommerceCtrl', function($scope, $ionicScrollDelegate, $rootScope, $localstorage, $state, $ionicModal, $timeout, $ionicLoading, $http, $ionicPopup) {

    $scope.products = [];
    $scope.newProducts = [];
    $scope.newProductsLoader = false;
    $scope.network = false;
    $scope.wooCurrentNetworkSiteUrl = "";
    $scope.wooCurrentNetworkSiteName = "";
    $scope.wooCurrentNetworkSiteId = 0;
    $scope.baseShowUrl = "";
    $scope.callApiUrl = "";
    $scope.arg1 = null;
    $scope.page = 1;
    $scope.per_page = 20;
    $scope.arg2 = JSON.stringify({"page": $scope.page,"filter[limit]": $scope.per_page});
    $scope.needed = "products/get";
    $scope.ck = "";
    $scope.cs = "";

    $scope.localUrl = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.Woocommerce = "";

    $scope.pushCards = [];
    $scope.cardsKey = 0;
    $scope.busy = false;
    $scope.searchQuery = "";
    $scope.content_classes = "";
    $scope.layout = "";

    $scope.currency_symbol = "ریال";


    $scope.onTabSelected = function(type) {
        $timeout(function(){
            $ionicScrollDelegate.resize();
        }, 250);
    };

    $scope.$watch('localUrl', function () {
        if(WoocommerceAPI == null || $scope.network) {
            $scope.Woocommerce = new WooCommerceAPI.WooCommerceAPI({
                url: $scope.localUrl,
                consumerKey: $scope.localCk,
                consumerSecret: $scope.localCs,
                verifySsl: true,
                queryStringAuth: true
            });
            WoocommerceAPI = $scope.Woocommerce;
            if($scope.network) {
                wooCurrentNetworkSiteUrl = $scope.wooCurrentNetworkSiteUrl;
                wooCurrentNetworkSiteName = $scope.wooCurrentNetworkSiteName;
                wooCurrentNetworkSiteId = $scope.wooCurrentNetworkSiteId;
            }
        }
        else {
            $scope.Woocommerce = WoocommerceAPI;
        }

        wooNetwork = $scope.network;

        $scope.WooGetProducts();

        $timeout(function(){
            var cardCount = $localstorage.getNoExpired("wooCartCount");
            if(cardCount != '' && cardCount > 0) {
                $(".woocommerce-card-count i").html(cardCount);
            }
            $(".woocommerce-card").click(function(){
                $state.go('nav.woocommerce-cart-v2');
            });
        }, 1000);

    });

    $scope.WooGetProducts = function(){
        if(!$scope.busy) {
            $ionicLoading.show();
            $scope.busy = true;
            var cards = $localstorage.getObjectNoExpired("wooAllProductsCache");
            var newCards = $localstorage.getObjectNoExpired("wooNewProductsCache");
            var keys = $localstorage.getNoExpired("wooAllProductsKeyCache");
            var page = $localstorage.getNoExpired("wooAllProductsPageCache");
            if($scope.currency_symbol != "") {
                $localstorage.setNoExpired("wooCurrencySymbol", $scope.currency_symbol);
            }
            if($scope.newProductsLoader ||  $scope.network) {
                page = 1;
                $scope.page = 1;
                if(!$scope.network) {
                    $scope.busy = false;
                }
                $scope.pushCards = [];
                $scope.cardsKey = 0;
                $scope.searchQuery = "";
                $scope.products = [];
                $scope.newProducts = [];
                $scope.per_page = 10;
                cards = [];
                keys = 0;
            }

            $localstorage.setNoExpired("wooCk", $scope.ck);
            $localstorage.setNoExpired("wooCs", $scope.cs);
            $localstorage.setNoExpired("wooLocalCk", $scope.localCk);
            $localstorage.setNoExpired("wooLocalCs", $scope.localCs);

            if(page != '' && page != 0 && page != 'end') {
                $scope.page = Number(page);
                $scope.pushCards = cards;
                $scope.cardsKey = Number(keys);
                $scope.currency_symbol = $localstorage.getNoExpired("wooCurrencySymbol");
                if($scope.currency_symbol == "") {
                    $scope.currency_symbol = "ريال";
                }
            }

            if(page == 'end') {
                $scope.products = cards;
                $scope.newProducts = newCards;
                $ionicLoading.hide();
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.currency_symbol = $localstorage.getNoExpired("wooCurrencySymbol");
                if($scope.currency_symbol == "") {
                    $scope.currency_symbol = "ريال";
                }
            }
            else {

                $scope.Woocommerce.get('products?page='+$scope.page+'&filter[limit]='+$scope.per_page, function(err, data, res) {
                    if(err) {
                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                        $scope.busy = false;

                        var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
                        if ( is_app_call ) {
                            var success = function (message) {

                            };
                            var failure = function () {
                                alert("عدم دسترسی به اینترنت");
                            };
                            window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
                        }

                    }
                    else {
                        var result = JSON.parse(res);
                        var counter = 1;
                        var link = {
                            'layout': $scope.layout,
                            'content_classes': $scope.content_classes
                        };
                        for(var i in result.products) {
                            if(!result.products[i].visible) {
                                continue;
                            }
                            if(counter <= 2) {
                                if(counter == 1) {
                                    $scope.pushCards[$scope.cardsKey] = {
                                        "products": []
                                    };
                                }
                                link.id = result.products[i].id.toString();
                                link.name = result.products[i].title;
                                result.products[i].appLink = WooBase64.encode(JSON.stringify(link));
                                $scope.pushCards[$scope.cardsKey].products.push(result.products[i]);
                                $scope.newProducts.push(result.products[i]);
                            }
                            counter++;
                            if(counter > 2) {
                                counter = 1;
                                $scope.cardsKey++;
                            }
                        }
                        if(result.products.length < $scope.per_page) {
                            $scope.page = "end";
                            $scope.busy = true;
                        }
                        else {
                            $scope.page = $scope.page + 1;
                            $timeout(function(){
                                $scope.busy = false;
                            }, 500);
                        }
                        $scope.products = $scope.pushCards;


                        if($scope.currency_symbol == "") {
                            $scope.currency_symbol = "ريال";
                        }

                        $localstorage.setObjectNoExpired("wooAllProductsCache", $scope.pushCards);
                        $localstorage.setObjectNoExpired("wooNewProductsCache", $scope.newProducts);
                        $localstorage.setNoExpired("wooAllProductsKeyCache", $scope.cardsKey);
                        $localstorage.setNoExpired("wooAllProductsPageCache", $scope.page);
                        $localstorage.setNoExpired("wooCurrencySymbol", $scope.currency_symbol);

                        $ionicLoading.hide();
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    }
                });
            }
        }
    };

    $scope.doRefresh = function() {
        $scope.page = 1;
        $scope.busy = false;
        $scope.pushCards = [];
        $scope.cardsKey = 0;
        $scope.searchQuery = "";
        $scope.products = [];

        $localstorage.removeNoExpired("wooAllProductsCache");
        $localstorage.removeNoExpired("wooAllProductsKeyCache");
        $localstorage.removeNoExpired("wooAllProductsPageCache");

        $scope.WooGetProducts();

        $scope.$broadcast('scroll.refreshComplete');
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };

    $scope.nextPage = function() {
        if($scope.busy || $scope.page == "end") {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return false;
        }
        $scope.network = false;
        $scope.WooGetProducts();
    };

    $scope.doSearch = function() {
        $scope.searchQuery = "";
        var searchPopup = $ionicPopup.show({
            template: '<ion-md-input><input type="text" id="searchQuery" ng-model="searchQuery" required><span class="md-highlight"></span><span class="md-bar"></span><label>کلمه مورد نظر خود را بنویسید</label></ion-md-input>',
            title: 'جستجو',
            subTitle: '',
            scope: $scope,
            buttons: [
                {
                    text: 'بازگشت',
                    onTap: function(e) {
                        return 'searchQueryCanceled';
                    }
                },
                {
                    text: '<b>جستجو</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        $scope.searchQuery = jQuery("#searchQuery").val();
                        return $scope.searchQuery;
                    }
                }
            ]
        });
        searchPopup.then(function(res) {
            if(typeof res != "undefined" && res != '' && res != 'searchQueryCanceled') {
                res = res.replace(/ك/g, 'ک').replace(/ي/g, 'ی').replace(/ي/g, 'ی');
                var arg2 = JSON.stringify({"filter[q]": res});
                /*$state.go('nav.woocommerce', {arg1: 'null', arg2: arg2, needed: $scope.needed, ck: $scope.ck, cs: $scope.cs, view: 'search', extra: "{'name':'جستجو', 'content_classes':'"+$scope.content_classes+"', 'layout':'"+$scope.layout+"'}"});*/

                var link = {
                    'layout': $scope.layout,
                    'content_classes': $scope.content_classes,
                    'searchQuery': res,
                    'name': "جستجو"
                };
                var appLink = WooBase64.encode(JSON.stringify(link));
                $state.go('nav.woocommerce-v2', {
                    'view': 'search',
                    'extra': appLink
                });
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        });

    };

});
angular.module('ngApp').controller('WoocommerceCategoryCtrl', function($scope, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http){

    $scope.products = [];
    $scope.baseShowUrl = "";
    $scope.callApiUrl = "";
    $scope.arg1 = null;
    $scope.page = 1;
    $scope.per_page = 20;
    $scope.category = "";
    $scope.arg2 = JSON.stringify({"page": $scope.page,"filter[limit]": $scope.per_page,"filter[category]": $scope.category});
    $scope.needed = "products/get";
    $scope.ck = "";
    $scope.cs = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.pushCards = [];
    $scope.cardsKey = 0;
    $scope.currency_symbol = "";
    $scope.busy = false;

    var targetRgbs = fadeToRgb.split(',');
    $(".card-bar").attr("style", 'box-shadow:0 0 4px 0 rgba(0,0,0,0.12), 0 4px 4px 0 rgba(0,0,0,0.24); background-color: rgb(' + targetRgbs[0] + ', ' + targetRgbs[1] + ', ' + targetRgbs[2] + ') !important;');

    $scope.$watch('localUrl', function () {

        $scope.ck = $localstorage.getNoExpired("wooCk");
        $scope.cs = $localstorage.getNoExpired("wooCs");
        $scope.localCk = $localstorage.getNoExpired("wooLocalCk");
        $scope.localCs = $localstorage.getNoExpired("wooLocalCs");

        if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
            WoocommerceAPI = null;
            $scope.localUrl = wooCurrentNetworkSiteUrl;
        }

        if(WoocommerceAPI != null) {
            $scope.WooGetProducts();
        }
        else {
            WoocommerceAPI = new WooCommerceAPI.WooCommerceAPI({
                url: $scope.localUrl,
                consumerKey: $scope.localCk,
                consumerSecret: $scope.localCs,
                verifySsl: true,
                queryStringAuth: true
            });
            $scope.WooGetProducts();
        }
    });

    $scope.WooGetProducts = function(){
        if(!$scope.busy) {
            $ionicLoading.show();
            $scope.busy = true;
            WoocommerceAPI.get('products?page='+$scope.page+'&filter[limit]='+$scope.per_page+'&filter[category]='+$scope.category, function(err, data, res) {
                if(err) {
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.busy = false;
                    var success = function (message) {

                    };
                    var failure = function () {
                        alert("عدم دسترسی به اینترنت");
                    };
                    window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
                }
                else {
                    var result = JSON.parse(res);
                    var counter = 1;
                    var link = {
                        'layout': $scope.layout,
                        'content_classes': $scope.content_classes
                    };
                    for(var i in result.products) {
                        if(!result.products[i].visible) {
                            continue;
                        }
                        if(counter <= 2) {
                            if(counter == 1) {
                                $scope.pushCards[$scope.cardsKey] = {
                                    "products": []
                                };
                            }
                            link.id = result.products[i].id.toString();
                            link.name = result.products[i].title;
                            result.products[i].appLink = WooBase64.encode(JSON.stringify(link));
                            $scope.pushCards[$scope.cardsKey].products.push(result.products[i]);
                        }
                        counter++;
                        if(counter > 2) {
                            counter = 1;
                            $scope.cardsKey++;
                        }
                    }
                    if(result.products.length < $scope.per_page) {
                        $scope.page = "end";
                        $scope.busy = true;
                    }
                    else {
                        $scope.page = $scope.page + 1;
                        $timeout(function(){
                            $scope.busy = false;
                        }, 500);
                    }
                    $scope.products = $scope.pushCards;

                    if($scope.currency_symbol == "") {
                        $scope.currency_symbol = "ريال";
                    }

                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            });
        }

    };

    $scope.nextPage = function() {
        if($scope.busy || $scope.page == "end") {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return false;
        }
        $scope.WooGetProducts();
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };

});
angular.module('ngApp').controller('WoocommerceSearchCtrl', function($scope, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http){
    $scope.searchQuery = "";
    $scope.products = [];
    $scope.showNotFound = false;
    $scope.baseShowUrl = "";
    $scope.ck = "";
    $scope.cs = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.pushCards = [];
    $scope.cardsKey = 0;
    $scope.currency_symbol = "ريال";
    $scope.q = "";
    $scope.localUrl = "";
    $scope.busy = false;
    $scope.page = 1;
    $scope.per_page = 0;
    $scope.checker = new Array();

    $scope.$watch('localUrl', function () {

        $scope.ck = $localstorage.getNoExpired("wooCk");
        $scope.cs = $localstorage.getNoExpired("wooCs");
        $scope.localCk = $localstorage.getNoExpired("wooLocalCk");
        $scope.localCs = $localstorage.getNoExpired("wooLocalCs");

        if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
            WoocommerceAPI = null;
            $scope.localUrl = wooCurrentNetworkSiteUrl;
        }

        if(WoocommerceAPI != null) {
            $scope.WooGetProducts();
        }
        else {
            WoocommerceAPI = new WooCommerceAPI.WooCommerceAPI({
                url: $scope.localUrl,
                consumerKey: $scope.localCk,
                consumerSecret: $scope.localCs,
                verifySsl: true,
                queryStringAuth: true
            });
            $scope.WooGetProducts();
        }
    });

    $scope.WooGetProducts = function(){
        if(!$scope.busy) {
            $ionicLoading.show();
            $scope.busy = true;
            $scope.q = $scope.q.replace(/ك/g, 'ک').replace(/ي/g, 'ی').replace(/ي/g, 'ی');
            WoocommerceAPI.get('products?filter[q]='+$scope.q, function(err, data, res) {
                if(err) {
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.busy = false;
                    var success = function (message) {

                    };
                    var failure = function () {
                        alert("عدم دسترسی به اینترنت");
                    };
                    window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
                    $scope.showNotFound = true;
                }
                else {
                    var result = JSON.parse(res);
                    var counter = 1;
                    var link = {
                        'layout': $scope.layout,
                        'content_classes': $scope.content_classes
                    };
                    for(var i in result.products) {
                        if(!result.products[i].visible) {
                            continue;
                        }
                        if(counter <= 2) {
                            if(counter == 1) {
                                $scope.pushCards[$scope.cardsKey] = {
                                    "products": []
                                };
                            }
                            link.id = result.products[i].id.toString();
                            link.name = result.products[i].title;
                            result.products[i].appLink = WooBase64.encode(JSON.stringify(link));
                            $scope.pushCards[$scope.cardsKey].products.push(result.products[i]);
                        }
                        counter++;
                        if(counter > 2) {
                            counter = 1;
                            $scope.cardsKey++;
                        }
                    }
                    if(result.products.length <= $scope.per_page) {
                        $scope.page = "end";
                        $scope.busy = true;
                        $scope.showNotFound = true;
                    }
                    else {
                        $scope.page = $scope.page + 1;
                        $scope.showNotFound = false;
                        $timeout(function(){
                            $scope.busy = false;
                        }, 500);
                    }

                    $scope.$apply(function(){
                        $scope.products = $scope.pushCards;
                    });

                    if($scope.currency_symbol == "") {
                        $scope.currency_symbol = "ريال";
                    }

                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }
            });
        }

    };


    $scope.wooInnerSearch = function() {
        if($scope.searchQuery != "") {
            $scope.products = [];
            $scope.showNotFound = false;
            $scope.pushCards = [];
            $scope.cardsKey = 0;
            $scope.q = $scope.searchQuery;
            $scope.busy = false;
            $scope.page = 1;
            $scope.per_page = 0;
            $scope.WooGetProducts();
        }
    };



});
angular.module('ngApp').controller('WoocommerceCartCtrl', function($scope, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http, $state, $ionicPopup, $ionicScrollDelegate){

    $scope.ck = "";
    $scope.cs = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.slug = "";
    $scope.baseShowUrl = "";
    $scope.orders = [];
    $scope.fullPrice = 0;
    $scope.separator = ",";
    $scope.num_decimal = 0;

    $scope.newAccount = true;

    $scope.registered = {
        email: "",
        password: "",
        remember: false
    };

    $scope.userInfo = {
        'first_name': '',
        'last_name': '',
        'company': '',
        'address_1': '',
        'address_2': '',
        'city': '',
        'state': '',
        'postcode': '',
        'country': 'IR',
        'email': '',
        'phone': '',
        'password': ''
    };
    $scope.userInfoContinue = "";


    $scope.listCanSwipe = true;

    $scope.setCartPage = function() {
        var orders = $localstorage.getObjectNoExpired("wooCartProducts");
        var allOrders = [];
        $scope.fullPrice = 0;
        var price = 0;

        $scope.ck = $localstorage.getNoExpired("wooCk");
        $scope.cs = $localstorage.getNoExpired("wooCs");
        $scope.localCk = $localstorage.getNoExpired("wooLocalCk");
        $scope.localCs = $localstorage.getNoExpired("wooLocalCs");

        if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
            $scope.baseShowUrl = wooCurrentNetworkSiteUrl+"/?appeto_api=woocommerce";
        }


        for(var i in orders) {
            allOrders.push(orders[i]);
            price = orders[i].price.split($scope.separator);
            price = price.join("");
            $scope.fullPrice += (parseFloat(price) * orders[i].quantity);
        }
        if($scope.num_decimal != 0) {
            $scope.fullPrice = $scope.fullPrice.toFixed($scope.num_decimal);
        }
        else {
            $scope.fullPrice = $scope.fullPrice;
        }

        $scope.orders = allOrders;

        var email = $localstorage.getNoExpired("wooThisMobileEmail");
        if(email == "") {
            $scope.newAccount = true;
            $scope.registered.email = "";
        }
        else {
            $scope.newAccount = false;
            $scope.registered.email = email;
            var remember = $localstorage.getNoExpired("wooRegisteredRemember");
            if(remember == true || remember == "true") {
                $scope.registered.remember = true;
                var pass = $localstorage.getNoExpired("wooRegisteredPassword");
                $scope.registered.password = pass;
            }
            else {
                $scope.registered.remember = false;
            }
        }

    };

    $scope.changeAccountMode = function(status) {
        if(status == 1) {
            $scope.newAccount = true;
        }
        else {
            $scope.newAccount = false;
        }
        $ionicScrollDelegate.$getByHandle('inOrder').scrollTop();
    };

    $scope.deleteFromCart = function(id, title) {
        var removePopup = $ionicPopup.show({
            template: 'آیا مایلید این محصول را از  سبد خرید حذف کنید؟',
            title: title,
            subTitle: '',
            scope: $scope,
            buttons: [
                {
                    text: 'خیر',
                    onTap: function(e) {
                        return 'no';
                    }
                },
                {
                    text: 'بله',
                    type: 'button-positive',
                    onTap: function(e) {
                        return 'yes';
                    }
                }
            ]
        });
        removePopup.then(function(res) {
            if(typeof res != "undefined" && res != '' && res == 'yes') {
                var products = $localstorage.getObjectNoExpired("wooCartProducts");
                var counts = products[id].quantity;
                delete products[id];
                $localstorage.setObjectNoExpired("wooCartProducts", products);
                $scope.removeFromTopMenu(counts);
                $scope.setCartPage();
            }
        });
    };

    $scope.showItemFromCart = function(id, title, layout, content_class) {
        title = title.replace("#", "");
        var link = {
            'layout': layout,
            'content_classes': content_class
        };
        link.id = id;
        link.name = title;
        var appLink = WooBase64.encode(JSON.stringify(link));
        $state.go('nav.woocommerce-v2', {
            'view': 'product',
            'extra': appLink
        });
    };

    $scope.removeFromTopMenu = function(count) {
        var cardCount = Number($localstorage.getNoExpired("wooCartCount"));
        cardCount -= count;
        if(cardCount < 0) {
            cardCount = 0;
        }
        $localstorage.setNoExpired("wooCartCount", cardCount);
    };

    $scope.isEmpty = function(obj) {
        for(var prop in obj) {
            if(obj.hasOwnProperty(prop))
                return false;
        }

        return true;
    };

    $scope.emptyCart = function() {

        var removePopup = $ionicPopup.show({
            template: 'آیا مایلید سبد خرید خود را خالی کنید؟',
            title: 'پاک کردن سبد خرید',
            subTitle: '',
            scope: $scope,
            buttons: [
                {
                    text: 'خیر',
                    onTap: function(e) {
                        return 'no';
                    }
                },
                {
                    text: 'بله',
                    type: 'button-positive',
                    onTap: function(e) {
                        return 'yes';
                    }
                }
            ]
        });
        removePopup.then(function(res) {
            if(typeof res != "undefined" && res != '' && res == 'yes') {
                $localstorage.removeNoExpired("wooCartProducts");
                $localstorage.removeNoExpired("wooCartCount");
                $scope.orders = [];
                $(".woocommerce-card-count i").html(0);
            }
        });
    };

    $scope.createOrder = function() {
        if($scope.newAccount) {
            if(typeof $scope.userInfoContinue == "string") {
                $scope.userInfoContinue = $scope.userInfoContinue.split(",");
            }
            var showError = false;
            var showPassError = false;
            for(var i in $scope.userInfo) {
                if(i == 'company' || i == 'address_2') {
                    continue;
                }

                if($scope.userInfo[i] == "") {
                    for(var j in  $scope.userInfoContinue) {
                        if(i == $scope.userInfoContinue[j]) {
                            showError = true;
                            break;
                        }
                    }
                }
                if(i == "password" && $scope.userInfo[i].length < 6) {
                    showPassError = true;
                    break;
                }
            }
            if(showError) {
                $scope.showError("لطفا اطلاعات مورد نیاز را تکمیل کنید.");
                return false;
            }

            if(!wooValidateEmail($scope.userInfo.email)) {
                $scope.showError("لطفا یک ایمیل صحیح وارد کنید.");
                return false;
            }

            if(showPassError) {
                $scope.showError("گذرواژه باید حداقل 6 کاراکتر باشد.");
                return false;
            }

            $scope.registerNewUser();
        }
        else {
            if(!wooValidateEmail($scope.registered.email)) {
                $scope.showError("لطفا یک ایمیل صحیح وارد کنید.");
                return false;
            }
            $scope.getRegisteredUser();
        }
    };

    $scope.registerNewUser = function() {
        $ionicLoading.show();
        var arg2 = JSON.stringify($scope.userInfo);
        var callApiUrl = $scope.baseShowUrl+"&arg1=-1&arg2="+arg2+"&needed=customers/create&ck="+$scope.ck+"&cs="+$scope.cs;
        $http.get(callApiUrl).then(function(resp) {
            if(resp.data.status == "true" && typeof resp.data.response.customer != "undefined") {
                var customer = resp.data.response.customer;
                $localstorage.setNoExpired('wooThisMobileEmail', customer.email);
                $scope.registered.email = customer.email;
                $scope.registered.password = $scope.userInfo.password;
                $scope.sendOrder(customer.id, resp.data.app_order_key);
            }
            else {
                if(resp.data.msg == "emailExists") {
                    $ionicLoading.hide();
                    $scope.showError('این ایمیل قبلا ثبت شده.');
                    return false;
                }
                else {
                    $ionicLoading.hide();
                    $scope.showError('خطا لطفا دوباره تلاش کنید.');
                    return false;
                }
            }
        }, function(err) {
            $ionicLoading.hide();
            $scope.showError('خطا لطفا دوباره تلاش کنید.');

            var success = function(message) {

            };
            var failure = function() {
                alert("عدم دسترسی به اینترنت");
            };
            window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
        });
    };

    $scope.getRegisteredUser = function() {
        $ionicLoading.show();
        var arg2 = JSON.stringify({"email": $scope.registered.email,"password": $scope.registered.password});
        var callApiUrl = $scope.baseShowUrl+"&arg1=-1&arg2="+arg2+"&needed=customers/get_by_email&ck="+$scope.ck+"&cs="+$scope.cs;
        $http.get(callApiUrl).then(function(resp) {
            if(resp.data.status == "true" && typeof resp.data.response.customer != "undefined") {
                var customer = resp.data.response.customer;
                $localstorage.setNoExpired('wooThisMobileEmail', customer.email);
                $localstorage.setNoExpired("wooRegisteredRemember", $scope.registered.remember);
                if($scope.registered.remember) {
                    $localstorage.setNoExpired("wooRegisteredPassword", $scope.registered.password);
                }
                else {
                    $localstorage.removeNoExpired("wooRegisteredPassword");
                }
                $scope.sendOrder(customer.id, resp.data.app_order_key);
            }
            else {
                $ionicLoading.hide();
                $scope.showError('خطا لطفا دوباره تلاش کنید.');
                return false;
            }
        }, function(err) {
            $ionicLoading.hide();
            var success = function(message) {

            };
            var failure = function() {
                alert("عدم دسترسی به اینترنت");
            };
            window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
        });
    };

    $scope.sendOrder = function(customer, key) {
        var line_items = [];
        var item = {};
        for(var i in $scope.orders) {
            item = {};
            if(typeof $scope.orders[i].parent_id != "undefined" && $scope.orders[i].parent_id > 0) {
                item.product_id = $scope.orders[i].id;
                item.variations = {};
                for(var j in $scope.orders[i].selectedVariations) {
                    item.variations[$scope.orders[i].selectedVariations[j].baseName] = $scope.orders[i].selectedVariations[j].name;
                }
            }
            else {
                item.product_id = $scope.orders[i].id;
            }
            item.quantity = $scope.orders[i].quantity;
            line_items.push(item);
        }
        var data = {
            "customer_id": customer,
            "line_items": line_items
        };
        var arg2 = JSON.stringify(data);
        var callApiUrl = $scope.baseShowUrl+"&arg1=-1&arg2="+arg2+"&needed=orders/create&ck="+$scope.ck+"&cs="+$scope.cs+"&appeto_key="+key+"&e="+$scope.registered.email+"&g="+$scope.registered.password;
        $http.get(callApiUrl).then(function(resp) {
            if(resp.data.status == "true" && resp.data.app_order_key != "") {
                $localstorage.removeNoExpired("wooCartProducts");
                $localstorage.removeNoExpired("wooCartCount");
                $scope.orders = [];
                $(".woocommerce-card-count i").html(0);
                $scope.newAccount = false;
                $ionicLoading.hide();
                $scope.modal.hide();
                $scope.doneMessage(resp.data.response.order.id, resp.data.response.order.view_order_url);
                var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
                if(is_app_call) {
                    navigator.app.loadUrl(resp.data.app_order_key, {openExternal : true});
                }
                else {
                    window.open(resp.data.app_order_key, '_system');
                }
            }
            else {
                $ionicLoading.hide();
                $scope.showError('خطا لطفا دوباره تلاش کنید.')
            }
        }, function(err) {
            $ionicLoading.hide();
            var success = function(message) {

            };
            var failure = function() {
                alert("عدم دسترسی به اینترنت");
            };
            window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
        });
    };

    $scope.showError = function(msg) {
        var errorPopup = $ionicPopup.show({
            template: msg,
            title: 'خطا',
            subTitle: '',
            scope: $scope,
            buttons: [
                {
                    text: 'باشه',
                    onTap: function(e) {
                        return 'ok';
                    }
                }
            ]
        });
        errorPopup.then(function(res) {

        });
    };

    $scope.doneMessage = function(orderId, view_order_url) {
        var donePopup = $ionicPopup.show({
            template: 'با تشکر سفارش شما ثبت شد، برای پرداخت به سایت منتقل شدید، شماره سفارش: '+orderId,
            title: 'تکمیل خرید',
            subTitle: '',
            scope: $scope,
            buttons: [
                {
                    text: 'باشه',
                    onTap: function(e) {
                        return 'ok';
                    }
                }
            ]
        });
        donePopup.then(function(res) {
            /*$state.go("nav."+$scope.slug);*/
        });
    };

    $scope.appCardToSite = function(siteUrl) {
        if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
            siteUrl = wooCurrentNetworkSiteUrl;
        }
        var line_items = [];
        var item = {};
        for(var i in $scope.orders) {
            item = {};
            if(typeof $scope.orders[i].parent_id != "undefined" && $scope.orders[i].parent_id > 0) {
                item.p = $scope.orders[i].id;
                item.v = {};
                for(var j in $scope.orders[i].selectedVariations) {
                    item.v[$scope.orders[i].selectedVariations[j].baseName] = $scope.orders[i].selectedVariations[j].name;
                }
            }
            else {
                item.p = $scope.orders[i].id;
            }
            item.q = $scope.orders[i].quantity;
            line_items.push(item);
        }
        var data = JSON.stringify(line_items);
        data = WooBase64.encode(data);
        $localstorage.removeNoExpired("wooCartProducts");
        $localstorage.removeNoExpired("wooCartCount");
        $scope.orders = [];
        $(".woocommerce-card-count i").html(0);
        var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
        if(is_app_call) {
            navigator.app.loadUrl(siteUrl+'/?appCardToSite='+data, {openExternal : true});
        }
        else {
            window.open(siteUrl+'/?appCardToSite='+data, '_system');
        }
    };

    $ionicModal.fromTemplateUrl('in-order.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function() {
        $scope.modal.show();
    };
    $scope.closeModal = function() {
        $scope.modal.hide();
    };
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
    });
    $scope.$on('modal.hidden', function() {
    });
    $scope.$on('modal.removed', function() {
    });


});
angular.module('ngApp').controller('WoocommerceCategoriesCtrl', function($scope, $ionicPopup, $state, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http){
    $scope.localUrl = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.ck = "";
    $scope.cs = "";
    $scope.layout = "";
    $scope.content_classes = "";
    $scope.categories = [];
    $scope.loadingText = "در حال دریافت اطلاعات";
    $scope.network = false;
    $scope.wooCurrentNetworkSiteUrl = "";
    $scope.wooCurrentNetworkSiteName = "";
    $scope.wooCurrentNetworkSiteId = 0;

    $scope.doSearch = function() {
        $scope.searchQuery = "";
        var searchPopup = $ionicPopup.show({
            template: '<ion-md-input><input type="text" id="searchQuery" ng-model="searchQuery" required><span class="md-highlight"></span><span class="md-bar"></span><label>کلمه مورد نظر خود را بنویسید</label></ion-md-input>',
            title: 'جستجو',
            subTitle: '',
            scope: $scope,
            buttons: [
                {
                    text: 'بازگشت',
                    onTap: function(e) {
                        return 'searchQueryCanceled';
                    }
                },
                {
                    text: '<b>جستجو</b>',
                    type: 'button-positive',
                    onTap: function(e) {
                        $scope.searchQuery = jQuery("#searchQuery").val();
                        return $scope.searchQuery;
                    }
                }
            ]
        });
        searchPopup.then(function(res) {
            if(typeof res != "undefined" && res != '' && res != 'searchQueryCanceled') {
                res = res.replace(/ك/g, 'ک').replace(/ي/g, 'ی').replace(/ي/g, 'ی');
                var arg2 = JSON.stringify({"filter[q]": res});
                /*$state.go('nav.woocommerce', {arg1: 'null', arg2: arg2, needed: $scope.needed, ck: $scope.ck, cs: $scope.cs, view: 'search', extra: "{'name':'جستجو', 'content_classes':'"+$scope.content_classes+"', 'layout':'"+$scope.layout+"'}"});*/

                var link = {
                    'layout': $scope.layout,
                    'content_classes': $scope.content_classes,
                    'searchQuery': res,
                    'name': "جستجو"
                };
                var appLink = WooBase64.encode(JSON.stringify(link));
                $state.go('nav.woocommerce-v2', {
                    'view': 'search',
                    'extra': appLink
                });
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        });

    };

    $scope.load_categories = function() {
        $ionicLoading.show({
            noBackdrop: true
        });

        if($scope.network) {
            wooNetwork = $scope.network;
            wooCurrentNetworkSiteUrl = $scope.wooCurrentNetworkSiteUrl;
            wooCurrentNetworkSiteName = $scope.wooCurrentNetworkSiteName;
            wooCurrentNetworkSiteId = $scope.wooCurrentNetworkSiteId;
        }
        else {
            $scope.ck = $localstorage.getNoExpired("wooCk");
            $scope.cs = $localstorage.getNoExpired("wooCs");
            $scope.localCk = $localstorage.getNoExpired("wooLocalCk");
            $scope.localCs = $localstorage.getNoExpired("wooLocalCs");
        }


        if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
            WoocommerceAPI = null;
            $scope.localUrl = wooCurrentNetworkSiteUrl;
        }

        if(WoocommerceAPI != null) {
            WoocommerceAPI.get('products/categories', function(err, data, res) {
                if(!err) {
                    $scope.show_categories(res);
                }
                else {
                    $scope.loadingText = "خطا در برقراری ارتباط";
                }
                $ionicLoading.hide();
            });
        }
        else {
            WoocommerceAPI = new WooCommerceAPI.WooCommerceAPI({
                url: $scope.localUrl,
                consumerKey: $scope.localCk,
                consumerSecret: $scope.localCs,
                verifySsl: true,
                queryStringAuth: true
            });
            WoocommerceAPI.get('products/categories', function(err, data, res) {
                if(!err) {
                    $scope.show_categories(res);
                }
                else {
                    $scope.loadingText = "خطا در برقراری ارتباط";
                }
                $ionicLoading.hide();
            });
        }
    };
    $scope.show_categories = function(res) {
        var result = JSON.parse(res);
        var link = {
            'layout': $scope.layout,
            'content_classes': $scope.content_classes
        };

        if(typeof result.product_categories != "undefined" && result.product_categories.length > 0) {
            for(var i in result.product_categories) {
                if(result.product_categories[i].parent == 0) {
                    link.id = result.product_categories[i].id.toString();
                    link.slug = result.product_categories[i].slug.toString();
                    link.name = result.product_categories[i].name.toString();
                    if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
                        link.sid = wooCurrentNetworkSiteId.toString();
                        if(link.sid == "0" && $scope.network) {
                            link.sid = $scope.wooCurrentNetworkSiteId.toString();
                        }
                    }
                    result.product_categories[i].applink = WooBase64.encode(JSON.stringify(link));
                    $scope.categories.push(result.product_categories[i]);
                }
            }
            if($scope.categories.length <= 0) {
                $scope.loadingText = "دسته ای یافت نشد";
            }
        }
        else {
            $scope.loadingText = "دسته ای یافت نشد";
        }

    };

});
angular.module('ngApp').controller('WoocommerceNetworkCtrl', function($scope, $ionicPopup, $state, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http){
    $scope.localUrl = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.ck = "";
    $scope.cs = "";
    $scope.layout = "";
    $scope.content_classes = "";
    $scope.theme = "";
    $scope.sites = [];
    $scope.sites_id = [];
    $scope.loadingText = "در حال دریافت اطلاعات";

    $scope.load_sites = function() {
        $ionicLoading.show({
            noBackdrop: true
        });

        $http.get($scope.localUrl+"/?appeto_api=woocommerce&check_api=network").then(function(resp) {
            $scope.sites = resp.data;
            $ionicLoading.hide();
            if($scope.sites.length > 0) {
                wooNetwork = true;
            }
            for(var i in $scope.sites) {
                $scope.sites_id.push($scope.sites[i]["id"]);
            }
        }, function(err) {
            $ionicLoading.hide();
        });
    };

    $scope.switchSite = function(view, extra, id, siteurl, name) {
        var orders = $localstorage.getObjectNoExpired("wooCartProducts");
        if(JSON.stringify(orders) === '{}') {
            $state.go('nav.woocommerce-v2', {
                'view': view,
                'extra': extra
            });
        }
        else {
            var go = true;
            for(var i in orders) {
                if(orders[i]["network"] != id) {
                    go = false;
                }
            }
            if(go) {
                $state.go('nav.woocommerce-v2', {
                    'view': view,
                    'extra': extra
                });
            }
            else {
                var removePopup = $ionicPopup.show({
                    template: 'سبد خرید شما خالی نیست برای تغییر فروشگاه ابتدا خرید خود را از فروشگاه قبلی انجام دهید یا سبد خرید خود را خالی کنید.',
                    title: 'توجه',
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'پاک کردن سبد',
                            onTap: function(e) {
                                return 'no';
                            }
                        },
                        {
                            text: 'رفتن به سبد',
                            type: 'button-positive',
                            onTap: function(e) {
                                return 'yes';
                            }
                        }
                    ]
                });
                removePopup.then(function(res) {
                    if(typeof res != "undefined" && res != '' && res == 'yes') {
                        $state.go('nav.woocommerce-cart-v2');
                    }
                    else {
                        $localstorage.removeNoExpired("wooCartProducts");
                        $localstorage.removeNoExpired("wooCartCount");
                        $(".woocommerce-card-count i").html(0);
                        $state.go('nav.woocommerce-v2', {
                            'view': view,
                            'extra': extra
                        });
                    }
                });
            }
        }
    };

    $scope.doSearch = function() {
        var extra = {
            sites: $scope.sites_id,
            localUrl: $scope.localUrl,
            localCk: $scope.localCk,
            localCs: $scope.localCs,
            theme: $scope.theme
        };
        extra = WooBase64.encode(JSON.stringify(extra));
        $state.go('nav.woocommerce-v2', {
            'view': 'network-search',
            'extra': extra
        });
    };

});
angular.module('ngApp').controller('WoocommerceNetworkSearchCtrl', function($scope, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http, $ionicPopup, $state){
    $scope.searchQuery = "";
    $scope.products = [];
    $scope.showNotFound = false;
    $scope.baseShowUrl = "";
    $scope.ck = "";
    $scope.cs = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.pushCards = [];
    $scope.cardsKey = 0;
    $scope.currency_symbol = "ريال";
    $scope.q = "";
    $scope.localUrl = "";
    $scope.busy = false;
    $scope.page = 1;
    $scope.per_page = 0;
    $scope.sites_id = "";
    $scope.showType = "p";
    $scope.sites_info = [];
    $scope.sites = [];

    $scope.$watch('localUrl', function () {
        WoocommerceAPI = null;
        WoocommerceAPI = new WooCommerceAPI.WooCommerceAPI({
            url: $scope.localUrl,
            consumerKey: $scope.localCk,
            consumerSecret: $scope.localCs,
            verifySsl: true,
            queryStringAuth: true
        });
    });

    $scope.WooGetProducts = function(){
        if($scope.q == "") return false;
        if(!$scope.busy) {
            $ionicLoading.show();
            $scope.busy = true;
            $scope.q = $scope.q.replace(/ك/g, 'ک').replace(/ي/g, 'ی').replace(/ي/g, 'ی');
            var _link = $scope.localUrl + "/?appeto_api=woocommerce&check_api=networkSearch&s="+$scope.q;
            $http.get(_link).then(function(resp) {
                if(resp.data == null) {
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.busy = false;
                    var success = function (message) {

                    };
                    var failure = function () {
                        alert("عدم دسترسی به اینترنت");
                    };
                    window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
                    $scope.showNotFound = true;
                }
                else {
                    var r = resp.data;
                    $scope.sites_info = resp.data;
                    var counter = 1;
                    var link = {
                        'layout': $scope.layout,
                        'content_classes': $scope.content_classes
                    };
                    var result;
                    for(var j in r) {
                        result = r[j]["result"];
                        if(counter != 2) {
                            counter = 1;
                        }
                        for (var i in result) {
                            if(counter <= 2) {
                                if(counter == 1) {
                                    $scope.pushCards[$scope.cardsKey] = {
                                        "products": []
                                    };
                                }
                                link.id = result[i].id.toString();
                                link.name = result[i].title;
                                link.network = result[i].site.toString();
                                result[i].appLink = WooBase64.encode(JSON.stringify(link));
                                result[i].siteImage = r[j]["info"].image;
                                $scope.pushCards[$scope.cardsKey].products.push(result[i]);
                            }
                            counter++;
                            if(counter > 2) {
                                counter = 1;
                                $scope.cardsKey++;
                            }
                        }

                        $scope.sites.push(r[j]["info"]);
                    }
                    $scope.products = $scope.pushCards;
                    if($scope.currency_symbol == "") {
                        $scope.currency_symbol = "ريال";
                    }
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.busy = false;
                }
            }, function(err) {
                $ionicLoading.hide();
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.busy = false;
                var success = function (message) {

                };
                var failure = function () {
                    alert("عدم دسترسی به اینترنت");
                };
                window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
                $scope.showNotFound = true;
            });
        }
    };


    $scope.wooInnerSearch = function() {
        if($scope.searchQuery != "") {
            $scope.products = [];
            $scope.sites = [];
            $scope.showNotFound = false;
            $scope.pushCards = [];
            $scope.cardsKey = 0;
            $scope.q = $scope.searchQuery;
            $scope.busy = false;
            $scope.page = 1;
            $scope.per_page = 0;
            $scope.WooGetProducts();
        }
    };

    $scope.switchSite = function(view, extra, id, siteurl, name) {
        var orders = $localstorage.getObjectNoExpired("wooCartProducts");
        if(JSON.stringify(orders) === '{}') {
            $state.go('nav.woocommerce-v2', {
                'view': view,
                'extra': extra
            });
        }
        else {
            var go = true;
            for(var i in orders) {
                if(orders[i]["network"] != id) {
                    go = false;
                }
            }
            if(go) {
                $state.go('nav.woocommerce-v2', {
                    'view': view,
                    'extra': extra
                });
            }
            else {
                var removePopup = $ionicPopup.show({
                    template: 'سبد خرید شما خالی نیست برای تغییر فروشگاه ابتدا خرید خود را از فروشگاه قبلی انجام دهید یا سبد خرید خود را خالی کنید.',
                    title: 'توجه',
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'پاک کردن سبد',
                            onTap: function(e) {
                                return 'no';
                            }
                        },
                        {
                            text: 'رفتن به سبد',
                            type: 'button-positive',
                            onTap: function(e) {
                                return 'yes';
                            }
                        }
                    ]
                });
                removePopup.then(function(res) {
                    if(typeof res != "undefined" && res != '' && res == 'yes') {
                        $state.go('nav.woocommerce-cart-v2');
                    }
                    else {
                        $localstorage.removeNoExpired("wooCartProducts");
                        $localstorage.removeNoExpired("wooCartCount");
                        $(".woocommerce-card-count i").html(0);
                        $state.go('nav.woocommerce-v2', {
                            'view': view,
                            'extra': extra
                        });
                    }
                });
            }
        }
    };

    $scope.setProductSite = function(sid, extra) {
        var view = "product";
        var id = Number(sid);
        wooNetwork = true;
        wooCurrentNetworkSiteUrl = $scope.sites_info[sid]["info"]["siteurl"];
        wooCurrentNetworkSiteName = $scope.sites_info[sid]["info"]["name"];
        wooCurrentNetworkSiteId = id;
        var orders = $localstorage.getObjectNoExpired("wooCartProducts");
        if(JSON.stringify(orders) === '{}') {
            $state.go('nav.woocommerce-v2', {
                'view': view,
                'extra': extra
            });
        }
        else {
            var go = true;
            for(var i in orders) {
                if(orders[i]["network"] != id) {
                    go = false;
                }
            }
            if(go) {
                $state.go('nav.woocommerce-v2', {
                    'view': view,
                    'extra': extra
                });
            }
            else {
                var removePopup = $ionicPopup.show({
                    template: 'سبد خرید شما خالی نیست برای تغییر فروشگاه ابتدا خرید خود را از فروشگاه قبلی انجام دهید یا سبد خرید خود را خالی کنید.',
                    title: 'توجه',
                    subTitle: '',
                    scope: $scope,
                    buttons: [
                        {
                            text: 'پاک کردن سبد',
                            onTap: function(e) {
                                return 'no';
                            }
                        },
                        {
                            text: 'رفتن به سبد',
                            type: 'button-positive',
                            onTap: function(e) {
                                return 'yes';
                            }
                        }
                    ]
                });
                removePopup.then(function(res) {
                    if(typeof res != "undefined" && res != '' && res == 'yes') {
                        $state.go('nav.woocommerce-cart-v2');
                    }
                    else {
                        $localstorage.removeNoExpired("wooCartProducts");
                        $localstorage.removeNoExpired("wooCartCount");
                        $(".woocommerce-card-count i").html(0);
                        $state.go('nav.woocommerce-v2', {
                            'view': view,
                            'extra': extra
                        });
                    }
                });
            }
        }
    };

});
angular.module('ngApp').controller('WoocommerceProductCtrl', function($scope, $rootScope, $localstorage, $ionicModal, $timeout, $ionicLoading, $http, $ionicSlideBoxDelegate, $state, $ionicPopup){
    $scope.productRate = 5;
    $scope.quantity = 1;
    $scope.productId = 0;
    $scope.createdCommentsStars = new Array();
    $scope.localUrl = "";
    $scope.localCk = "";
    $scope.localCs = "";
    $scope.currency_symbol = "ريال";
    $scope.product = {};
    $scope.comments = [];
    $scope.attributes = [];
    $scope.variations = [];
    $scope.terms = [];
    $scope.term = [];
    $scope.product_attribute_terms = [];
    $scope.disableToCard = false;
    $scope.variationsLoading = false;
    $scope.haveComments = true;
    $scope.fromNetwork = false;
    $scope.commentsLoading = 'در حال دریافت دیدگاه ها';
    $scope.selectedVariations = "";

    $scope.$watch('productId', function () {

        if(!$scope.fromNetwork) {
            $scope.ck = $localstorage.getNoExpired("wooCk");
            $scope.cs = $localstorage.getNoExpired("wooCs");
            $scope.localCk = $localstorage.getNoExpired("wooLocalCk");
            $scope.localCs = $localstorage.getNoExpired("wooLocalCs");
        }

        if(wooNetwork && wooCurrentNetworkSiteUrl != "") {
            WoocommerceAPI = null;
            $scope.localUrl = wooCurrentNetworkSiteUrl;
        }

        if(WoocommerceAPI == null) {
            WoocommerceAPI = new WooCommerceAPI.WooCommerceAPI({
                url: $scope.localUrl,
                consumerKey: $scope.localCk,
                consumerSecret: $scope.localCs,
                verifySsl: true,
                queryStringAuth: true
            });
        }
        $ionicLoading.show();
        $scope.setProductInfo();
    });

    $scope.$watch('productRate', function () {
        $scope.ratingsObjectDisable = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(34, 34, 34)',
            iconOffColor:  'rgb(34, 34, 34)',
            rating:  $scope.productRate,
            minRating:1,
            readOnly: true,
            callback: function(rating) {
            }
        };
    });
    $scope.$watch('quantity', function () {
        if($scope.quantity <= 0) {
            $scope.quantity = 1;
        }
    });

    $scope.ratingsObjectDisable = {
        iconOn: 'ion-ios-star',
        iconOff: 'ion-ios-star-outline',
        iconOnColor: 'rgb(34, 34, 34)',
        iconOffColor:  'rgb(34, 34, 34)',
        rating:  $scope.productRate,
        minRating:1,
        readOnly: true,
        callback: function(rating) {
        }
    };

    $scope.setProductInfo = function() {
        WoocommerceAPI.get('products/'+$scope.productId, function(err, data, res) {
            if(!err) {
                res = JSON.parse(res);
                if(typeof res.product != 'undefined') {
                    res.product.description = $scope.wpStripScripts(res.product.description);
                    $scope.product = res.product;
                    $scope.product.title = $scope.product.title.replace(/'/g, "");
                    if($scope.product.variations.length > 0) {
                        $scope.variations = $scope.product.variations;
                        $scope.disableToCard = true;
                        $scope.variationsLoading = true;
                        WoocommerceAPI.get('products/attributes', function(err, data, result) {
                            result = JSON.parse(result);
                            $scope.variationsLoading = false;
                            if(typeof result.product_attributes != "undefined") {
                                $scope.terms = result.product_attributes;
                                for(var i in $scope.product.attributes) {
                                    for(var j in $scope.terms) {
                                        if($scope.terms[j].slug == "pa_"+$scope.product.attributes[i].slug ) {
                                            $scope.product.attributes[i].id = $scope.terms[j].id;
                                        }
                                    }
                                }
                                if($scope.product.attributes.length > 0) {
                                    $scope.$apply(function(){
                                        $scope.attributes = $scope.product.attributes;
                                        $timeout(function(){
                                            $(".variation_selector").change(function(){
                                                var variationId = Number($(this).attr('data-attr-id'));
                                                var variationName = $(this).val();
                                                var variationBaseName = $(this).attr('data-attr-name');
                                                var variationBaseSlug = $(this).attr('data-attr-slug');
                                                if(variationName == "") {
                                                    if(typeof $scope.term[variationId] != "undefined") {
                                                        delete $scope.term[variationId];
                                                    }
                                                    $scope.$apply(function(){
                                                        $scope.term = $scope.term;
                                                    });
                                                    return;
                                                }
                                                if(typeof $scope.product_attribute_terms[variationId] == "undefined") {
                                                    $scope.$apply(function(){
                                                        $scope.variationsLoading = true;
                                                    });
                                                    WoocommerceAPI.get('products/attributes/'+variationId+'/terms', function(err, data, res) {
                                                        $scope.variationsLoading = false;
                                                        res = JSON.parse(res);
                                                        if(typeof res.product_attribute_terms != "undefined") {
                                                            var product_attribute_terms = res.product_attribute_terms;
                                                            $scope.product_attribute_terms[variationId] = product_attribute_terms;
                                                            for(var pk in product_attribute_terms) {
                                                                if(product_attribute_terms[pk].name == variationName) {
                                                                    $scope.term[variationId] = {
                                                                        "name": variationName,
                                                                        "slug": product_attribute_terms[pk].slug,
                                                                        "id": product_attribute_terms[pk].id,
                                                                        "baseName": variationBaseName,
                                                                        "baseSlug": variationBaseSlug
                                                                    };
                                                                }
                                                            }
                                                            $scope.$apply(function(){
                                                                $scope.term = $scope.term;
                                                                if(Object.keys($scope.term).length >= $scope.attributes.length) {
                                                                    $scope.checkVariableProduct();
                                                                }
                                                            });
                                                        }
                                                    });
                                                }
                                                else {
                                                    var product_attribute_terms = $scope.product_attribute_terms[variationId];
                                                    for(var pk in product_attribute_terms) {
                                                        if(product_attribute_terms[pk].name == variationName) {
                                                            $scope.term[variationId] = {
                                                                "name": variationName,
                                                                "slug": product_attribute_terms[pk].slug,
                                                                "id": product_attribute_terms[pk].id,
                                                                "baseName": variationBaseName,
                                                                "baseSlug": variationBaseSlug
                                                            };
                                                        }
                                                    }
                                                    $scope.$apply(function(){
                                                        $scope.term = $scope.term;
                                                        if(Object.keys($scope.term).length >= $scope.attributes.length) {
                                                            $scope.checkVariableProduct();
                                                        }
                                                    });
                                                }
                                            });
                                        }, 300)
                                    });
                                }
                            }

                        });
                    }
                    else {
                        if($scope.product.attributes.length > 0) {
                            $scope.attributes = $scope.product.attributes;
                        }
                    }
                }
                WoocommerceAPI.get('products/'+$scope.productId+'/reviews', function(err, data, res) {
                    if(!err) {
                        res = JSON.parse(res);
                        if(typeof res.product_reviews != 'undefined') {
                            $scope.comments = res.product_reviews;
                        }
                    }
                    $scope.commentsLoading = 'دیدگاه ها';
                    if($scope.comments.length <= 0) {
                        $scope.$apply(function(){
                            $scope.haveComments = false;
                        });
                    }

                });
            }
            $ionicLoading.hide();
        });
    };


    $scope.wpStripScripts = function(s) {
        var div = document.createElement('div');
        div.innerHTML = s;
        var scripts = div.getElementsByTagName('script');
        var i = scripts.length;
        while (i--) {
            scripts[i].parentNode.removeChild(scripts[i]);
        }
        var images = div.getElementsByTagName('img');
        var i = images.length;
        var lazy_src = "";
        while (i--) {
            if(images[i].hasAttribute('data-lazy-src')) {
                lazy_src = images[i].getAttribute('data-lazy-src');
                images[i].setAttribute('src', lazy_src);
            }
            images[i].removeAttribute('width');
            images[i].removeAttribute('height');
            images[i].setAttribute('class', 'img-responsive');
        }

        var audios = div.getElementsByTagName('audio');
        var i = audios.length;

        while (i--) {
            audios[i].autoplay = false;
            audios[i].load();
            audios[i].style.visibility = "visible";
            audios[i].style.width = "100%";
        }


        var iframes = div.getElementsByTagName('iframe');
        var i = iframes.length;
        while (i--) {
            iframes[i].style.width = "100%";
            iframes[i].style.height = "360px";
        }

        var videos = div.getElementsByTagName('video');
        var i = videos.length;
        while (i--) {
            videos[i].style.width = "100%";
            videos[i].style.height = "360px";
        }

        var a = div.getElementsByTagName('a');
        var i = a.length;
        while (i--) {
            if(a[i].hasAttribute('target')) {
                a[i].removeAttribute('target');
            }
            a[i].setAttribute('target', '_blank');
        }

        return div.innerHTML;
    };

    $scope.checkVariableProduct = function() {
        var termLength = Object.keys($scope.term).length;
        var checkCounter = 0;
        var selectedVariations = "";
        for(var i in $scope.variations) {
            checkCounter = 0;
            for(var j in $scope.variations[i].attributes) {
                for(var k in $scope.term) {
                    if($scope.term[k].slug == $scope.variations[i].attributes[j].option) {
                        checkCounter++;
                        if(checkCounter == termLength) {
                            selectedVariations = $scope.variations[i];
                        }
                    }
                }
            }
        }
        if(selectedVariations != "") {
            $scope.productId = selectedVariations.id;
            var link = {
                'layout': $scope.layout,
                'content_classes': $scope.content_classes,
                'variations': $scope.term
            };
            link.id = $scope.productId.toString();
            link.name = $scope.product.title;
            var appLink = WooBase64.encode(JSON.stringify(link));
            $state.go('nav.woocommerce-v2', {
                'view': 'product',
                'extra': appLink
            });
        }
        else {
            $ionicPopup.show({
                template: 'متاسفانه محصولی با این ویژگی موجود نیست',
                title: 'خطا',
                subTitle: '',
                scope: $scope,
                buttons: [
                    {
                        text: 'باشه',
                        type: 'button-positive',
                        onTap: function(e) {
                            return 'yes';
                        }
                    }
                ]
            });
        }
    };

    $scope.setPageChanges = function() {
        $timeout(function() {
            var products = $localstorage.getObjectNoExpired("wooCartProducts");
            var id = $scope.productId;
            if($scope.inObject(products, id)) {
                $("#wooAddToCard"+id).removeClass("button-royal");
                $("#wooAddToCard"+id).addClass("button-calm");
                $("#wooAddToCard"+id).html("مشاهده سبد خرید");
                $scope.quantity = products[id].quantity;
            }
        }, 500);
    };

    $scope.quantityNegativePlusCall = false;

    $scope.quantityNegativePlus = function(id, method) {
        var count = Number($("#quantity"+id).val());
        if(method == "-") {
            count--;
            if(count <= 0) {
                count = 1;
            }
        }
        else {
            count++;
        }
        if($scope.product.stock_quantity != null && $scope.product.stock_quantity > 0) {
            if(count > $scope.product.stock_quantity) {
                alert("در حال حاضر این تعداد در انبار موجود نیست.");
                return false;
            }
        }
        $scope.quantityNegativePlusCall = true;
        $("#quantity"+id).val(count);
        $scope.quantity = count;
        $scope.setQuantity();
    };

    $scope.setQuantity = function() {
        var products = $localstorage.getObjectNoExpired("wooCartProducts");
        var id = $scope.productId;

        if(!$scope.quantityNegativePlusCall) {
            $scope.quantity = Number($("#quantity"+id).val());
        }
        else {
            $scope.quantityNegativePlusCall = false;
        }

        if($scope.inObject(products, id)) {
            var product = products[id];
            if(product.quantity == $scope.quantity) {
                return true;
            }

            if(product.quantity < $scope.quantity) {
                $scope.addToTopMenu(1);
            }
            else {
                if(product.quantity > 1) {
                    $scope.removeFromTopMenu(1);
                }
            }
            product.quantity = $scope.quantity;
            if(product.quantity <= 0) {
                product.quantity = 1;
            }
            products[id] = product;
            $localstorage.setObjectNoExpired("wooCartProducts", products);
        }
    };

    $scope.commentRateObj = function(rate, id){
        for(var i in $scope.createdCommentsStars) {
            if(i == id) {
                return $scope.createdCommentsStars[id];
            }
        }
        var obj = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(34, 34, 34)',
            iconOffColor:  'rgb(34, 34, 34)',
            rating:  rate,
            minRating:1,
            readOnly: true
        };
        $scope.createdCommentsStars[id] = obj;
        return obj;
    };

    $scope.addToCard = function(id, title, price, regular_price, thumb) {
        var products = $localstorage.getObjectNoExpired("wooCartProducts");
        var is_ordered = $scope.inObject(products, id);
        if(typeof $("#selectedVariations") != "undefined" && $("#selectedVariations").length > 0 && $("#selectedVariations").val() != "") {
            $scope.selectedVariations = JSON.parse($("#selectedVariations").val());
        }
        if(!is_ordered) {
            if(wooNetwork && wooCurrentNetworkSiteUrl != "" && wooCurrentNetworkSiteName != "") {
                title += ' - <small style="font-size: 10px;">'+wooCurrentNetworkSiteName+'</small>';
                if(wooCurrentNetworkSiteId > 0) {
                    var network_error = $scope.inObjectNetwork(products, wooCurrentNetworkSiteId);
                    if(network_error) {
                        var removePopup = $ionicPopup.show({
                            template: 'در هر بار خرید فقط میتوانید از یک فروشگاه خرید کنید، لطفا سبد خرید خود را تکمیل کنید یا پاک کنید سپس از فروشگاه دیگر خرید انجام دهید',
                            title: 'خطا',
                            subTitle: '',
                            scope: $scope,
                            buttons: [
                                {
                                    text: 'متوجه شدم'
                                }
                            ]
                        });
                        return false;
                    }
                }
            }
            var product = {"id": Number(id), "selectedVariations": $scope.selectedVariations, "parent_id":Number($scope.product.parent_id), "title": title, "price": price, "regular_price": regular_price, "thumb": thumb, "quantity": $scope.quantity, "network": wooCurrentNetworkSiteId};
            products[id] = product;
            $localstorage.setObjectNoExpired("wooCartProducts", products);
            $scope.addToTopMenu($scope.quantity);
            $("#wooAddToCard"+id).removeClass("button-royal");
            $("#wooAddToCard"+id).addClass("button-calm");
            $("#wooAddToCard"+id).html("مشاهده سبد خرید");
        }
        else {
            /*$state.go('nav.woocommerce-cart');*/
            /*var link = {
                'layout': $scope.layout,
                'content_classes': $scope.content_classes
            };
            var extra = WooBase64.encode(JSON.stringify(link));
            $state.go('nav.woocommerce-v2', {
             'view': 'cart',
             'extra': extra
             });*/
            $state.go('nav.woocommerce-cart-v2');

        }
    };

    $scope.inObject = function(obj, val) {
        for(var i in obj) {
            if(i == val) {
                return true;
            }
        }
        return false;
    };

    $scope.inObjectNetwork = function(obj, val) {
        for(var i in obj) {
            if(typeof obj[i]["network"] != "undefined") {
                if(obj[i]["network"] != val) {
                    return true;
                }
            }
        }
        return false;
    };

    $scope.addToTopMenu = function(count) {
        var cardCount = Number($localstorage.getNoExpired("wooCartCount"));
        cardCount += count;
        $localstorage.setNoExpired("wooCartCount", cardCount);
    };
    $scope.removeFromTopMenu = function(count) {
        var cardCount = Number($localstorage.getNoExpired("wooCartCount"));
        cardCount -= count;
        if(cardCount < 0) {
            cardCount = 0;
        }
        $localstorage.setNoExpired("wooCartCount", cardCount);
    };

});

function doSearchBtnWoo() {
    var $scope = angular.element('[ng-controller=WoocommerceCtrl]').scope();
    $scope.doSearch();
}

function wooValidateEmail(email) {
    var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
    return re.test(email);
}

var WooBase64 = {

    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = WooBase64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
            this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
            this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }
        return this._beautiful_url(output);
    },

    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = WooBase64._utf8_decode(output);

        return output;

    },

    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    },

    _beautiful_url: function(txt) {
        txt = txt.replace(/[/]/g, "::");
        txt = txt.replace(/[+]/g, "^");
        return txt;
    }

};