angular.module('ngApp').controller('AparatCtrl', function($scope, $ionicModal, $timeout, $ionicLoading, $http, $ionicScrollDelegate, $sce)
{
    $scope.username = "";
    $scope.sl = "";
    $scope.column = "oneColumn";
    $scope.type = "username";
    $scope.pushCards = [];
    $scope.cardsKey = 0;
    $scope.videos = [];
    $scope.nextLink = "";
    $scope.busy = true;
    $scope.aparatAutoplay = "true";
    $scope.isRefresh = false;
    $scope.clickRefresh = false;

    $scope.$watch('sl', function () {
        $scope.showVideos();
    });

    $scope.trustSrc = function(src) {
        return $sce.trustAsResourceUrl(src);
    };

    $scope.doRefresh = function() {
        $scope.pushCards = [];
        $scope.cardsKey = 0;
        $scope.videos = [];
        $scope.nextLink = "";
        $scope.isRefresh = true;
        if($scope.clickRefresh) {
            $scope.isRefresh = false;
        }
        $scope.showVideos();
    };

    $scope.showVideos = function()
    {
        $scope.busy = true;
        if(!$scope.isRefresh) {
            $ionicLoading.show({
                noBackdrop: true
            });
        }
        $scope.isRefresh = false;
        if( $scope.type == 'username' || $scope.type == 'category' )
            $scope.showUsername();
        else
            $scope.showIFrame();
    };

    $scope.showUsername = function()
    {
        $.get(url+"/api/v1/widget/get/aparat/getInfoForMobile",{sl: $scope.sl, nextLink: $scope.nextLink},function(d)
        {
            if(d == "" || d == 0)
            {
                $("#show_errors").html('<h3 style="text-align: center">اطلاعاتی یافت نشد </h3>');
            }
            else
            {
                $("#show_errors").html('');
                var json = JSON.parse(d);
                var videoInfo = '';
                if( $scope.type == 'username' )
                    videoInfo = json['videobyuser'];//Username
                else
                    videoInfo = json['videobyprofilecat'];//Category

                var ui = json['ui'];
                $scope.nextLink = ui['pagingForward'];
                if( videoInfo[0]['frame'] != '' && videoInfo.length != 0 )
                    $("#topVideo").attr('src', videoInfo[0]['frame']);

                if( $scope.column == 2 )
                {
                    var counter = 1;
                    for(var i in videoInfo)
                    {
                        if(counter <= 2)
                        {
                            if(counter == 1)
                            {
                                $scope.pushCards[$scope.cardsKey] = {
                                    "videos": []
                                };
                            }
                            $scope.pushCards[$scope.cardsKey].videos.push(videoInfo[i]);
                        }
                        counter++;
                        if(counter > 2)
                        {
                            counter = 1;
                            $scope.cardsKey++;
                        }
                    }
                    $scope.videos = $scope.pushCards;
                }
                else
                {
                    for(var i in videoInfo)
                    {
                        $scope.pushCards[$scope.cardsKey] = videoInfo[i];
                        $scope.cardsKey++;
                    }
                    $scope.videos = $scope.pushCards;
                }

                $timeout(function(){
                    if($scope.nextLink != "")
                    {
                        $scope.busy = false;
                    }
                    $ionicLoading.hide();
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }, 1000);
            }
        }).error(function(){
            $scope.busy = true;
            $ionicLoading.hide();
        }).always(function(){

        });
    };

    $scope.showIFrame = function(){
        $scope.busy = true;
        $.get(url+"/api/v1/widget/get/aparat/getInfoForMobile",{sl: $scope.sl, nextLink: $scope.nextLink},function(d)
        {
            if(d == "" || d == 0)
            {
                $("#show_errors").html('<h3 style="text-align: center">اطلاعاتی یافت نشد </h3>');
            }
            else
            {
                $("#show_errors").html('');
                var videoInfo = JSON.parse(d);
                if( $scope.column == 2 )
                {
                    var counter = 1;
                    for(var i in videoInfo)
                    {
                        if(counter <= 2)
                        {
                            if(counter == 1)
                            {
                                $scope.pushCards[$scope.cardsKey] = {
                                    "videos": []
                                };
                            }
                            $scope.pushCards[$scope.cardsKey].videos.push(videoInfo[i]);
                        }
                        counter++;
                        if(counter > 2)
                        {
                            counter = 1;
                            $scope.cardsKey++;
                        }
                    }
                    $scope.videos = $scope.pushCards;
                }
                else
                {
                    $scope.videos = videoInfo;
                }
				
                $ionicLoading.hide();
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }
        }).error(function(){
            $("#show_errors").html('<h3 style="text-align: center">اطلاعاتی یافت نشد </h3>');
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
            $scope.$broadcast('scroll.infiniteScrollComplete');
        }).always(function(){

        });
    };

    $scope.showVideoFrame = function( src, title )
    {
        $scope.openModal();
        src = $scope.trustSrc(src);
        $scope.aparatFrame = src;
        $scope.aparatTitle = title;
        $scope.aparatAutoplay = "true";
        $('#aparatIframeModal').load(function() {
            document.getElementById('aparatIframeModal').contentWindow.changeFrameSrc();
        });
    };

    $scope.nextPage = function()
    {
        if($scope.busy || $scope.nextLink == null || $scope.nextLink == "")
        {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return false;
        }
        $scope.isRefresh = true;
        $scope.showVideos();
    };

    $ionicModal.fromTemplateUrl('aparatVideo.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });

    $scope.openModal = function() {
        $scope.modal.show();
    };

    $scope.closeModal = function() {
        $scope.modal.hide();
        $scope.aparatAutoplay = "false";
        $scope.aparatFrame = '';
        $('iframe').attr('src', '');
    };
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
        $scope.aparatAutoplay = "false";
        $scope.aparatFrame = '';
        $('iframe').attr('src', '');
    });
    $scope.$on('modal.hidden', function() {
        $scope.aparatAutoplay = "false";
        $scope.aparatFrame = '';
        $('iframe').attr('src', '');
    });
    $scope.$on('modal.removed', function() {
        $scope.aparatAutoplay = "false";
        $scope.aparatFrame = '';
        $('iframe').attr('src', '');
    });

    if(!checkNetConnection())
    {
        var success = function(message) {

        };
        var failure = function() {
            alert("عدم دسترسی به اینترنت");
        };
        
		if( typeof window.plugins != "undefined" ) {
            window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
        }
    }
});
