angular.module('ngApp').controller('internalMenuCtrl', function($scope, $timeout, $http, $ionicLoading, $ionicSlideBoxDelegate) {

    $scope.sliders = [];
    $scope.menu_slider_type = 0;
    $scope.sl = '';
    $scope.sliderOnlineShow = false;
    $scope.sliderOfflineShow = true;

    $scope.$watch('sl', function ()
    {
        $timeout(function ()
        {
            if( checkNetConnection() )
            {
                if( $scope.menu_slider_type == 1 )
                {
                    $scope.getOnlineSlider();
                }
            }
        }, 10);
    });

    $scope.getOnlineSlider = function()
    {
        $ionicLoading.show();
        var slider = [];
        $.ajax({
            type: 'POST',
            url: url + '/api/v1/widget/post/internal-menu/getOnlineSlider',
            data: {sl: $scope.sl},
            dataType: 'json',
            success: function (resp)
            {
                var lenS = resp.length;
                for( var s=0; s<lenS; ++s )
                {
                    if( $.trim(resp[s]['image']) )
                        slider.push(resp[s]);
                }

                if(slider.length > 0)
                {
                    $scope.sliders = slider;
                    $scope.sliderOnlineShow = true;
                    $scope.sliderOfflineShow = false;
                    $timeout(function ()
                    {
                        $ionicSlideBoxDelegate.update();
                    }, 10);
                }
            }
        }).always(function() {
            $ionicLoading.hide();
        }).fail(function() {
            var success = function(message) {

            };
            var failure = function() {
                $scope.sliderOnlineShow = false;
            };
        });
    };
});