angular.module('ngApp').controller('ShopCtrl', function($scope, $state, $timeout, $http, $ionicModal, $ionicActionSheet,
														$ionicPopover, $ionicLoading, $localstorage, $appetoToast) {
    $scope.oneCol = true;
    $scope.backSearch = true;
    $scope.products = [];
	$scope.searchProducts = [];
    $scope.sliders = [];
    $scope.page = 1;
    $scope.limit = 20;
    $scope.busy = true;
    $scope.noInfo = false;
    $scope.noInfoSearch = false;
    $scope.noImg = '';
	var arrayLength = 0;
	$scope.search = {
		input: ""
	};
	$scope.haveCategory = null;
	$scope.categories_show_type = 'self';
	$scope.special_active = 0;
	$scope.pushCards = [];
	$scope.categories = [];
	$scope.specials = [];
	$scope.cardsKey = 0;
	$scope.firstLoad = true;
	var allProducts = [];
    var userId = $localstorage.getNoExpired('loginUserId');
    var loginKey = $localstorage.getNoExpired('loginLoginKey');

	$ionicModal.fromTemplateUrl('my-modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.openModal = function() {
		$scope.modal.show();
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
	// Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.modal.remove();
	});
	// Execute action on hide modal
	$scope.$on('modal.hidden', function() {
		// Execute action
	});
	// Execute action on remove modal
	$scope.$on('modal.removed', function() {
		// Execute action
	});

	if(!checkNetConnection())
    {
        var success = function(message) {

        };
        var failure = function() {
            alert("عدم دسترسی به اینترنت");
        };
        if(typeof window.plugins != "undefined") {
        	window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
		}
    }
	
    $scope.$watch('sl', function(){
    	$scope.getProducts();
    });
   
    $scope.changeColumn = function() {
    	$scope.oneCol = !$scope.oneCol;
    };

    $scope.getProducts = function()
	{
		if($scope.firstLoad) {
			$ionicLoading.show({
				noBackdrop: true
			});
		}
    	var slider = [];
		// Load products
		$http.get(
			url + '/api/v1/widget/get/ecommerce-new/getAllProducts?sl=' + $scope.sl +"&page="+$scope.page+"&categories_show_type="+$scope.categories_show_type+"&special_active="+$scope.special_active
		).then(function(resp) {
			arrayLength = resp.data.data.length;
			/*allProducts.push.apply(allProducts, resp.data.data);*/
			allProducts = resp.data.data;
			var counter = 1;
			for(var i in allProducts)
			{
				if(counter <= 2)
				{
					if(counter == 1)
					{
						$scope.pushCards[$scope.cardsKey] = {
							"products": []
						};
					}
					$scope.pushCards[$scope.cardsKey].products.push(allProducts[i]);
				}
				counter++;
				if(counter > 2)
				{
					counter = 1;
					$scope.cardsKey++;
				}
			}
			$scope.products = $scope.pushCards;

			if( allProducts.length == 0 )
				$scope.noInfo = true;
			else
				$scope.noInfo = false;

			if( $scope.page == 1 )
			{
				$scope.haveCategory = resp.data.haveCategory;
				$scope.categories = resp.data.categories;
				if($scope.haveCategory && $scope.categories_show_type == 'self' && $scope.categories.length > 0) {
					$scope.noInfo = false;
				}
				$scope.noImg = resp.data.noImg;
				$scope.specials = resp.data.special;

				if( resp.data['shop_slider_type'] == 1 )/* new */
				{
					var lenS = resp.data['online_slider'].length;
					for( var s=0; s<lenS; ++s )
					{
						if( $.trim(resp.data['online_slider'][s]['image']) )
                            slider.push(resp.data['online_slider'][s]);
					}
				}
				else
				{
                    for( var i=0; i<arrayLength; ++i )
                    {
                        if( resp.data.data[i]['cover'] != '' )
                        {
                            if( slider.length < 4 )
                            {
                                var cover = {
                                    "cover": resp.data.data[i]['cover']
                                };
                                slider.push(cover);
                            }
                        }
                    }
				}

				if(slider.length > 0)
					$scope.setSlider(slider);

			}
			
			$timeout(function()
			{
				if($scope.limit > arrayLength) {
					$scope.page = 'end';
					$scope.busy = true;
				}
				else
					$scope.busy = false;

				$scope.$broadcast('scroll.infiniteScrollComplete');
				$scope.$broadcast('scroll.refreshComplete');
				$ionicLoading.hide();
			}, 500);
		
		}, function(err) {
			$scope.busy = true;
		});
    };
    
    $scope.setSlider = function(covers) {
    	$scope.sliders = covers;
	};
    
    $scope.moreDataCanBeLoaded = function() {
    	return !$scope.busy;
    };
    
    $scope.loadMoreData = function() {
		if($scope.busy || $scope.page == "end")
		{
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return false;
		}
    	$scope.page = $scope.page + 1;
		$scope.firstLoad = false;
    	$scope.getProducts();
    };
    
    $scope.doRefresh = function() {
    	$scope.page = 1;
    	$scope.products = [];
		$scope.pushCards = [];
		$scope.categories = [];
		$scope.specials = [];
		$scope.cardsKey = 0;
		allProducts = [];
		$scope.sliders = [];
    	$scope.busy = true;
		$scope.noInfo = false;
		$scope.search.input = '';
		$scope.backSearch = true;
		$scope.firstLoad = false;
    	$scope.getProducts();
    };

	$scope.shopSearch = function()
	{
		if( $scope.search.input != '' )
		{
			$scope.searchProducts = [];
			$http.get(
				url + '/api/v1/widget/get/ecommerce-new/searchInAllProducts?sl=' + $scope.sl +"&input="+$scope.search.input
			).then(function(resp) {
				$scope.searchProducts = resp.data;
				if( $scope.searchProducts.length == 0 )
					$scope.noInfoSearch = true;
				else
					$scope.noInfoSearch = false;

			}, function(err) {

			});
		}
	};
	
	$scope.modalSearchHide = function ()
	{
		$timeout(function () {
            $scope.closeModal();
        }, 1000);
    };

	$ionicPopover.fromTemplateUrl('popover.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.closePopover = function() {
		$scope.popover.hide();
	};

	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

	// Execute action on hide popover
	$scope.$on('popover.hidden', function() {
		// Execute action
	});

	// Execute action on remove popover
	$scope.$on('popover.removed', function() {
		// Execute action
	});

	$scope.goToCard = function()
	{
		if( $scope.shop_connect_to_login == 1 )
		{
            if( userId != '' && loginKey != '' )
			{
                $state.go('nav.e-commerce-card', {userId: userId, loginKey: loginKey});
			}
			else
			{
                if(typeof loginPageSlug != "undefined" && loginPageSlug != "")
                {
                    $appetoToast.make("برای تکمیل خرید ابتدا باید ثبت نام کنید", 2000);
                    $state.go('nav.'+loginPageSlug);
                }
                else
                {
                    alert("با توجه به این که افزونه فروشگاه ساز را به حساب کاربری متصل کرده اید حتما باید این افزونه در اپلیکیشن استفاده شده باشد");
                    return false;
                }
			}
		}
		else
		{
            $state.go('nav.e-commerce-card', {userId: 0, loginKey: ''});
		}
	};

	$scope.goToMyOrders = function ()
	{
		if( userId === '' || loginKey === '' )
		{
            $appetoToast.make("برای مشاهده خریدهای قبلی باید در اکانت خود لاگین باشید", 2000);
		}
		else
		{
            $state.go('nav.myOrders', {userId: userId, loginKey: loginKey});
		}
    }
});

ngApp.controller('myOrderCtrl', function ($scope, $ionicModal, $stateParams) {

	$scope.noInfo = false;
    $ionicModal.fromTemplateUrl('modal-order.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.openModal = function() {
        $scope.modal.show();
    };
    $scope.closeModal = function() {
        $scope.modal.hide();
    };
    // Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
    });
    // Execute action on hide modal
    $scope.$on('modal.hidden', function() {
        // Execute action
    });
    // Execute action on remove modal
    $scope.$on('modal.removed', function() {
        // Execute action
    });

    $scope.getAllOrdersOfUser = function ()
	{
        $.ajax({
            type: 'POST',
            url: url + '/api/v1/widget/post/ecommerce-new/getOrderOfUser',
            data: {
            	user_userId: $stateParams.userId,
                loginKey: $stateParams.loginKey,
                sl: $scope.sl
			},
            dataType: 'json',
            success: function(data)
            {
            	$scope.orders = data;
                if( data.length == 0 )
            		$scope.noInfo = true;
            }
        }).always(function() {

        }).fail(function() {
            var success = function(message) {

            };
            var failure = function() {
                alert("عدم دسترسی به اینترنت");
            };
        });
    };

    $scope.moreInfoOrder = function (index)
	{
		$scope.products = $scope.orders[index]['products']['items'];
        $scope.modal.show();
    };
});

ngApp.controller('shopCategoriesCtrl', function($scope, $stateParams, $state, $ionicHistory, $appetoToast, $localstorage){
	
	$scope.onCatColumn = true;
	$scope.catPage = 2;
	
	$scope.changeCatColumn = function() {
		
    	$scope.onCatColumn = !$scope.onCatColumn;
    };

	$scope.back = function() {
		$ionicHistory.goBack();
	};

	$scope.goToCard = function()
	{
        if( $scope.shop_connect_to_login == 1 )
        {
            var userId = $localstorage.getNoExpired('loginUserId');
            var loginKey = $localstorage.getNoExpired('loginLoginKey');

            if( userId != '' && loginKey != '' )
            {
                $state.go('nav.e-commerce-card', {userId: userId, loginKey: loginKey});
            }
            else
            {
                if(typeof loginPageSlug != "undefined" && loginPageSlug != "")
                {
                    $appetoToast.make("برای تکمیل خرید ابتدا باید ثبت نام کنید", 2000);
                    $state.go('nav.'+loginPageSlug);
                }
                else
                {
                    alert("با توجه به این که افزونه فروشگاه ساز را به حساب کاربری متصل کرده اید حتما باید این افزونه در اپلیکیشن استفاده شده باشد");
                    return false;
                }
            }
        }
        else
        {
            $state.go('nav.e-commerce-card', {userId: 0, loginKey: ''});
        }
	};
});

angular.module('ngApp').controller('categoryProductsCtrl', function($scope, $state, $timeout, $http, $ionicPopover, $ionicModal, $appetoToast, $localstorage) {

	$scope.oneCol = true;
	$scope.backSearch = true;
	$scope.categoryProducts = [];
	$scope.searchProducts = [];
	$scope.pushCards = [];
	$scope.cardsKey = 0;
	$scope.page = 2;
	$scope.limit = 20;
	$scope.busy = true;
	$scope.noInfoCat = false;
	$scope.noInfoSearch = false;
	var arrayLength = 0;
	$scope.search = {
		input: ""
	};
	var allProducts = [];
	$scope.$watch('sl', function(){
		$scope.getCategoryProducts();
	});

	$scope.changeColumn = function() {
		$scope.oneCol = !$scope.oneCol;
	};

	$scope.getCategoryProducts = function()
	{
		$http.get(
			url + '/api/v1/widget/get/ecommerce-new/getCategoryProducts?sl=' + $scope.sl +"&page="+$scope.page
		).then(function(resp)
		{
			arrayLength = resp.data.length;
			/*allProducts.push.apply(allProducts, resp.data);*/
			allProducts = resp.data;
			var counter = 1;
			for(var i in allProducts)
			{
				if(counter <= 2)
				{
					if(counter == 1)
					{
						$scope.pushCards[$scope.cardsKey] = {
							"products": []
						};
					}
					$scope.pushCards[$scope.cardsKey].products.push(allProducts[i]);
				}
				counter++;
				if(counter > 2)
				{
					counter = 1;
					$scope.cardsKey++;
				}
			}

			$scope.categoryProducts = $scope.pushCards;


			if( allProducts.length == 0 && $('#firstProducts').length <= 0)
				$scope.noInfoCat = true;
			else
				$scope.noInfoCat = false;

		},function(err) {
		});


		$timeout(function()
		{
			if($scope.limit > arrayLength) {
				$scope.page = 'end';
				$scope.busy = true;
			}
			else
			{
				$scope.busy = false;
			}

			$scope.$broadcast('scroll.infiniteScrollComplete');
			$scope.$broadcast('scroll.refreshComplete');
		}, 500);
	};

	$scope.search = function()
	{
		if( $scope.search.input != '' )
		{
			$http.get(
				url + '/api/v1/widget/get/ecommerce-new/searchInCategoryProducts?sl=' + $scope.sl +"&input=" + $scope.search.input
			).then(function(resp) {
				$scope.searchProducts = resp.data;
				if( resp.data.length == 0 )
					$scope.noInfoSearch = true;
				else
					$scope.noInfoSearch = false;

			}, function(err) {
			});
		}
	};

	$scope.moreDataCanBeLoaded = function() {
		return !$scope.busy;
	};

	$scope.loadMoreData = function() {
		if($scope.busy || $scope.page == "end")
		{
			$scope.$broadcast('scroll.infiniteScrollComplete');
			return false;
		}
		$scope.page++;
		$scope.getCategoryProducts();
	};

	$scope.doRefresh = function() {
		if( $('#firstProducts').length > 0 )
			$('#firstProducts').remove();

		$scope.page = 1;
		$scope.categoryProducts = [];
		$scope.pushCards = [];
		$scope.cardsKey = 0;
		allProducts = [];
		$scope.busy = true;
		$scope.noInfoCat = false;
		$scope.backSearch = true;
		$scope.getCategoryProducts();
	};

	$ionicModal.fromTemplateUrl('my-modal.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	});
	$scope.openModal = function() {
		$scope.modal.show();
	};
	$scope.closeModal = function() {
		$scope.modal.hide();
	};
	// Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.modal.remove();
	});
	// Execute action on hide modal
	$scope.$on('modal.hidden', function() {
		// Execute action
	});
	// Execute action on remove modal
	$scope.$on('modal.removed', function() {
		// Execute action
	});

	$ionicPopover.fromTemplateUrl('popover.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.closePopover = function() {
		$scope.popover.hide();
	};

	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

	// Execute action on hide popover
	$scope.$on('popover.hidden', function() {
		// Execute action
	});

	// Execute action on remove popover
	$scope.$on('popover.removed', function() {
		// Execute action
	});

	$scope.shareIt = function() {

	};
	$scope.bookmarkIt = function() {

	};

    $scope.goToCard = function()
    {
        if( $scope.shop_connect_to_login == 1 )
        {
            var userId = $localstorage.getNoExpired('loginUserId');
            var loginKey = $localstorage.getNoExpired('loginLoginKey');

            if( userId != '' && loginKey != '' )
            {
                $state.go('nav.e-commerce-card', {userId: userId, loginKey: loginKey});
            }
            else
            {
                if(typeof loginPageSlug != "undefined" && loginPageSlug != "")
                {
                    $appetoToast.make("برای تکمیل خرید ابتدا باید ثبت نام کنید", 2000);
                    $state.go('nav.'+loginPageSlug);
                }
                else
                {
                    alert("با توجه به این که افزونه فروشگاه ساز را به حساب کاربری متصل کرده اید حتما باید این افزونه در اپلیکیشن استفاده شده باشد");
                    return false;
                }
            }
        }
        else
        {
            $state.go('nav.e-commerce-card', {userId: 0, loginKey: ''});
        }
    };
});

var shop_current_property = '';
angular.module('ngApp').controller('productCtrl', function($scope, $rootScope, $timeout, $ionicActionSheet, $localstorage, $state,
														   $ionicPopup, $stateParams, $appetoToast)
{
	$scope.property = "";
	$scope.real_price = 0;
	$scope.productId = 0;
	$scope.propertyId = 0;
	$scope.max_buy = 0;
	$scope.discount_price = 0;
	$scope.addedToCard = false;
	$scope.quantity = 0;
	$scope.sl = '';
	$scope.sku = '';
	$scope.allProperty = [];
	$scope.propertyTitle = "";
	$scope.propertyValue = "";
	$scope.file_address = "";
	$scope.property = JSON.parse(shop_current_property);
	var card = {};

	$scope.init = function()
	{
		if( $scope.property != '' )
		{
			$scope.propertyTitle = $scope.property[0].property;
			$scope.propertyValue = $scope.property[0].property_value;
			$scope.number_buy = $scope.property[0].number_buy;
			$scope.real_price = $scope.property[0].real_price;
			$scope.discount_price = $scope.property[0].discount_price;
			$scope.max_buy = $scope.property[0].max_buy;
			$scope.productId = $scope.property[0].product_id;
			$scope.propertyId = $scope.property[0].id;
			$scope.sku = $scope.property[0].sku;

			if( $scope.property[0].max_buy > 0 )
				$scope.quantity = $scope.property[0].max_buy - $scope.number_buy;

            if( $scope.property[0].max_buy == -1 ) /*new update*/
                $scope.quantity = 0;
			var count = $scope.property.length;
			var p = '';
			for( var i=0; i<count; ++i )
			{
				p = { text: $scope.property[i].property_value };
				$scope.allProperty.push(p);
			}
		}
		else
		{
			if( $scope.max_buy > 0 )
				$scope.quantity = $scope.max_buy - $scope.number_buy;
			if( $scope.max_buy == -1 )/*new update*/
                $scope.quantity = 0;
		}

		var card = $localstorage.getObjectECommerce("shopCard_eCommerce");
		var cardId = $scope.productId+'_'+$scope.propertyId;
		var price = $scope.real_price;
		if( $scope.inCard( card, cardId ) )
		{
			$scope.addedToCard = true;
		}


		$timeout(function () {
            var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
            if(is_app_call) {
                $("a[target='_blank']").click(function(e){
                    e.preventDefault();
                    navigator.app.loadUrl($(this).attr('href'), {openExternal : true});
                    return false;
                });
            }
        }, 500);

	};

	$scope.show = function() {

		var hideSheet = $ionicActionSheet.show({
			buttons: $scope.allProperty,
			titleText: 'ویژگی های محصول',
			cancelText: 'انصراف',
			cancel: function() {
			},
			buttonClicked: function(index) {
				$scope.propertyTitle = $scope.property[index].property;
				$scope.propertyValue = $scope.property[index].property_value;
				$scope.number_buy = $scope.property[index].number_buy;
				$scope.real_price = $scope.property[index].real_price;
				$scope.discount_price = $scope.property[index].discount_price;
				$scope.max_buy = $scope.property[index].max_buy;
				$scope.productId = $scope.property[index].product_id;
				$scope.propertyId = $scope.property[index].id;
				$scope.sku = $scope.property[index].sku;

				if( $scope.max_buy > 0 )
					$scope.quantity = $scope.max_buy - $scope.number_buy;
				if( $scope.max_buy == -1 ) /*new update*/
                    $scope.quantity = 0;
                return true;
			}
		});
	};

	$scope.addToCard = function(typeShop, title, payment_provider, cover)
	{
		var card = $localstorage.getObjectECommerce("shopCard_eCommerce");
		var cardId = $scope.productId+'_'+$scope.propertyId;
		var price = $scope.real_price;
		
		if( payment_provider == 'cafebazaar' || payment_provider == 'myket' )
			card = {};

		if( typeShop == 1 )
			card = {};

		if( !$scope.inCard( card, cardId ) )
		{
			if( $scope.discount_price > 0 )
				price = $scope.discount_price;

			/*New update*/
			if( $scope.max_buy == -1 )
			{
                $ionicPopup.alert({
                    title: "خطا",
                    template: "موجودی این محصول به اتمام رسیده است و نمی توانید آنرا بخرید!",
                    okText: "باشه"
                });
                return false;
			}
			/*New update*/
			if( $scope.max_buy > 0 )
			{
				var len = Number( $scope.max_buy ) - Number( $scope.number_buy );
				if( len <= 0 )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "موجودی این محصول به اتمام رسیده است و نمی توانید آنرا بخرید!",
						okText: "باشه"
					});
					return false;
				}
			}
			card[cardId] = {"productId": $scope.productId, "propertyId": $scope.propertyId, "max_buy": $scope.max_buy, "file_address": $scope.file_address,
				"title": title, "price": price, "typeShop": typeShop, "number_buy": $scope.number_buy, "sku": $scope.sku,
				"propertyTitle": $scope.propertyTitle, "propertyValue": $scope.propertyValue, "cover": cover, "selectorCountPurchased": 1};

			$localstorage.setObjectECommerce("shopCard_eCommerce", card);
			$scope.addedToCard = true;
			$appetoToast.make("محصول به سبد خرید اضافه شد", 1500);
        }
		else
		{
			if($scope.addedToCard) {
				$timeout(function(){
					//$state.go('nav.e-commerce-card');
                    $scope.goToCard();
				}, 400);
				return;
			}
		}
		if( payment_provider == 'cafebazaar' || payment_provider == 'myket' || typeShop == 1) {
			$timeout(function(){
				//$state.go('nav.e-commerce-card');
                $scope.goToCard();
			}, 400);
		}
	};

	$scope.inCard = function(obj, val)
	{
		for(var i in obj)
		{
			if(i == val)
				return true;
		}
		return false;
	};

    $scope.goToCard = function()
    {
        if( $scope.shop_connect_to_login == 1 )
        {
            var userId = $localstorage.getNoExpired('loginUserId');
            var loginKey = $localstorage.getNoExpired('loginLoginKey');

            if( userId !== '' && loginKey !== '' )
            {
                $state.go('nav.e-commerce-card', {userId: userId, loginKey: loginKey});
            }
            else
            {
                if(typeof loginPageSlug !== "undefined" && loginPageSlug !== "")
                {
                    $appetoToast.make("برای تکمیل خرید ابتدا باید ثبت نام کنید", 2000);
                    $state.go('nav.'+loginPageSlug);
                }
                else
                {
                    alert("با توجه به این که افزونه فروشگاه ساز را به حساب کاربری متصل کرده اید حتما باید این افزونه در اپلیکیشن استفاده شده باشد");
                    return false;
                }
            }
        }
        else
        {
            $state.go('nav.e-commerce-card', {userId: 0, loginKey: ''});
        }
    };

	$scope.shopTime = function (shopTimeTxt)
	{
        $appetoToast.make(shopTimeTxt, 5000);
    };
});

angular.module('ngApp').controller('eCommerceCardCtrl', function($scope, $rootScope, $http, $timeout, $ionicActionSheet, $localstorage, $ionicScrollDelegate, $ionicPopup, $ionicLoading, $appetoToast, $stateParams){

	$scope.flat_rate = 0;
	$scope.quantity_rate = 0;
	$scope.total_rate = 0;
	$scope.tax_rate = 0;
	$scope.tax_shipping = 0;
	$scope.noInfoCard = true;
	$scope.sumAllPrice = 0;
	$scope.postage = 0;
	$scope.browserType = 'blank';
    $scope.discount = [];
    $scope.discount.code = '';
	$scope.userInfo = $localstorage.getObjectNoExpired("shopUserInfo");

	if( typeof $scope.userInfo.fullname == 'undefined' )
		$scope.userInfo.fullname = '';
	if( typeof $scope.userInfo.email == 'undefined' )
		$scope.userInfo.email = '';
	if( typeof $scope.userInfo.mobile == 'undefined' )
		$scope.userInfo.mobile = '';
	if( typeof $scope.userInfo.address == 'undefined' )
		$scope.userInfo.address = '';
	if( typeof $scope.userInfo.postalCode == 'undefined' )
		$scope.userInfo.postalCode = '';
    if( typeof $scope.userInfo.selectPaymentProvider == 'undefined' )
        $scope.userInfo.selectPaymentProvider = '';

	var totalPrice = new Array();
	var card = $localstorage.getObjectECommerce("shopCard_eCommerce");
	$scope.selectorModel = {};

	$scope.init = function()
	{
		var keys = Object.keys(card);
		if( keys.length > 0 )
			$scope.noInfoCard = false;
		
		for(var i in card)
		{
			var data = [];
			var length = 10;
			if( card[i]['max_buy'] > 0 )
			{
				length = Number(card[i]['max_buy']) - Number(card[i]['number_buy']);
				if( length > 10 )
					length = 10;
			}
			for(var j = 0; j < length; j++) {
				data.push(j);
			}
			card[i]['selectorCount'] = data;
			card[i]['totalPriceProduct'] = 0;
			card[i]['taxRate'] = $scope.tax_rate;
			$scope.selectorModel[card[i]['productId']+"_"+card[i]['propertyId']] = card[i]['selectorCountPurchased'];

			/* shipping tax */
			card[i]['taxShipping'] = 0;
			/*if( $scope.flat_rate > 0 )
			{
				card[i]['taxShipping'] = Number($scope.flat_rate);
			}*/
			if( $scope.quantity_rate > 0 )
			{
				card[i]['taxShipping'] += Number(card[i]['selectorCountPurchased']) * Number($scope.quantity_rate);
			}
			if( $scope.tax_shipping == 1 && $scope.tax_rate > 0 )
			{
				card[i]['taxShipping'] += Number($scope.tax_rate) * Number(card[i]['taxShipping']) / 100;
			}
			/* shipping tax */

			/* product tax */
			card[i]['taxProduct'] = 0;
			if( $scope.tax_rate > 0 )
			{
				card[i]['taxProduct'] = Number($scope.tax_rate) * Number(card[i]['price']) * Number(card[i]['selectorCountPurchased']) / 100;
			}
			/* product tax */

			card[i]['totalPriceProduct'] = ( Number(card[i]['selectorCountPurchased']) * Number(card[i]['price']) ) + Number(card[i]['taxProduct']) + Number(card[i]['taxShipping']);
			totalPrice[i] = card[i]['totalPriceProduct'];
			$scope.sumPrice();

			if($scope.shop_type == 1)
			{
				currentSKU = card[i]["sku"];
				currentSL = $scope.sl;
				currentPath = card[i]['file_address']
			}
		}
		$scope.eCommerceCard = card;
	};

	$scope.changeProduct = function(productId, propertyId)
	{
		var cardId = productId+'_'+propertyId;
		var count = $scope.selectorModel[cardId];
		if( isNaN(count) )
		{
			count = "";
            card[cardId]['selectorCountPurchased'] = 0;
			return false;
        }

		count = Number(count.toFixed(0));
        if( card[cardId]['max_buy'] > 0 )
        {
            var numberUserCanBuy = Number(card[cardId]['max_buy']) - Number(card[cardId]['number_buy']);
            if( count > numberUserCanBuy )
			{
				count = numberUserCanBuy;
                $appetoToast.make(" تعداد موجودی این محصول " + count + " می باشد ", 2000);
            }
        }
        /*new update*/
        if( card[cardId]['max_buy'] == -1 )
		{
            count = 0;
            $appetoToast.make(" این محصول موجود نمی باشد لطفا آنرا از سبد خرید حذف نمایید ", 2000);
		}
		/*new update*/
        $scope.selectorModel[cardId] = count;

		card[cardId]['selectorCountPurchased'] = count;

		/* shipping tax */
		card[cardId]['taxShipping'] = 0;
		/*if( $scope.flat_rate > 0 )
		{
			card[cardId]['taxShipping'] = Number($scope.flat_rate);
		}*/
		if( $scope.quantity_rate > 0 )
		{
			card[cardId]['taxShipping'] += count * Number($scope.quantity_rate);
		}
		if( $scope.tax_shipping == 1 && $scope.tax_rate > 0 )
		{
			card[cardId]['taxShipping'] += Number($scope.tax_rate) * Number(card[cardId]['taxShipping']) / 100;
		}
		/* shipping tax */

		/* product tax */
		card[cardId]['taxProduct'] = 0;
		if( $scope.tax_rate > 0 )
		{
			card[cardId]['taxProduct'] = Number($scope.tax_rate) * Number(card[cardId]['price']) * count / 100;
		}
		/* product tax */
		card[cardId]['totalPriceProduct'] = 0;
		card[cardId]['totalPriceProduct'] = (count * Number(card[cardId]['price'])) + Number(card[cardId]['taxProduct']) + Number(card[cardId]['taxShipping']);
		totalPrice[cardId] = card[cardId]['totalPriceProduct'];
		$scope.sumPrice();
		$localstorage.setObjectECommerce("shopCard_eCommerce", card);
	};

	$scope.removeItem = function(key, productId, propertyId)
	{
		var cardId = productId+'_'+propertyId;
		delete card[cardId];
		delete totalPrice[cardId];
		$scope.eCommerceCard = [];
		$scope.eCommerceCard = card;
		var keys = Object.keys(card);
		if( keys.length == 0 )
			$scope.noInfoCard = true;

		$localstorage.setObjectECommerce("shopCard_eCommerce", card);
		if( key == 0 )
			$ionicScrollDelegate.scrollTo(0, 0, true);
		else
			$ionicScrollDelegate.scrollTo(0, $(document).height()-50, true);

		$scope.sumPrice();
	};

	$scope.buyThisCard = function()
	{
		if( !$.trim($scope.userInfo.fullname) )
		{
			$ionicPopup.alert({
				title: "خطا",
				template: "لطفا نام و نام خانوادگی خود را وارد نمایید",
				okText: "باشه"
			});
			return false;
		}
		if($scope.shop_connect_to_login == 1)
		{
            var checkboxValue = {};
            $('[data-checkbox="checkbox"]').each(function(i, e){
                if( $(e).is(':checked') )
                {
                    var name = $(e).attr('name');
                    if( !(name in checkboxValue) )
                    {
						/*true if "key" doesn't exist in object*/
                        checkboxValue[name] = $(e).val();
                    }
                    else
                    {
                        checkboxValue[name] = checkboxValue[name] + ',' + $(e).val();
                    }
                }
            });

            checkboxValue = JSON.stringify( checkboxValue );
            $("#checkbox_inputs").val( checkboxValue );
		}
		else
		{
            if( $scope.shop_type == 1 || $scope.shop_type == '1' || $scope.get_email == 1 || $scope.get_email == '1' )
            {
                if( !$scope.validateEmail($scope.userInfo.email) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                else
                {
                    currentEmail = $scope.userInfo.email;
                }
            }
            if( $scope.get_phone == 1 || $scope.get_phone == '1' )
            {
                if( !$scope.checkMobile( $scope.userInfo.mobile ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید.",
                        okText: "باشه"
                    });
                    return false;
                }
            }
            if( $scope.get_address == 1 || $scope.get_address == '1' )
            {
                if( !$.trim($scope.userInfo.address) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا آدرس خود را وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
            }
            if( $scope.get_postalCode == 1 || $scope.get_postalCode == '1' )
            {
                if( !$scope.checkPostalCode( $scope.userInfo.postalCode ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا کدپستی خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
            }
        }

        //card[cardId]['selectorCountPurchased']
		var hasError = false;
		var counterCard = 0;
        for(var i in card)
		{
			if( card[i]['selectorCountPurchased'] === '' || card[i]['selectorCountPurchased'] == 0 )
                hasError = true;
			else
                counterCard += card[i]['selectorCountPurchased'];
		}
		if( hasError )
		{
            $ionicPopup.alert({
                title: "خطا",
                template: "تعداد یکی از محصولات وارد نشده است!",
                okText: "باشه"
            });
            return false;
		}
		
		if( $scope.appId == '82511' )
        {
        	if( counterCard != 6 )
			{
                $ionicPopup.alert({
                    title: "خطا",
                    template: "حداقل و حداکثر خرید برای هر فرد باید 6 عدد باشد",
                    okText: "متوجه شدم"
                });
                return;
			}
        }
		if( $scope.appId == '65973' )
        {
        	if( counterCard > 1000 )
			{
                $ionicPopup.alert({
                    title: "خطا",
                    template: "حداکثر خرید برای هر فرد باید 1000 عدد باشد",
                    okText: "متوجه شدم"
                });
                return;
			}
        }
		if( $scope.appId == '83842' )
		{
			if( $scope.sumAllPrice < 30000 )
			{
                $ionicPopup.alert({
                    title: "خطا",
                    template: "حداقل خرید باید 30 هزار تومان باشد",
                    okText: "متوجه شدم"
                });
                return;
			}
		}

		$localstorage.setObjectNoExpired("shopUserInfo", $scope.userInfo);
        var c = JSON.stringify( card );
        var userInfo = JSON.stringify( $scope.userInfo );
        var sendCodeData = '';
		
		var customInputForm = "";
		if( $("#customInputForm").length > 0 )
            customInputForm = $("#customInputForm").serialize();

		if($scope.payment_provider === 'cafebazaar')
		{
			/* check discount code */
			if( $.trim($scope.discount.code) )
			{
                sendCodeData = $.param({
                    sl:  $scope.sl,
                    code: $scope.discount.code
                });
                $http({
                    method: 'POST',
                    url: url + '/api/v1/widget/post/ecommerce-new/checkValidDiscountCode',
                    data: sendCodeData,
                    dataType: 'json',
                    headers: {'Content-Type': 'application/x-www-form-urlencoded'}
                }).success(function (data, status, headers, config)
                {
                    if( data.result === 'valid' )
					{
						currentSKU = $scope.discount.code;
                        cafebazaarECommerceInit( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                        return false;
                    }
                    else
					{
                        cafebazaarECommerceInit( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                        return false;
					}

                }).error(function (data, status, headers, config)
                {
                    cafebazaarECommerceInit( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                    return false;
                });
			}
			else
			{
                cafebazaarECommerceInit( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                return false;
			}
		}

		if($scope.payment_provider === 'myket')
		{
			/* check discount code */
            if( $.trim($scope.discount.code) )
            {
                sendCodeData = $.param({
                    sl:  $scope.sl,
                    code: $scope.discount.code
                });
                $http({
                    method: 'POST',
                    url: url + '/api/v1/widget/post/ecommerce-new/checkValidDiscountCode',
                    data: sendCodeData,
                    headers: {'Content-Type': 'application/x-www-form-urlencoded'}
                }).success(function (data, status, headers, config)
                {
                    if( data.result === 'valid' )
					{
                        currentSKU = $scope.discount.code;
                        myketCommerceInitNew( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                        return false;
					}
					else
					{
                        myketCommerceInitNew( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                        return false;
					}
                }).error(function (data, status, headers, config)
                {
                    myketCommerceInitNew( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                    return false;
                });
            }
            else
			{
                myketCommerceInitNew( currentSKU, currentEmail, currentPath, currentSL, c, userInfo, customInputForm, $stateParams.userId );
                return false;
			}
		}

		var backToMe = url + '/api/v1/widget/get/ecommerce-new/paymentCheckNew?info=%s';
		if($scope.payment_provider === 'parsian' || $scope.payment_provider === 'paymentUponDelivery_parsian')
		{
            backToMe = url + '/api/v1/widget/post/ecommerce-new/paymentCheckParsian?info=%s';
		}

		

		var sendData = $.param({
			sl:  $scope.sl,
			card: c,
			userInfo: userInfo,
			postage: $scope.postage,
			backToMe: backToMe,
            discountCode: $scope.discount.code,
            customInputForm: customInputForm,
            shop_connect_to_login: $scope.shop_connect_to_login,
            user_userId: $stateParams.userId,
            activeTypeAccount: $scope.activeTypeAccount
		});
		$http({
			method: 'POST',
			url: url + '/api/v1/widget/post/ecommerce-new/buyProductCard',
			data: sendData,
			headers: {'Content-Type': 'application/x-www-form-urlencoded'}
		}).success(function (data, status, headers, config)
		{
			if(data.status === 'success')
			{
				$localstorage.removeECommerce("shopCard_eCommerce");
				$scope.eCommerceCard = [];
				$scope.noInfoCard = true;
				$scope.sumAllPrice = 0;
				$ionicScrollDelegate.scrollTo(0, 0, true);
                var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
				if(data.provider === 'zarinpal')
				{
					if ( is_app_call )
					{
						var devicePlatform = device.platform;
						devicePlatform = devicePlatform.toLowerCase();
						if($scope.browserType == "self") {
							if(devicePlatform == "android") {
								inAppBrowserRef = cordova.InAppBrowser.open(data.url, "_self", "location=yes,toolbar=no");
							}
							else {
								inAppBrowserRef = cordova.InAppBrowser.open(data.url, "_blank", "location=yes,toolbar=yes");
							}
							inAppBrowserRef.addEventListener('loaderror', function(params) {
								if (inAppBrowserRef != undefined) {
									inAppBrowserRef.close();
									inAppBrowserRef = undefined;
								}
								var url = params.url;
								var check = url.split("://");
								if(check[0] == appScheme)
								{
									window.open(params.url, '_system');
								}
								else
								{
									$ionicPopup.alert({
										title: "خطا",
										template: "ارتباط با بانک برقرار نشد.",
										okText: "باشه"
									});
								}
							});
						}
						else {
							window.open(data.url, '_system');
						}
					}
					else
					{
						alert('دقت کنید که این بخش داخل موبایل از طریق اپلیکیشن انجام خواهد شد، در نتیجه در دمو آنلاین شما به صورت کامل روند را انجام نمیدهید، در فایل اصلی کاربر شما به اپلیکیشن باز خواهد گشت.');
						window.open(data.url, '_blank', 'toolbar=yes, location=yes, status=yes, menubar=yes, scrollbars=yes');
					}
				}
				else if(data.provider === 'parsian')
				{
                    if ( is_app_call )
					{
                        window.open(data.url, '_system');
					}
					else
					{
                        alert('دقت کنید که این بخش داخل موبایل از طریق اپلیکیشن انجام خواهد شد، در نتیجه در دمو آنلاین شما به صورت کامل روند را انجام نمیدهید، در فایل اصلی کاربر شما به اپلیکیشن باز خواهد گشت.');
                        window.open(data.url, '_blank', 'toolbar=yes, location=yes, status=yes, menubar=yes, scrollbars=yes');
					}
				}
				else if(data.provider === 'cafebazaar')
				{

				}
				else
				{
					if( $scope.payment_provider === 'paymentUponDelivery_zarinpal' || $scope.payment_provider === 'paymentUponDelivery_parsian' )
					{
                        $ionicPopup.alert({
                            title: "خرید شما ثبت شد",
                            template: "با تشکر خرید شما ثبت شد.<br /><span style='direction: ltr'> شماره پیگیری: 99"+data.url+" </span><br /> پشتیبانی: "+" <a href='tel:"+$scope.paymentUponDelivery+"'>"+$scope.paymentUponDelivery+"</a> ",
                            okText: "باشه"
                        });
					}
					else
					{
                        $ionicPopup.alert({
                            title: "خرید شما ثبت شد",
                            template: "با تشکر خرید شما ثبت شد.<br /><span style='direction: ltr'> شماره پیگیری: 99"+data.url+" </span><br /> پشتیبانی: "+" <a href='tel:"+$scope.payment_provider_email+"'>"+$scope.payment_provider_email+"</a> ",
                            okText: "باشه"
                        });
					}
				}
			}
			else if( data.status === 'fillRequiredInputs' )
			{
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا فیلدهای ستاره دار را کامل نمایید",
                    okText: "باشه"
                });
			}
			else
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
					okText: "باشه"
				});
			}
		}).error(function (data, status, headers, config) {
			$ionicPopup.alert({
				title: "خطا",
				template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
				okText: "باشه"
			});
		});
	};

	$scope.getPreFactor = function ()
	{
        if( !$.trim($scope.userInfo.fullname) )
        {
            $ionicPopup.alert({
                title: "خطا",
                template: "لطفا نام و نام خانوادگی خود را وارد نمایید",
                okText: "باشه"
            });
            return false;
        }
        if($scope.shop_connect_to_login == 1)
        {
            var checkboxValue = {};
            $('[data-checkbox="checkbox"]').each(function(i, e){
                if( $(e).is(':checked') )
                {
                    var name = $(e).attr('name');
                    if( !(name in checkboxValue) )
                    {
						/*true if "key" doesn't exist in object*/
                        checkboxValue[name] = $(e).val();
                    }
                    else
                    {
                        checkboxValue[name] = checkboxValue[name] + ',' + $(e).val();
                    }
                }
            });

            checkboxValue = JSON.stringify( checkboxValue );
            $("#checkbox_inputs").val( checkboxValue );
        }
        else
		{
            if( $scope.shop_type == 1 || $scope.shop_type == '1' || $scope.get_email == 1 || $scope.get_email == '1' )
            {
                if( !$scope.validateEmail($scope.userInfo.email) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                else
                {
                    currentEmail = $scope.userInfo.email;
                }
            }
            if( $scope.get_phone == 1 || $scope.get_phone == '1' )
            {
                if( !$scope.checkMobile( $scope.userInfo.mobile ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید.",
                        okText: "باشه"
                    });
                    return false;
                }
            }
            if( $scope.get_address == 1 || $scope.get_address == '1' )
            {
                if( !$.trim($scope.userInfo.address) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا آدرس خود را وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
            }
            if( $scope.get_postalCode == 1 || $scope.get_postalCode == '1' )
            {
                if( !$scope.checkPostalCode( $scope.userInfo.postalCode ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا کدپستی خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
            }
		}

        $localstorage.setObjectNoExpired("shopUserInfo", $scope.userInfo);
        var c = JSON.stringify( card );
        var userInfo = JSON.stringify( $scope.userInfo );

        var customInputForm = "";
        if( $("#customInputForm").length > 0 )
            customInputForm = $("#customInputForm").serialize();

        $ionicLoading.show();
        var sendData = $.param({
            sl:  $scope.sl,
            card: c,
            userInfo: userInfo,
            customInputForm: customInputForm,
            shop_connect_to_login: $scope.shop_connect_to_login,
            user_userId: $stateParams.userId,
            postage: $scope.postage
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/ecommerce-new/getPreFactor',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config)
        {
			var factorLink = data.factorLink;
        	factorLink = factorLink.replace("http://appeto.ir/uploads/user/", "");
            factorLink = "http://appage.online/factors.php?type=showFactor&pdf=" + Base64.encode(factorLink);
			
            $ionicLoading.hide();
            var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
            if ( is_app_call )
			{
				/* new for update cordova */
                window.open(factorLink, '_system');
                return false;
				
				if(device.platform === "iOS")
                {
                    window.open(factorLink, '_system');
                    return false;
                }
                var fileTransfer = new FileTransfer();
                var uri = encodeURI(data.factorLink);
                var fileURL = cordova.file.externalCacheDirectory + '/' + data.fileName;

                $ionicPopup.alert({
                    title: "دانلود",
                    template: "در حال دانلود فاکتور: "+
                    "<span id='fileDownloadingProgress'>0</span>%",
                    okText: "باشه"
                });

                fileTransfer.onprogress = function(progressEvent) {
                    if (progressEvent.lengthComputable) {
                        $("#fileDownloadingProgress").html(Math.ceil(progressEvent.loaded / progressEvent.total) * 100);
                    }
                };
                fileTransfer.download(
                    uri,
                    fileURL,
                    function(entry) {
                        window.open(entry.toURL(), '_pdf');
                    },
                    function(error) {
                        alert('خطا، فایل مورد نظر دانلود نشد: '+error.code);
                    },
                    true,
                    {

                    }
                );
            }
            else
			{
				window.open(factorLink);
                return false;
			}
        }).error(function (data, status, headers, config)
		{
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });
    };

	$scope.checkDiscountCode = function ()
	{
		if( $.trim($scope.discount.code) )
		{
            $ionicLoading.show();
            var sendData = $.param({
                sl:  $scope.sl,
                code: $scope.discount.code
            });
            $http({
                method: 'POST',
                url: url + '/api/v1/widget/post/ecommerce-new/checkValidDiscountCode',
                data: sendData,
                headers: {'Content-Type': 'application/x-www-form-urlencoded'}
            }).success(function (data, status, headers, config)
            {
                $ionicLoading.hide();
                if( data.result === 'valid' )
                {
                    $ionicPopup.alert({
                        title: "موفقیت",
                        template: "کد شامل " + data.percent + " درصد تخفیف می باشد",
                        okText: "باشه"
                    });
                }
                else
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "کد تخفیف معتبر نیست",
                        okText: "باشه"
                    });
                }
            }).error(function (data, status, headers, config)
			{
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            });
		}
    };

	$scope.sumPrice = function()
	{
		var sum = 0;
		$scope.postage = 0;
		for(var i in totalPrice)
		{
			sum += Number( totalPrice[i] );
		}
		if( $scope.flat_rate > 0 )
		{
			$scope.postage += Number($scope.flat_rate);

			if( $scope.tax_shipping == 1 && $scope.tax_rate > 0 )
				$scope.postage += Number($scope.tax_rate) * Number($scope.flat_rate) / 100;

			sum += $scope.postage;
		}
		$scope.sumAllPrice = sum;
	};

	$scope.validateEmail = function ( email )
	{
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	};

	$scope.checkMobile = function( mobile )
	{
		if(typeof mobile == 'undefined')
			return false;
		else
		{
			if( mobile.length == 11 )
			{
                if( mobile.substring(0, 2) != '09')
                    return false;
			}
			else if( mobile.length == 10 )
			{
                if( mobile.substring(0, 1) != '9')
                    return false;
			}
			else
			{
                return false;
			}

			if( isNaN(mobile) )
				return false;
		}
		return true;
	};

	$scope.checkPostalCode = function ( code )
	{
        if(typeof code == 'undefined')
            return false;
        else
        {
			code = replacePersianNumbers(code);
            if( code.length != 10 )
                return false;
            if( isNaN(code) )
                return false;
        }
        return true;
    };
	
	function replacePersianNumbers(num)
	{
		num = replaceAll(num, '۰', '0');
		num = replaceAll(num, '۱', '1');
		num = replaceAll(num, '۲', '2');
		num = replaceAll(num, '۳', '3');
		num = replaceAll(num, '۴', '4');
		num = replaceAll(num, '۵', '5');
		num = replaceAll(num, '۶', '6');
		num = replaceAll(num, '۷', '7');
		num = replaceAll(num, '۸', '8');
		num = replaceAll(num, '۹', '9');
		return num;
	}

	function replaceAll(str, find, replace) {
		return str.replace(new RegExp(find, 'g'), replace);
	}

	$scope.removeAllCard = function(){
		$localstorage.removeECommerce("shopCard_eCommerce");
		$scope.eCommerceCard = [];
		$scope.noInfoCard = true;
		$scope.sumAllPrice = 0;
		$ionicScrollDelegate.scrollTo(0, 0, true);
	};
});

var currentUserId = "";
var customInputFormApp = "";
var currentSKU = "";
var currentSL = "";
var currentEmail = "";
var currentPath = "";
var currentCard = "";
var currentUserinfo = "";

function successECafeInitNew(result)
{
	angular.element($('ion-view')).injector().get("$ionicLoading").hide();
	inappbilling.buy(cafebazaarEPurchaseDoneNew, cafebazaarEPurchaseErrorNew, currentSKU);
}

function errorECafeCallbackNew(error)
{
	angular.element($('ion-view')).injector().get("$ionicLoading").hide();
	currentSKU = '';
	currentPath = '';
	currentEmail = '';
	currentCard = '';
	currentUserinfo = '';
	var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
	$scope.removeAllCard();

	angular.element($('ion-view')).injector().get("$ionicPopup").alert({
		title: "خطا",
		template: "خطا در اتصال به کافه بازار، لطفا در اپلیکیشن کافه بازار وارد حساب کاربری خود شوید.",
		okText: "باشه"
	});
}

function cafebazaarEPurchaseDoneNew (result)
{
	var data = {
		'orderCode': result.orderId,
		'card': currentCard,
		'userInfo': currentUserinfo,
		'customInputForm': customInputFormApp,
		'user_userId': currentUserId,
		'productId': result.productId,
		'description': 'کد محصول: '+result.productId,
		'sl': currentSL,
		'currentSku': currentSKU,
		'backToMe': url + '/api/v1/widget/get/ecommerce-new/paymentCheckNew?info=%s'
	};
	var orderCode = result.orderId;
	angular.element($('ion-view')).injector().get("$ionicLoading").show();
	$.ajax({
		type: 'POST',
		url: url + '/api/v1/widget/post/ecommerce-new/buyProductCard',
		data: data,
		dataType: 'json',
		success: function(data)
		{
			if(data.status == 'success')
			{
				var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
				$scope.removeAllCard();
				if(typeof data.dl != "undefined" && data.dl != "") {
					var fileTransfer = new FileTransfer();
					var uri = encodeURI(data.dl);
					var fileURL = cordova.file.externalCacheDirectory + '/'+currentPath;

					angular.element($('ion-view')).injector().get("$ionicPopup").alert({
						title: "خرید شما تکمیل شد",
						template: "با تشکر خرید شما انجام شد و اطلاعات مورد نظر برای شما ایمیل شد.<br /><span style='direction: ltr'> شماره پیگیری: 99"+data.url+" </span><br />در حال دانلود فایل: "+
						"<span id='fileDownloadingProgress'>0</span>%",
						okText: "باشه"
					});

					fileTransfer.onprogress = function(progressEvent) {
						if (progressEvent.lengthComputable) {
							$("#fileDownloadingProgress").html(Math.ceil(progressEvent.loaded / progressEvent.total) * 100);
						}
					};
					fileTransfer.download(
						uri,
						fileURL,
						function(entry) {
							window.open(entry.toURL(), '_filemanager');
						},
						function(error) {
							alert('خطا، فایل مورد نظر دانلود نشد: '+error.code);
						},
						true,
						{

						}
					);
				}
				else {
					angular.element($('ion-view')).injector().get("$ionicPopup").alert({
						title: "خرید شما تکمیل شد",
						template: "با تشکر خرید شما انجام شد و اطلاعات مورد نظر برای شما ایمیل شد.<br /><span style='direction: ltr'> شماره پیگیری: 99"+data.url+" </span>",
						okText: "باشه"
					});
				}
			}
			else if(data.status == 'bazaar') {
                var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
                $scope.removeAllCard();
                angular.element($('ion-view')).injector().get("$ionicPopup").alert({
                    title: "خطا",
                    template: "خطا در اعتبار سنجی خرید شما، لطفا در صورتی که از صحیح بودن خرید خود مطمعن هستید با پشتیبانی تماس بگیرید، کد پیگیری: "+orderCode,
                    okText: "باشه"
                });
			}
			else
			{
				var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
				$scope.removeAllCard();
				angular.element($('ion-view')).injector().get("$ionicPopup").alert({
					title: "خطا",
					template: "خرید شما انجام شد اما اطلاعات برای شما ایمیل نشد، لطفا دوباره تلاش کنید.<br /> دقت کنید که هنگام خرید دوباره نیازی به پرداخت هزینه نخواهد بود.",
					okText: "باشه"
				});
			}
		}
	}).always(function() {
        inappbilling.consumePurchase(function(){

		}, function () {

        }, currentSKU);
		currentSKU = '';
		currentPath = '';
		currentEmail = '';
		currentCard = '';
		currentUserinfo = '';
		angular.element($('ion-view')).injector().get("$ionicLoading").hide();
	}).fail(function() {
		var success = function(message) {

		};
		var failure = function() {
			alert("عدم دسترسی به اینترنت");
		};
		window.plugins.toast.show("عدم دسترسی به اینترنت", 'long', 'center', success, failure);
		var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
		$scope.removeAllCard();
	});
}

function cafebazaarEPurchaseErrorNew (error)
{
	currentSKU = '';
	currentPath = '';
	currentEmail = '';
	currentCard = '';
	currentUserinfo = '';
	var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
	$scope.removeAllCard();
	angular.element($('ion-view')).injector().get("$ionicPopup").alert({
		title: "خطا",
		template: "خطا در خرید، خرید شما انجام نشد.",
		okText: "باشه"
	});
}

function cafebazaarECommerceInit(sku, email, path, sl, card, userinfo, customInputForm, userId)
{
	var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
	if(!is_app_call) {
		alert("این کار فقط در فایل ساخته شده آندروید امکان پذیر میباشد.");
		return false;
	}
	angular.element($('ion-view')).injector().get("$ionicLoading").show();
	currentEmail = email;
	currentSKU = sku;
	customInputFormApp = customInputForm;
	currentUserId = userId;
	currentPath = path;
	currentSL = sl;
	currentCard = card;
	currentUserinfo = userinfo;
	inappbilling.init(successECafeInitNew, errorECafeCallbackNew, {showLog:false});
}

function successMyketInitNew(result) {
	angular.element($('ion-view')).injector().get("$ionicLoading").hide();
	inappbilling.buy(cafebazaarEPurchaseDoneNew, cafebazaarEPurchaseErrorNew, currentSKU);
}
function errorMyketCallbackNew(error) {
	angular.element($('ion-view')).injector().get("$ionicLoading").hide();
	currentSKU = '';
	currentPath = '';
	currentEmail = '';
	currentCard = '';
	currentUserinfo = '';
	var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
	$scope.removeAllCard();

	angular.element($('ion-view')).injector().get("$ionicPopup").alert({
		title: "خطا",
		template: "خطا در اتصال به مایکت، لطفا در اپلیکیشن مایکت وارد حساب کاربری خود شوید.",
		okText: "باشه"
	});
}
function myketCommerceInitNew(sku, email, path, sl, card, userinfo, customInputForm) {
	var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
	if(!is_app_call) {
		alert("این کار فقط در فایل ساخته شده آندروید امکان پذیر میباشد.");
		return false;
	}
	angular.element($('ion-view')).injector().get("$ionicLoading").show();
	currentEmail = email;
	currentSKU = sku;
	currentPath = path;
	currentSL = sl;
	currentCard = card;
	currentUserinfo = userinfo;
	inappbilling.init(successMyketInitNew, errorMyketCallbackNew, {showLog:false});
}

var Base64 = {

    _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    encode : function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
                this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }

        return output;
    },

    decode : function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },

    _utf8_encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },

    _utf8_decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while ( i < utftext.length ) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

};