var globalFirstRedirectTo = false;
angular.module('ngApp').controller('loginPageCtrl', function($scope, $ionicPopover, $ionicScrollDelegate, $ionicSideMenuDelegate, $timeout, $http, $ionicHistory, $ionicPopup, $localstorage, $state, $ionicLoading) {

	$scope.loginInfo = {};
	$scope.loginInfo.email = "";
	$scope.loginInfo.pass = "";

	/* self page register */
    $scope.userInfo = {};
    $scope.userInfo.email = "";
    $scope.userInfo.mobile = "";
    $scope.userInfo.username = "";
    $scope.userInfo.fullname = "";
    $scope.userInfo.password = "";
    $scope.userInfo.emailOrMobile = "";

	$scope.slug = '';
	$scope.activeTypeAccount = '';
	$scope.showBack = true;

	if(!checkNetConnection())
    {
        var success = function(message) {

        };
        var failure = function() {
            alert("عدم دسترسی به اینترنت");
        };
        if(typeof window.plugins != "undefined") {
        	window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
		}
    }
	
	$scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
		var checker = "nav."+loginPageSlug;
		if(toState.name == checker) {
			$ionicSideMenuDelegate.canDragContent(false);
		}
		else {
			$ionicSideMenuDelegate.canDragContent(true);
		}
	});

	$ionicPopover.fromTemplateUrl('popover.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.closePopover = function() {
		$scope.popover.hide();
	};

	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

	// Execute action on hide popover
	$scope.$on('popover.hidden', function() {
		// Execute action
	});

	// Execute action on remove popover
	$scope.$on('popover.removed', function() {
		// Execute action
	});

	$scope.onTabSelected = function(type) {
		$timeout(function(){
			$ionicScrollDelegate.resize();
		}, 250);
	};

    $scope.checkMobile = function (mobile)
	{
        if(typeof mobile === 'undefined')
            return false;
        else
        {
        	mobile = replacePersianNumbers(mobile);
            if( mobile.length != 11 )
                return false;
            if( mobile.substring(0, 2) != '09')
                return false;
            if( isNaN(mobile) )
                return false;
        }
        return true;
    };

    $scope.validateEmail = function(email)
    {
        var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return re.test(email);
    };

    $scope.registerUser = function()
	{
		if(!checkNetConnection())
		{
			var success = function(message) {

			};
			var failure = function() {
				alert("عدم دسترسی به اینترنت");
			};
			window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
			return false;
		}
        var activeTypeAccount = $("#activeTypeAccountRegister").val();
        var emailOrMobile = '', emailMobileUsername = '';
		if( !$.trim($scope.userInfo.fullname) )
		{
			$ionicPopup.alert({
				title: "خطا",
				template: "لطفا فیلدهای ستاره دار را کامل نمایید",
				okText: "باشه"
			});
			return false;
		}
		if( activeTypeAccount === 'activeWithEmail' )
		{
            if( !$scope.validateEmail( $scope.userInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'email';
            emailMobileUsername = $scope.userInfo.email;
		}
		else if( activeTypeAccount === 'activeWithSms' )
		{
            if( !$scope.checkMobile($scope.userInfo.mobile) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'mobile';
            emailMobileUsername = $scope.userInfo.mobile;
		}
		else if( activeTypeAccount === 'activeWithEmailSms' )
		{
			if( $scope.userInfo.emailOrMobile.indexOf( '@' ) > 0 )
			{
				/*Email*/
                if( !$scope.validateEmail( $scope.userInfo.emailOrMobile ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'email';
			}
			else
			{
				/*Mobile*/
                if( !$scope.checkMobile($scope.userInfo.emailOrMobile) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'mobile';
			}
            emailMobileUsername = $scope.userInfo.emailOrMobile;
		}
		else
		{
			if(!$.trim($scope.userInfo.username))
			{
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا یک نام کاربری برای خود انتخاب نمایید",
                    okText: "باشه"
                });
                return false;
			}
            emailMobileUsername = $scope.userInfo.username;
		}

		$("#emailOrMobile").val( emailOrMobile );
		if( !$.trim($scope.userInfo.password) )
		{
			$ionicPopup.alert({
				title: "خطا",
				template: "لطفا فیلدهای ستاره دار را کامل نمایید",
				okText: "باشه"
			});
			return false;
		}

		var checkboxValue = {};
		$('[data-checkbox="checkbox"]').each(function(i, e){
			if( $(e).is(':checked') )
			{
				var name = $(e).attr('name');
				if( !(name in checkboxValue) )
				{
					/*true if "key" doesn't exist in object*/
					checkboxValue[name] = $(e).val();
				}
				else
				{
					checkboxValue[name] = checkboxValue[name] + ',' + $(e).val();
				}
			}
		});
		checkboxValue = JSON.stringify(checkboxValue);
		$("#checkbox_inputs").val( checkboxValue );

		$ionicLoading.show();
		$.ajax({
			type: 'POST',
			url: url + '/api/v1/widget/post/login-register/register',
			data: $("#registerForm").serialize(),
			dataType: 'json',
			success: function(data)
			{
				if(data.status === "successWithSend")
				{
					$('#registerForm')[0].reset();
					$ionicPopup.alert({
						title: "موفقیت",
						template: "کد فعال سازی برای شما ارسال شد!",
						okText: "باشه"
					}).then(function(res)
					{
                        $localstorage.setNoExpired('registerActiveTypeAccount', activeTypeAccount);
                        $localstorage.setNoExpired('registerEmailMobileUsername', emailMobileUsername);
                        $localstorage.setNoExpired('registerEmailOrMobile', emailOrMobile);

						$state.go('nav.active-code');
					});
				}
				else if(data.status === 'successWithActive') // use username
				{
                    $('#registerForm')[0].reset();
                    $ionicPopup.alert({
                        title: "موفقیت",
                        template: "ثبت نام شما با موفقیت انجام شد و میتوانید وارد شوید",
                        okText: "باشه"
                    }).then(function(res) {
                        //$state.go('nav.index');
						var location = firstPageHash.split('/');
                        location = location[location.length-1];
                        $state.go('nav.'+location);
                    });
				}
				else if( data.status === 'successWithoutSend' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "ثبت نام شما انجام شد اما متاسفانه موفق به ارسال کد فعال سازی برای شما نشدیم لطفا از قسمت ارسال مجدد کد فعال سازی اقدام نمایید",
						okText: "باشه"
					}).then(function(res) {
						$state.go('nav.send-new-code');
					});
				}
				else if( data.status === 'fillRequiredInputs' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "لطفا فیلدهای ستاره دار را کامل نمایید",
						okText: "باشه"
					});
				}
				else if( data.status === 'endLimit' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "امکان ثبت نام وجود ندارد لطفا با مدیر اپلیکیشن تماس حاصل نمایید",
						okText: "باشه"
					});
				}
				else if( data.status === 'existEmail' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "این ایمیل قبلا ثبت شده است!",
						okText: "باشه"
					});
				}
                else if( data.status === 'existMobile' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "این تلفن همراه قبلا ثبت شده است!",
                        okText: "باشه"
                    });
                }
                else if( data.status === 'existUsername' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "این نام کاربری قبلا ثبت شده است!",
                        okText: "باشه"
                    });
                }
				else
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "لطفا دوباره تلاش کنید!",
						okText: "باشه"
					});
				}
			}
		}).always(function() {
			$ionicLoading.hide();
		}).fail(function() {
			var success = function(message) {

			};
			var failure = function() {
				alert("عدم دسترسی به اینترنت");
			};
			/*window.plugins.toast.show("عدم دسترسی به اینترنت", 'long', 'center', success, failure);*/
		});

		return false;
	};

	/*old*/
	$scope.back = function() {
		if("#/nav/"+$scope.slug != firstPageHash)
		{
			$ionicHistory.goBack();
		}
	};

	$scope.checkLocalData = function() {
		var userId = $localstorage.getNoExpired('loginUserId');
		var roleId = $localstorage.getNoExpired('loginRoleId');
		var loginKey = $localstorage.getNoExpired('loginLoginKey');
		var redirectTo = $localstorage.getNoExpired('loginRedirectTo');
		var firstRedirectTo = $localstorage.getNoExpired('firstRedirectTo');
		
		if( userId != '' && roleId != '' && loginKey != '' )
		{
            if( redirectTo !== '' && redirectTo !== 'profile' && !globalFirstRedirectTo )
            {
				$localstorage.setNoExpired('firstRedirectTo', 'false');
				globalFirstRedirectTo = true;
                $ionicHistory.nextViewOptions({
                    historyRoot: true
                });
                $state.go('nav.'+redirectTo, {userId: userId, loginKey: loginKey});
            }
            else
            {
                $state.go('nav.profile', {userId: userId, loginKey: loginKey});
            }
		}
	};

	$scope.login = function()
	{
		if(!checkNetConnection())
		{
			var success = function(message) {

			};
			var failure = function() {
				alert("عدم دسترسی به اینترنت");
			};
			window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
			return false;
		}
        var activeTypeAccount = $("#activeTypeAccount").val();
        var emailOrMobile = '';
        if( activeTypeAccount === 'activeWithEmail' )
        {
            if( !$scope.validateEmail( $scope.loginInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'email';
        }
        else if( activeTypeAccount === 'activeWithSms' )
        {
            if( !$scope.checkMobile($scope.loginInfo.email) ) /*dar login bejay 3 input az input email ba nam email estefade shod*/
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'mobile';
        }
        else if( activeTypeAccount === 'activeWithEmailSms' )
        {
            if( $scope.loginInfo.email.indexOf( '@' ) > 0 )
            {
                /*Email*/
                if( !$scope.validateEmail( $scope.loginInfo.email ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'email';
            }
            else
            {
                /*Mobile*/
                if( !$scope.checkMobile($scope.loginInfo.email) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'mobile';
            }
        }
        else
        {
            if( !$.trim($scope.loginInfo.email) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا نام کاربری را وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
        }

		if( $.trim($scope.loginInfo.email) && $.trim($scope.loginInfo.pass) )
		{
			$ionicLoading.show();
			var sendData = $.param({
				email: $scope.loginInfo.email,
				password: btoa(unescape(encodeURIComponent($scope.loginInfo.pass))),//btoa( $scope.loginInfo.pass ),
				sl: $scope.sl,
                activeTypeAccount: activeTypeAccount,
                emailOrMobile: emailOrMobile
			});
			$http({
				method: 'POST',
				url: url + '/api/v1/widget/post/login-register/doLoginUser',
				data: sendData,
				headers: {'Content-Type': 'application/x-www-form-urlencoded'}
			}).success(function (data, status, headers, config) {
				$ionicLoading.hide();
				if(data.status === 'success')
				{
					$localstorage.setNoExpired('loginUserId', data.userId);
					$localstorage.setNoExpired('loginRoleId', data.roleId);
					$localstorage.setNoExpired('loginLoginKey', data.key);
					$localstorage.setNoExpired('loginFullName', data.fullName);
					$localstorage.setNoExpired('loginProfileImage', data.profileImage);
					$localstorage.setNoExpired('loginDateAccessPersian', data.dateAccessPersian);
					$localstorage.setNoExpired('loginCanVisitPages', data.canVisitPages);
					$localstorage.setNoExpired('loginRedirectTo', data.redirectTo);

                    if( data.redirectTo !== '' && data.redirectTo !== 'profile' )
                    {
                        $ionicHistory.nextViewOptions({
                            historyRoot: true
                        });
                        $state.go('nav.'+data.redirectTo, {userId: data.userId, loginKey: data.key});
                    }
                    else
                    {
                        $state.go('nav.profile', {userId: data.userId, loginKey: data.key});
                    }
				}
				else if( data.status === 'falseInputs' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "اطلاعات وارد شده صحیح نیست!",
						okText: "باشه"
					});
				}
				else if( data.status === 'noActive' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "اکانت شما غیر فعال است!",
						okText: "باشه"
					});
				}
				else
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
						okText: "باشه"
					});
				}
			}).error(function (data, status, headers, config) {
				$ionicLoading.hide();
				$ionicPopup.alert({
					title: "خطا",
					template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
					okText: "باشه"
				});
			});
		}
	};

	/* new theme */
	$scope.goToRegisterPage = function ()
	{
        $state.go('nav.register-form');
    };
	/* new theme */
});

var currentSKU = "";
var currentSubscribe = "";
var currentSL = "";
var currentEmail = "";
var currentPath = "";
var currentCard = "";
var currentUserinfo = "";

angular.module('ngApp').controller('accountsPageCtrl', function($ionicViewService, $scope, $timeout, $http, $ionicHistory, $localstorage, $ionicPopup, $ionicLoading, $state) {

	$scope.buyThisAccount = function ( price, roleId, payment_provider, sku, subscribe )
	{
        $scope.browserType = "blank"; /* self */
        var userId = $localstorage.getNoExpired('loginUserId');
        var loginFullName = $localstorage.getNoExpired('loginFullName');
        var sendData = $.param({
            sl:  $scope.sl,
            loginUserInfoId: userId,
            accountPrice: price,
            roleId: roleId,
            backToMe: url + '/api/v1/widget/get/login-register/paymentAccountFactor?info=%s'
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/login-register/buyAccount',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config)
        {
            if(data.status === 'success')
            {
                var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
                if ( is_app_call )
                {
                    var devicePlatform = device.platform;
                    devicePlatform = devicePlatform.toLowerCase();
                    if($scope.browserType == "self")
                    {
                        if(devicePlatform == "android")
                        {
                            inAppBrowserRef = cordova.InAppBrowser.open(data.url, "_self", "location=yes,toolbar=no");
                        }
                        else
                        {
                            inAppBrowserRef = cordova.InAppBrowser.open(data.url, "_blank", "location=yes,toolbar=yes");
                        }

                        inAppBrowserRef.addEventListener('loaderror', function(params)
                        {
                            if (inAppBrowserRef != undefined) {
                                inAppBrowserRef.close();
                                inAppBrowserRef = undefined;
                            }
                            var url = params.url;
                            var check = url.split("://");
                            if(check[0] == appScheme)
                            {
                                window.open(params.url, '_system');
                            }
                            else
                            {
                                $ionicPopup.alert({
                                    title: "خطا",
                                    template: "ارتباط با بانک برقرار نشد.",
                                    okText: "باشه"
                                });
                            }
                        });
                    }
                    else
                    {
                        /*window.open(data.url, '_system');*/
						navigator.app.loadUrl(data.url, {openExternal : true});
                    }
                }
                else
                {
                    alert('دقت کنید که این بخش داخل موبایل از طریق اپلیکیشن انجام خواهد شد، در نتیجه در دمو آنلاین شما به صورت کامل روند را انجام نمیدهید، در فایل اصلی کاربر شما به اپلیکیشن باز خواهد گشت.');
                    window.open(data.url, '_blank', 'toolbar=yes, location=yes, status=yes, menubar=yes, scrollbars=yes');
                }
            }
            else
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            }
        }).error(function (data, status, headers, config) {
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });

        /*
        * var userInfo = {userId: userId, fullName: loginFullName};
		 var card = {price: price, roleId: roleId, sku: sku, subscribe: subscribe};
		 currentSubscribe = subscribe;
		 cafebazaarECommerceInit( sku, currentEmail, currentPath, $scope.sl, card, userInfo );
		 return false;
		 */
    };
});

angular.module('ngApp').controller('profilePageCtrl', function($ionicViewService, $scope, $timeout, $http, $ionicHistory, $localstorage, $ionicPopup, $ionicLoading, $state, $ionicScrollDelegate) {

    $scope.fileReaderSupported = window.FileReader != null;
    $scope.departmentArray = '';
    $scope.ticket = {};
    $scope.showBackBtn = true;
    $timeout(function () {
        if("#/nav/"+$scope.slug == firstPageHash)
        {
            $scope.showBackBtn = false;
        }
    }, 100);

    /*var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
    if ( is_app_call )
    {
        if(device.platform == "iOS")
            $scope.deviceAndroid = false;
        else
            $scope.deviceAndroid = true;// device is android
    }*/

    $scope.photoChanged = function(files)
    {
        if (files != null)
        {
            var file = files[0];
            var upload_file_size = 2 * 1000 * 1024; /* convert to byte */
            if( upload_file_size < file.size )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "بیشترین حجم آپلود تصویر پروفایل 2 مگابایت است",
                    okText: "باشه"
                });
                return false;
            }
            if ($scope.fileReaderSupported && typeof file !== "undefined" && typeof file.type !== "undefined" && file.type.indexOf('image') > -1)
            {
                $timeout(function() {
                    var fileReader = new FileReader();
                    fileReader.readAsDataURL(file); // convert the image to data url.
                    fileReader.onload = function(e) {
                        $timeout(function() {
                            var check1 = e.target.result.indexOf( "image/png" );
                            var check2 = e.target.result.indexOf( "image/jpg" );
                            var check3 = e.target.result.indexOf( "image/jpeg" );
                            if( check1 > -1 || check2 > -1 || check3 > -1 )
                            {
                                $("#attachment").val(e.target.result);
                                $("#imageInfo").val(file.name);
                                $("#showAttachment").attr('src', e.target.result).show();
                            }
                            else {
                                $ionicPopup.alert({
                                    title: "خطا",
                                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                                    okText: "باشه"
                                });
                            }
                        });
                    }
                });
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        }
    };

    $scope.showCamera = function(field)
    {
        var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
        if ( is_app_call ) {
            $scope.field = field;
            navigator.camera.getPicture(onCameraSuccess, onCameraFail, { quality: 50,
                destinationType: Camera.DestinationType.DATA_URL });
        }
        else {
            alert('این کار فقط در فایل ساخته شده موبایل امکان پذیر است.');
        }
    };

    $scope.onCameraSuccess = function(imageUrlData)
    {
        $timeout(function()
        {
            var check1 = imageUrlData.indexOf( "image/png" );
            var check2 = imageUrlData.indexOf( "image/jpg" );
            var check3 = imageUrlData.indexOf( "image/jpeg" );
            if( check1 > -1 || check2 > -1 || check3 > -1 ) {
                $("#attachment").val(imageUrlData);
                $("#imageInfo").val("fromCamera"+Math.floor((Math.random() * 1000) + 1)+".jpg");
                $("#showAttachment").attr('src', imageUrlData).show();
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "فایل مورد نظر معتبر نمیباشد، فقط تصاویر با فرمت png , jpg , jpeg قابل استفاده هستند.",
                    okText: "باشه"
                });
            }
        });
    };

    $scope.onCameraFail = function(msg)
    {
        $ionicPopup.alert({
            title: "خطا",
            template: msg,
            okText: "باشه"
        });
    };

    $scope.back = function()
	{
		if("#/nav/"+$scope.slug != firstPageHash)
		{
			var location = firstPageHash.split('/');
			location = location[location.length-1];
			$state.go('nav.'+location);
		}
	};

    $scope.goToAccountPage = function ()
	{
		$state.go('nav.accounts');
    };

	$scope.userInfo = {};
	$scope.userInfo.fullname = "";
	$scope.userInfo.password = "";
	$scope.slug = '';
	$scope.showBack = true;

    $scope.onTabSelected = function(type) {
        $timeout(function(){
            $ionicScrollDelegate.resize();
        }, 250);
    };

	$scope.goToAccountPage = function ()
	{
        //var userId = $localstorage.getNoExpired('loginUserId');
        $state.go('nav.accounts');
    };

	$scope.editProfile = function()
	{
		var checkboxValue = {};
		$('[data-checkbox="checkbox"]').each(function(i, e){
			if( $(e).is(':checked') )
			{
				var name = $(e).attr('name');
				if( !(name in checkboxValue) )
				{
					/*true if "key" doesn't exist in object*/
					checkboxValue[name] = $(e).val();
				}
				else
				{
					checkboxValue[name] = checkboxValue[name] + ',' + $(e).val();
				}
			}
		});
		checkboxValue = JSON.stringify( checkboxValue );
		$("#checkbox_inputs").val( checkboxValue );

		$ionicLoading.show();
		$.ajax({
			type: 'POST',
			url: url + '/api/v1/widget/post/login-register/editProfile',
			data: $("#editProfileForm").serialize(),
			dataType: 'json',
			success: function(data)
			{
				if(data.status === "success")
				{
                    $localstorage.setNoExpired('loginFullName', data.fullnameUser);
                    $localstorage.setNoExpired('loginProfileImage', data.profileImg);
					$ionicPopup.alert({
						title: "موفقیت",
						template: "ویراش اطلاعات با موفقیت انجام شد!",
						okText: "باشه"
					});
				}
				else if( data.status === 'fillRequiredInputs' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "لطفا فیلدهای ستاره دار را کامل نمایید",
						okText: "باشه"
					});
				}

			}
		}).always(function() {
			$ionicLoading.hide();
		}).fail(function() {
			var success = function(message) {

			};
			var failure = function() {
				alert("عدم دسترسی به اینترنت");
			};
			/*window.plugins.toast.show("عدم دسترسی به اینترنت", 'long', 'center', success, failure);*/
		});

		return false;
	};

	$scope.logoutUser = function(){

		var userId = $localstorage.getNoExpired('loginUserId');
		var loginKey = $localstorage.getNoExpired('loginLoginKey');

		$ionicLoading.show();
		var sendData = $.param({
			userId: userId,
			loginKey: loginKey,
			sl: $scope.sl
		});
		$http({
			method: 'POST',
			url: url + '/api/v1/widget/post/login-register/doLogoutUser',
			data: sendData,
			headers: {'Content-Type': 'application/x-www-form-urlencoded'}
		}).success(function (data, status, headers, config) {
			$ionicLoading.hide();
			if(data.status == 'success')
			{
				$localstorage.removeNoExpired('loginUserId');
				$localstorage.removeNoExpired('loginRoleId');
				$localstorage.removeNoExpired('loginLoginKey');
				$localstorage.removeNoExpired('loginFullName');

                $localstorage.removeNoExpired('loginDateAccess');
                $localstorage.removeNoExpired('loginIsPurchaseRole');
                $localstorage.removeNoExpired('loginCanVisitPages');
				$ionicViewService.clearHistory();
				$ionicHistory.nextViewOptions({
					disableBack: true
				});
				var location = firstPageHash.split('/');
				location = location[location.length-1];
				$state.go('nav.'+location);
			}
			else
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
					okText: "باشه"
				});
			}
		}).error(function (data, status, headers, config) {
			$ionicLoading.hide();
			$ionicPopup.alert({
				title: "خطا",
				template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
				okText: "باشه"
			});
		});
	};

    $scope.buyThisAccount = function ( price, roleId )
    {
        $scope.browserType = "blank"; /* self */
        var userId = $localstorage.getNoExpired('loginUserId');
        var sendData = $.param({
            sl:  $scope.sl,
            loginUserInfoId: userId,
            accountPrice: price,
            roleId: roleId,
            backToMe: url + '/api/v1/widget/get/login-register/paymentAccountFactor?info=%s'
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/login-register/buyAccount',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config)
        {
            if(data.status === 'success')
            {
                var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
                if ( is_app_call )
                {
                    var devicePlatform = device.platform;
                    devicePlatform = devicePlatform.toLowerCase();
                    if($scope.browserType == "self")
                    {
                        if(devicePlatform == "android")
                        {
                            inAppBrowserRef = cordova.InAppBrowser.open(data.url, "_self", "location=yes,toolbar=no");
                        }
                        else
                        {
                            inAppBrowserRef = cordova.InAppBrowser.open(data.url, "_blank", "location=yes,toolbar=yes");
                        }

                        inAppBrowserRef.addEventListener('loaderror', function(params)
                        {
                            if (inAppBrowserRef != undefined) {
                                inAppBrowserRef.close();
                                inAppBrowserRef = undefined;
                            }
                            var url = params.url;
                            var check = url.split("://");
                            if(check[0] == appScheme)
                            {
                                window.open(params.url, '_system');
                            }
                            else
                            {
                                $ionicPopup.alert({
                                    title: "خطا",
                                    template: "ارتباط با بانک برقرار نشد.",
                                    okText: "باشه"
                                });
                            }
                        });
                    }
                    else
                    {
                        /*window.open(data.url, '_system');*/
						
						navigator.app.loadUrl(data.url, {openExternal : true});
                    }
                }
                else
                {
                    alert('دقت کنید که این بخش داخل موبایل از طریق اپلیکیشن انجام خواهد شد، در نتیجه در دمو آنلاین شما به صورت کامل روند را انجام نمیدهید، در فایل اصلی کاربر شما به اپلیکیشن باز خواهد گشت.');
                    window.open(data.url, '_blank', 'toolbar=yes, location=yes, status=yes, menubar=yes, scrollbars=yes');
                }
            }
            else
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            }
        }).error(function (data, status, headers, config) {
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });
    };
});

angular.module('ngApp').controller('registerPageCtrl', function($scope, $timeout, $http, $ionicHistory, $localstorage, $ionicPopup, $ionicLoading, $state) {

    $scope.back = function() {
        var checker = "nav."+loginPageSlug;
        $state.go(checker);
    };

	$scope.userInfo = {};
	$scope.userInfo.fullname = "";
	$scope.userInfo.email = "";
	$scope.userInfo.password = "";

	$scope.validateEmail = function(email)
	{
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	};
	
	$scope.checkMobile = function (mobile)
    {
        if(typeof mobile === 'undefined')
            return false;
        else
        {
            mobile = replacePersianNumbers(mobile);
            if( mobile.length != 11 )
                return false;
            if( mobile.substring(0, 2) != '09')
                return false;
            if( isNaN(mobile) )
                return false;
        }
        return true;
    };

    $scope.registerUser = function()
    {
        if(!checkNetConnection())
        {
            var success = function(message) {

            };
            var failure = function() {
                alert("عدم دسترسی به اینترنت");
            };
            window.plugins.toast.show("Internet ERROR", 'long', 'center', success, failure);
            return false;
        }
        var activeTypeAccount = $("#activeTypeAccountRegister").val();
        var emailOrMobile = '', emailMobileUsername = '';
        if( !$.trim($scope.userInfo.fullname) )
        {
            $ionicPopup.alert({
                title: "خطا",
                template: "لطفا فیلدهای ستاره دار را کامل نمایید",
                okText: "باشه"
            });
            return false;
        }
        if( activeTypeAccount === 'activeWithEmail' )
        {
            if( !$scope.validateEmail( $scope.userInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'email';
            emailMobileUsername = $scope.userInfo.email;
        }
        else if( activeTypeAccount === 'activeWithSms' )
        {
            if( !$scope.checkMobile($scope.userInfo.mobile) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'mobile';
            emailMobileUsername = $scope.userInfo.mobile;
        }
        else if( activeTypeAccount === 'activeWithEmailSms' )
        {
            if( $scope.userInfo.emailOrMobile.indexOf( '@' ) > 0 )
            {
				/*Email*/
                if( !$scope.validateEmail( $scope.userInfo.emailOrMobile ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'email';
            }
            else
            {
				/*Mobile*/
                if( !$scope.checkMobile($scope.userInfo.emailOrMobile) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'mobile';
            }
            emailMobileUsername = $scope.userInfo.emailOrMobile;
        }
        else
        {
            if(!$.trim($scope.userInfo.username))
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا یک نام کاربری برای خود انتخاب نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailMobileUsername = $scope.userInfo.username;
        }

        $("#emailOrMobile").val( emailOrMobile );
        if( !$.trim($scope.userInfo.password) )
        {
            $ionicPopup.alert({
                title: "خطا",
                template: "لطفا فیلدهای ستاره دار را کامل نمایید",
                okText: "باشه"
            });
            return false;
        }

        var checkboxValue = {};
        $('[data-checkbox="checkbox"]').each(function(i, e){
            if( $(e).is(':checked') )
            {
                var name = $(e).attr('name');
                if( !(name in checkboxValue) )
                {
					/*true if "key" doesn't exist in object*/
                    checkboxValue[name] = $(e).val();
                }
                else
                {
                    checkboxValue[name] = checkboxValue[name] + ',' + $(e).val();
                }
            }
        });
        checkboxValue = JSON.stringify(checkboxValue);
        $("#checkbox_inputs").val( checkboxValue );

        $ionicLoading.show();
        $.ajax({
            type: 'POST',
            url: url + '/api/v1/widget/post/login-register/register',
            data: $("#registerForm").serialize(),
            dataType: 'json',
            success: function(data)
            {
                if(data.status === "successWithSend")
                {
                    $('#registerForm')[0].reset();
                    $ionicPopup.alert({
                        title: "موفقیت",
                        template: "کد فعال سازی برای شما ارسال شد!",
                        okText: "باشه"
                    }).then(function(res)
                    {
                        $localstorage.setNoExpired('registerActiveTypeAccount', activeTypeAccount);
                        $localstorage.setNoExpired('registerEmailMobileUsername', emailMobileUsername);
                        $localstorage.setNoExpired('registerEmailOrMobile', emailOrMobile);

                        $state.go('nav.active-code');
                    });
                }
                else if(data.status === 'successWithActive') // use username
                {
                    $('#registerForm')[0].reset();
                    $ionicPopup.alert({
                        title: "موفقیت",
                        template: "ثبت نام شما با موفقیت انجام شد و میتوانید وارد شوید",
                        okText: "باشه"
                    }).then(function(res) {
                        $state.go('nav.index');
                    });
                }
                else if( data.status === 'successWithoutSend' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "ثبت نام شما انجام شد اما متاسفانه موفق به ارسال کد فعال سازی برای شما نشدیم لطفا از قسمت ارسال مجدد کد فعال سازی اقدام نمایید",
                        okText: "باشه"
                    }).then(function(res) {
                        $state.go('nav.send-new-code');
                    });
                }
                else if( data.status === 'fillRequiredInputs' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا فیلدهای ستاره دار را کامل نمایید",
                        okText: "باشه"
                    });
                }
                else if( data.status === 'endLimit' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "امکان ثبت نام وجود ندارد لطفا با مدیر اپلیکیشن تماس حاصل نمایید",
                        okText: "باشه"
                    });
                }
                else if( data.status === 'existEmail' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "این ایمیل قبلا ثبت شده است!",
                        okText: "باشه"
                    });
                }
                else if( data.status === 'existMobile' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "این تلفن همراه قبلا ثبت شده است!",
                        okText: "باشه"
                    });
                }
                else if( data.status === 'existUsername' )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "این نام کاربری قبلا ثبت شده است!",
                        okText: "باشه"
                    });
                }
                else
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا دوباره تلاش کنید!",
                        okText: "باشه"
                    });
                }
            }
        }).always(function() {
            $ionicLoading.hide();
        }).fail(function() {
            var success = function(message) {

            };
            var failure = function() {
                alert("عدم دسترسی به اینترنت");
            };
			/*window.plugins.toast.show("عدم دسترسی به اینترنت", 'long', 'center', success, failure);*/
        });

        return false;
    };

	$('#registerForm').on('submit', function() {
		if( $scope.userInfo.fullname == "" )
		{
			$ionicPopup.alert({
				title: "خطا",
				template: "لطفا فیلدهای ستاره دار را کامل نمایید",
				okText: "باشه"
			});
			return false;
		}
		if( !$scope.validateEmail( $scope.userInfo.email ) )
		{
			$ionicPopup.alert({
				title: "خطا",
				template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
				okText: "باشه"
			});
			return false;
		}
		if( $scope.userInfo.password == "" )
		{
			$ionicPopup.alert({
				title: "خطا",
				template: "لطفا فیلدهای ستاره دار را کامل نمایید",
				okText: "باشه"
			});
			return false;
		}

		var checkboxValue = {};
		$('[data-checkbox="checkbox"]').each(function(i, e){
			if( $(e).is(':checked') )
			{
				var name = $(e).attr('name');
				if( !(name in checkboxValue) )
				{
					/*true if "key" doesn't exist in object*/
					checkboxValue[name] = $(e).val();
				}
				else
				{
					checkboxValue[name] = checkboxValue[name] + ',' + $(e).val();
				}
			}
		});
		checkboxValue = JSON.stringify(checkboxValue);
		$("#checkbox_inputs").val( checkboxValue );

		$ionicLoading.show();
		$.ajax({
			type: 'POST',
			url: url + '/api/v1/widget/post/login-register/register',
			data: $(this).serialize(),
			dataType: 'json',
			success: function(data)
			{
				if(data.status == "successWithEmail")
				{
					$('#registerForm')[0].reset();
					$ionicPopup.alert({
						title: "موفقیت",
						template: "کد فعال سازی برای شما ایمیل شد!",
						okText: "باشه"
					}).then(function(res) {
						$state.go('nav.active-code');
					});
				}
				else if( data.status == 'successWithoutEmail' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "ثبت نام شما انجام شد اما متاسفانه موفق به ارسال کد فعال سازی برای شما نشدیم لطفا از قسمت ارسال مجدد کد فعال سازی اقدام نمایید",
						okText: "باشه"
					}).then(function(res) {
						$state.go('nav.send-new-code');
					});
				}
				else if( data.status == 'fillRequiredInputs' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "لطفا فیلدهای ستاره دار را کامل نمایید",
						okText: "باشه"
					});
				}
				else if( data.status == 'endLimit' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "امکان ثبت نام وجود ندارد لطفا با مدیر اپلیکیشن تماس حاصل نمایید",
						okText: "باشه"
					});
				}
				else if( data.status == 'existEmail' )
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "این ایمیل قبلا ثبت شده است!",
						okText: "باشه"
					});
				}
				else
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "لطفا دوباره تلاش کنید!",
						okText: "باشه"
					});
				}
			}
		}).always(function() {
			$ionicLoading.hide();
		}).fail(function() {
			var success = function(message) {

			};
			var failure = function() {
				alert("عدم دسترسی به اینترنت");
			};
			/*window.plugins.toast.show("عدم دسترسی به اینترنت", 'long', 'center', success, failure);*/
		});

		return false;
	});
	
});

angular.module('ngApp').controller('activeCodePageCtrl', function($ionicSideMenuDelegate, $ionicPopover, $scope, $timeout, $http, $ionicHistory, $localstorage, $ionicPopup, $ionicLoading, $state, $appetoToast) {

	$scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
		var checker = "nav.active-code";
		if(toState.name == checker) {
			$ionicSideMenuDelegate.canDragContent(false);
		}
		else {
			$ionicSideMenuDelegate.canDragContent(true);
		}
	});

	$ionicPopover.fromTemplateUrl('popover.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.closePopover = function() {
		$scope.popover.hide();
	};

	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

	// Execute action on hide popover
	$scope.$on('popover.hidden', function() {
		// Execute action
	});

	// Execute action on remove popover
	$scope.$on('popover.removed', function() {
		// Execute action
	});

	$scope.back = function() {
		var checker = "nav."+loginPageSlug;
		$state.go(checker);
	};

	$scope.codeInfo = {};
	$scope.codeInfo.activeCode = "";
	$scope.checkActiveCode = function()
	{
		if( $.trim($scope.codeInfo.activeCode) )
		{
			$ionicLoading.show();
			var sendData = $.param({
				activeCode: $scope.codeInfo.activeCode,
				sl: $scope.sl,
                registerActiveTypeAccount: $localstorage.getNoExpired('registerActiveTypeAccount'),
                registerEmailMobileUsername: $localstorage.getNoExpired('registerEmailMobileUsername'),
                registerEmailOrMobile: $localstorage.getNoExpired('registerEmailOrMobile')
			});
			$http({
				method: 'POST',
				url: url + '/api/v1/widget/post/login-register/activeThisUser',
				data: sendData,
				headers: {'Content-Type': 'application/x-www-form-urlencoded'}
			}).success(function (data, status, headers, config) {
				$ionicLoading.hide();
				if(data.status === 'success')
				{
                    $localstorage.setNoExpired('loginUserId', data.userId);
                    $localstorage.setNoExpired('loginRoleId', data.roleId);
                    $localstorage.setNoExpired('loginLoginKey', data.key);
                    $localstorage.setNoExpired('loginFullName', data.fullName);
                    $localstorage.setNoExpired('loginProfileImage', data.profileImage);
                    $localstorage.setNoExpired('loginDateAccessPersian', data.dateAccessPersian);
                    $localstorage.setNoExpired('loginCanVisitPages', data.canVisitPages);

                    $scope.codeInfo.activeCode = "";
                    $appetoToast.make("اکانت شما فعال شد!", 2000);

                    /*$ionicPopup.alert({
                        title: "موفقیت",
                        template: "اکانت شما فعال شد!",
                        okText: "باشه"
                    });*/
					if( data.redirectTo !== '' && data.redirectTo !== 'profile' )
					{
                        try {
                            $ionicHistory.nextViewOptions({
                                historyRoot: true
                            });
                            $state.go('nav.'+data.redirectTo, {userId: data.userId, loginKey: data.key});
                        }
                        catch(err) {
                            $state.go('nav.profile', {userId: data.userId, loginKey: data.key});
                        }
					}
					else
					{
                        $state.go('nav.profile', {userId: data.userId, loginKey: data.key});
					}
				}
				else
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "کد فعال سازی مورد تایید نبود",
						okText: "باشه"
					});
				}
			}).error(function (data, status, headers, config) {
				$ionicLoading.hide();
				$ionicPopup.alert({
					title: "خطا",
					template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
					okText: "باشه"
				});
			});
		}
	};
});

angular.module('ngApp').controller('sendNewCodePageCtrl', function($ionicSideMenuDelegate, $ionicPopover, $scope, $timeout, $appetoToast,
																   $http, $ionicHistory, $localstorage, $ionicPopup, $ionicLoading, $state) {

	$scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
		var checker = "nav.send-new-code";
		if(toState.name == checker) {
			$ionicSideMenuDelegate.canDragContent(false);
		}
		else {
			$ionicSideMenuDelegate.canDragContent(true);
		}
	});

	$ionicPopover.fromTemplateUrl('popover.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.closePopover = function() {
		$scope.popover.hide();
	};

	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

	// Execute action on hide popover
	$scope.$on('popover.hidden', function() {
		// Execute action
	});

	// Execute action on remove popover
	$scope.$on('popover.removed', function() {
		// Execute action
	});

	$scope.back = function() {
		var checker = "nav."+loginPageSlug;
		$state.go(checker);
	};

	$scope.codeInfo = {};
	$scope.codeInfo.email = ""; // email or mobile
	$scope.codeInfo.newActiveCode = "";
	$scope.newCodeInputs = false;

	$scope.validateEmail = function(email)
	{
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	};
    $scope.checkMobile = function (mobile)
    {
        if(typeof mobile === 'undefined')
            return false;
        else
        {
            mobile = replacePersianNumbers(mobile);
            if( mobile.length != 11 )
                return false;
            if( mobile.substring(0, 2) != '09')
                return false;
            if( isNaN(mobile) )
                return false;
        }
        return true;
    };

	$scope.sendNewCode = function()
	{
		var activeTypeAccount = $("#activeTypeAccount").val();
		var emailOrMobile = '';
		if( activeTypeAccount === 'activeWithEmail' )
		{
            if( !$scope.validateEmail( $scope.codeInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'email';
		}
		else if( activeTypeAccount === 'activeWithSms' )
		{
            if( !$scope.checkMobile( $scope.codeInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'mobile';
		}
		else if( activeTypeAccount === 'activeWithEmailSms' )
		{
            if( $scope.codeInfo.email.indexOf( '@' ) > 0 )
            {
                /*Email*/
                if( !$scope.validateEmail( $scope.codeInfo.email ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'email';
            }
            else
            {
                /*Mobile*/
                if( !$scope.checkMobile( $scope.codeInfo.email ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'mobile';
            }
		}
		else
		{
			return false;
		}

		$ionicLoading.show();
		var sendData = $.param({
			emailMobile: $scope.codeInfo.email,
			sl: $scope.sl,
            activeTypeAccount: activeTypeAccount,
            emailOrMobileUsed: emailOrMobile
		});
		$http({
			method: 'POST',
			url: url + '/api/v1/widget/post/login-register/sendNewActiveCode',
			data: sendData,
			headers: {'Content-Type': 'application/x-www-form-urlencoded'}
		}).success(function (data, status, headers, config) {
			$ionicLoading.hide();

			if( data.status === 'success' )
			{
				$scope.codeInfo.email = "";
                $scope.newCodeInputs = true;
				$ionicPopup.alert({
					title: "موفقیت",
					template: "کد فعال سازی برای شما ارسال شد",
					okText: "باشه"
				});
			}
			else if( data.status === 'accountIsActive' )
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "این اکانت فعال است!",
					okText: "باشه"
				});
			}
			else if( data.status === 'infoNotExist' )
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "اطلاعات ثبت نشده است لطفا ابتدا ثبت نام کنید",
					okText: "باشه"
				});
			}
			else
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "لطفا دوباره تلاش کنید",
					okText: "باشه"
				});
			}
		}).error(function (data, status, headers, config) {
			$ionicLoading.hide();
			$ionicPopup.alert({
				title: "خطا",
				template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
				okText: "باشه"
			});
		});
	};

	$scope.checkNewActiveCode = function ()
	{
        if( $.trim($scope.codeInfo.newActiveCode) )
        {
            $ionicLoading.show();
            var sendData = $.param({
                activeCode: $scope.codeInfo.newActiveCode,
                sl: $scope.sl,
                registerActiveTypeAccount: $localstorage.getNoExpired('registerActiveTypeAccount'),
                registerEmailMobileUsername: $localstorage.getNoExpired('registerEmailMobileUsername'),
                registerEmailOrMobile: $localstorage.getNoExpired('registerEmailOrMobile')
            });
            $http({
                method: 'POST',
                url: url + '/api/v1/widget/post/login-register/activeThisUser',
                data: sendData,
                headers: {'Content-Type': 'application/x-www-form-urlencoded'}
            }).success(function (data, status, headers, config) {
                $ionicLoading.hide();
                if(data.status === 'success')
                {
                    /*$localstorage.setNoExpired('loginUserId', data.userId);
                    $localstorage.setNoExpired('loginRoleId', data.roleId);
                    $localstorage.setNoExpired('loginLoginKey', data.key);
                    $localstorage.setNoExpired('loginFullName', data.fullName);
                    $localstorage.setNoExpired('loginProfileImage', data.profileImage);
                    $localstorage.setNoExpired('loginDateAccessPersian', data.dateAccessPersian);
                    $localstorage.setNoExpired('loginCanVisitPages', data.canVisitPages);*/

                    $appetoToast.make("اکانت شما فعال شد!", 2000);
                    /*if( data.redirectTo !== '' && data.redirectTo !== 'profile' )
                    {
                        $ionicHistory.nextViewOptions({
                            historyRoot: true
                        });
                        $state.go('nav.'+data.redirectTo, {userId: data.userId, loginKey: data.key});
                    }
                    else
                    {
                        $state.go('nav.profile', {userId: data.userId, loginKey: data.key});
                    }*/
                }
                else
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "کد فعال سازی مورد تایید نبود",
                        okText: "باشه"
                    });
                }
            }).error(function (data, status, headers, config) {
                $ionicLoading.hide();
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            });
        }
    };
});

angular.module('ngApp').controller('forgotPasswordPageCtrl', function($ionicSideMenuDelegate, $ionicPopover, $scope, $timeout, $http, $ionicHistory, $localstorage, $ionicPopup, $ionicLoading, $state) {

	$scope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
		var checker = "nav.forgot-password";
		if(toState.name == checker) {
			$ionicSideMenuDelegate.canDragContent(false);
		}
		else {
			$ionicSideMenuDelegate.canDragContent(true);
		}
	});

	$ionicPopover.fromTemplateUrl('popover.html', {
		scope: $scope
	}).then(function(popover) {
		$scope.popover = popover;
	});

	$scope.openPopover = function($event) {
		$scope.popover.show($event);
	};

	$scope.closePopover = function() {
		$scope.popover.hide();
	};

	//Cleanup the popover when we're done with it!
	$scope.$on('$destroy', function() {
		$scope.popover.remove();
	});

	// Execute action on hide popover
	$scope.$on('popover.hidden', function() {
		// Execute action
	});

	// Execute action on remove popover
	$scope.$on('popover.removed', function() {
		// Execute action
	});

	$scope.back = function() {
		var checker = "nav."+loginPageSlug;
		$state.go(checker);
	};

	$scope.codeInfo = {};
	$scope.codeInfo.email = "";
	$scope.codeInfo.password = "";
	$scope.codeInfo.code = "";
	$scope.emailInput = true;
	$scope.codeInput = false;

	$scope.validateEmail = function(email)
	{
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	};
    $scope.checkMobile = function (mobile)
    {
        if(typeof mobile === 'undefined')
            return false;
        else
        {
            mobile = replacePersianNumbers(mobile);
            if( mobile.length != 11 )
                return false;
            if( mobile.substring(0, 2) != '09')
                return false;
            if( isNaN(mobile) )
                return false;
        }
        return true;
    };

	$scope.sendCodeForgotPass = function()
	{
		var activeTypeAccount = $("#activeTypeAccount").val();
		var emailOrMobile = '';
		if( activeTypeAccount === 'activeWithEmail' )
		{
            if( !$scope.validateEmail( $scope.codeInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'email';
		}
		else if( activeTypeAccount === 'activeWithSms' )
		{
            if( !$scope.checkMobile( $scope.codeInfo.email ) )
            {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                    okText: "باشه"
                });
                return false;
            }
            emailOrMobile = 'mobile';
		}
		else if( activeTypeAccount === 'activeWithEmailSms' )
		{
            if( $scope.codeInfo.email.indexOf( '@' ) > 0 )
            {
                /*Email*/
                if( !$scope.validateEmail( $scope.codeInfo.email ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا ایمیل خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'email';
            }
            else
            {
                /*Mobile*/
                if( !$scope.checkMobile( $scope.codeInfo.email ) )
                {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "لطفا تلفن همراه خود را بصورت صحیح وارد نمایید",
                        okText: "باشه"
                    });
                    return false;
                }
                emailOrMobile = 'mobile';
            }
		}
		else
		{
			return false;
		}

		$ionicLoading.show();
		var sendData = $.param({
			emailMobile: $scope.codeInfo.email,
			sl: $scope.sl,
            activeTypeAccount: activeTypeAccount,
            emailOrMobileUsed: emailOrMobile
		});
		$http({
			method: 'POST',
			url: url + '/api/v1/widget/post/login-register/sendCodeForgotPassword',
			data: sendData,
			headers: {'Content-Type': 'application/x-www-form-urlencoded'}
		}).success(function (data, status, headers, config) {
			$ionicLoading.hide();

			if( data.status === 'success' )
			{
				$scope.codeInfo.email = "";
				$scope.emailInput = false;
				$scope.codeInput = true;
				$ionicPopup.alert({
					title: "موفقیت",
					template: "کد تغییر رمز عبور برای شما ارسال شد!",
					okText: "باشه"
				});
			}
			else if( data.status === 'accountNotActive' )
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "شما باید ابتدا اکانت خود را فعال کنید",
					okText: "باشه"
				});
			}
			else if( data.status === 'infoNotExist' )
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "اطلاعات ثبت نشده است لطفا ابتدا ثبت نام کنید",
					okText: "باشه"
				});
			}
			else
			{
				$ionicPopup.alert({
					title: "خطا",
					template: "لطفا دوباره تلاش کنید",
					okText: "باشه"
				});
			}
		}).error(function (data, status, headers, config) {
			$ionicLoading.hide();
			$ionicPopup.alert({
				title: "خطا",
				template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
				okText: "باشه"
			});
		});
	};

	$scope.changePassword = function()
	{
		if( $.trim($scope.codeInfo.code) && $.trim($scope.codeInfo.password) )
		{
			$ionicLoading.show();
			var sendData = $.param({
				code: $scope.codeInfo.code,
				password: $scope.codeInfo.password,
				sl: $scope.sl
			});
			$http({
				method: 'POST',
				url: url + '/api/v1/widget/post/login-register/changePassword',
				data: sendData,
				headers: {'Content-Type': 'application/x-www-form-urlencoded'}
			}).success(function (data, status, headers, config) {
				$ionicLoading.hide();

				if( data.status === 'success' )
				{
					$scope.codeInfo.code = "";
					$scope.codeInfo.password = "";
					$scope.emailInput = true;
					$scope.codeInput = false;
					$ionicPopup.alert({
						title: "موفقیت",
						template: "رمز عبور شما تغییر کرد!",
						okText: "باشه"
					});
				}
				else if( data.status === 'falseCode' )
				{
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "کد وارد شده صحیح نمی باشد",
                        okText: "باشه"
                    });
				}
				else
				{
					$ionicPopup.alert({
						title: "خطا",
						template: "لطفا دوباره تلاش کنید",
						okText: "باشه"
					});
				}
			}).error(function (data, status, headers, config) {
				$ionicLoading.hide();
				$ionicPopup.alert({
					title: "خطا",
					template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
					okText: "باشه"
				});
			});
		}
	};
});

angular.module('ngApp').controller('noAccessPageCtrl', function($scope) {

});

function replacePersianNumbers(num)
{
    num = replaceAll(num, '۰', '0');
    num = replaceAll(num, '۱', '1');
    num = replaceAll(num, '۲', '2');
    num = replaceAll(num, '۳', '3');
    num = replaceAll(num, '۴', '4');
    num = replaceAll(num, '۵', '5');
    num = replaceAll(num, '۶', '6');
    num = replaceAll(num, '۷', '7');
    num = replaceAll(num, '۸', '8');
    num = replaceAll(num, '۹', '9');

    return num;
}

function replaceAll(str, find, replace) {
    return str.replace(new RegExp(find, 'g'), replace);
}

function successECafeInitNew(result)
{
    angular.element($('ion-view')).injector().get("$ionicLoading").hide();
    inappbilling.buy(cafebazaarEPurchaseDoneNew, cafebazaarEPurchaseErrorNew, currentSKU);
}

function errorECafeCallbackNew(error)
{
    angular.element($('ion-view')).injector().get("$ionicLoading").hide();
    currentSKU = '';
    currentSubscribe = '';
    currentPath = '';
    currentEmail = '';
    currentCard = '';
    currentUserinfo = '';
    var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
    $scope.removeAllCard();

    angular.element($('ion-view')).injector().get("$ionicPopup").alert({
        title: "خطا",
        template: "خطا در اتصال به کافه بازار، لطفا در اپلیکیشن کافه بازار وارد حساب کاربری خود شوید.",
        okText: "باشه"
    });
}

function cafebazaarEPurchaseDoneNew (result)
{
    var data = {
        'orderCode': result.orderId,
        'card': currentCard,
        'userInfo': currentUserinfo,
        'productId': result.productId,
        'description': 'کد محصول: '+result.productId,
        'sl': currentSL,
        'currentSku': currentSKU,
        'backToMe': url + '/api/v1/widget/get/ecommerce-new/paymentCheckNew?info=%s'
    };
    var orderCode = result.orderId;
    angular.element($('ion-view')).injector().get("$ionicLoading").show();
    $.ajax({
        type: 'POST',
        url: url + '/api/v1/widget/post/ecommerce-new/buyProductCard',
        data: data,
        dataType: 'json',
        success: function(data)
        {
            if(data.status == 'success')
            {
                var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
                $scope.removeAllCard();
                if(typeof data.dl != "undefined" && data.dl != "") {
                    var fileTransfer = new FileTransfer();
                    var uri = encodeURI(data.dl);
                    var fileURL = cordova.file.externalCacheDirectory + '/'+currentPath;

                    angular.element($('ion-view')).injector().get("$ionicPopup").alert({
                        title: "خرید شما تکمیل شد",
                        template: "با تشکر خرید شما انجام شد و اطلاعات مورد نظر برای شما ایمیل شد.<br /><span style='direction: ltr'> شماره پیگیری: 99"+data.url+" </span><br />در حال دانلود فایل: "+
                        "<span id='fileDownloadingProgress'>0</span>%",
                        okText: "باشه"
                    });

                    fileTransfer.onprogress = function(progressEvent) {
                        if (progressEvent.lengthComputable) {
                            $("#fileDownloadingProgress").html(Math.ceil(progressEvent.loaded / progressEvent.total) * 100);
                        }
                    };
                    fileTransfer.download(
                        uri,
                        fileURL,
                        function(entry) {
                            window.open(entry.toURL(), '_filemanager');
                        },
                        function(error) {
                            alert('خطا، فایل مورد نظر دانلود نشد: '+error.code);
                        },
                        true,
                        {

                        }
                    );
                }
                else {
                    angular.element($('ion-view')).injector().get("$ionicPopup").alert({
                        title: "خرید شما تکمیل شد",
                        template: "با تشکر خرید شما انجام شد و اطلاعات مورد نظر برای شما ایمیل شد.<br /><span style='direction: ltr'> شماره پیگیری: 99"+data.url+" </span>",
                        okText: "باشه"
                    });
                }
            }
            else if(data.status == 'bazaar') {
                var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
                $scope.removeAllCard();
                angular.element($('ion-view')).injector().get("$ionicPopup").alert({
                    title: "خطا",
                    template: "خطا در اعتبار سنجی خرید شما، لطفا در صورتی که از صحیح بودن خرید خود مطمعن هستید با پشتیبانی تماس بگیرید، کد پیگیری: "+orderCode,
                    okText: "باشه"
                });
            }
            else
            {
                var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
                $scope.removeAllCard();
                angular.element($('ion-view')).injector().get("$ionicPopup").alert({
                    title: "خطا",
                    template: "خرید شما انجام شد اما اطلاعات برای شما ایمیل نشد، لطفا دوباره تلاش کنید.<br /> دقت کنید که هنگام خرید دوباره نیازی به پرداخت هزینه نخواهد بود.",
                    okText: "باشه"
                });
            }
        }
    }).always(function() {
        currentSKU = '';
        currentPath = '';
        currentEmail = '';
        currentCard = '';
        currentUserinfo = '';
        angular.element($('ion-view')).injector().get("$ionicLoading").hide();
    }).fail(function() {
        var success = function(message) {

        };
        var failure = function() {
            alert("عدم دسترسی به اینترنت");
        };
        window.plugins.toast.show("عدم دسترسی به اینترنت", 'long', 'center', success, failure);
        var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
        $scope.removeAllCard();
    });
}

function cafebazaarEPurchaseErrorNew (error)
{
    currentSKU = '';
    currentSubscribe = '';
    currentPath = '';
    currentEmail = '';
    currentCard = '';
    currentUserinfo = '';
    var $scope = angular.element('[ng-controller=eCommerceCardCtrl]').scope();
    $scope.removeAllCard();
    angular.element($('ion-view')).injector().get("$ionicPopup").alert({
        title: "خطا",
        template: "خطا در خرید، خرید شما انجام نشد.",
        okText: "باشه"
    });
}

function cafebazaarECommerceInit(sku, email, path, sl, card, userinfo)
{
    var is_app_call = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
    if(!is_app_call) {
        alert("این کار فقط در فایل ساخته شده آندروید امکان پذیر میباشد.");
        return false;
    }
    angular.element($('ion-view')).injector().get("$ionicLoading").show();
    currentEmail = email;
    currentSKU = sku;
    currentPath = path;
    currentSL = sl;
    currentCard = card;
    currentUserinfo = userinfo;
    inappbilling.init(successECafeInitNew, errorECafeCallbackNew, {showLog:false});
}

function onCameraSuccess(imageURI) {
    var $scope = angular.element('[ng-controller=profilePageCtrl]').scope();
    $scope.onCameraSuccess("data:image/jpg;base64," + imageURI);
}

function onCameraFail(message) {
    var $scope = angular.element('[ng-controller=profilePageCtrl]').scope();
    $scope.onCameraFail(message);
}