angular.module('ngApp').controller('VoteCtrl', function($scope, $rootScope, $localstorage, $state, $ionicModal, $timeout, $ionicLoading, $http, $ionicPopup) {
    $scope.sl = '';
    $scope.qIds = [];
    $scope.selectAnswers = {};
    $scope.answerResult = {};
    $scope.show_results = 1;
    $scope.use_login = 0;
    $scope.vote_btn = 'ثبت رای';
    $scope.vote_btn_login = 'برای ارسال رای، وارد شوید یا ثبت نام کنید';
    $scope.emptyError = 'لطفا نظر خود را برای تمامی سوالات انتخاب کنید';
    $scope.successMsg = 'با تشکر رای شما ثبت شد';
    $scope.votedMsg = 'شما قبلا رای داده اید';
    $scope.viewResults = 'بروزرسانی نتایج';
    $scope.vote_btn_class = 'vote-btn';
    $scope.userId = 0;
    $scope.isVoted = false;
    $scope.lastVotes = [];
    $scope.pageId = 0;
    $scope.$watch('sl', function () {

        /*Iman new*/
        $scope.updateResults();
        /*Iman new*/
        //$scope.ctrlVotePage();
    });
    $scope.ctrlVotePage = function()
    {
        if($scope.use_login == 1) {
            var userId = $localstorage.getNoExpired('loginUserId');
            var roleId = $localstorage.getNoExpired('loginRoleId');
            var loginKey = $localstorage.getNoExpired('loginLoginKey');
            if( userId == '' || roleId == '' || loginKey == '' )
            {
                $scope.vote_btn = $scope.vote_btn_login;
                $scope.vote_btn_class = 'vote-btn-login';
            }
            else {
                $scope.userId = userId;
            }
        }

        var isVoted = $localstorage.getNoExpired('isVoted'+$scope.pageId);
        if(isVoted == 'yes')
        {
            $scope.isVoted = true;
            if($scope.show_results == 1) {
                $scope.vote_btn = $scope.viewResults;
            }
            else {
                $scope.vote_btn_class = 'vote-btn-hidden';
            }
            $timeout(function(){
                $scope.selectAnswers = $localstorage.getObjectNoExpired('selectAnswers'+$scope.pageId);
                if($scope.show_results == 1) {
                    $scope.answerResult = $localstorage.getObjectNoExpired('answerResult'+$scope.pageId);
                    var id = "";
                    for(var p in $scope.answerResult) {
                        id = p.replace("id", "apid");
                        $( "#"+id ).animate({
                            width: $scope.answerResult[p]+"%"
                        }, 800, function() {
                        });
                    }
                }
            }, 500);
        }

    };

    $scope.setQids = function(id){
        $scope.qIds.push(id);
    };

    $scope.sendVote = function() {
        if($scope.use_login == 1) {
            var userId = $localstorage.getNoExpired('loginUserId');
            var roleId = $localstorage.getNoExpired('loginRoleId');
            var loginKey = $localstorage.getNoExpired('loginLoginKey');
            if( userId == '' || roleId == '' || loginKey == '' )
            {
                $state.go('nav.'+loginPageSlug);
                return false;
            }
            else {
                $scope.userId = userId;
            }
        }
        if($scope.isVoted) {
            if($scope.show_results == 1) {
                $scope.updateResults();
            }
            else {
                $ionicPopup.alert({
                    title: "پیام",
                    template: $scope.votedMsg,
                    okText: "باشه"
                });
            }
            return false;
        }

        var haveError = false;
        for(var id in $scope.qIds) {
            if($scope.selectAnswers["id"+$scope.qIds[id]] === undefined || $scope.selectAnswers["id"+$scope.qIds[id]] == null || $scope.selectAnswers["id"+$scope.qIds[id]] == 0) {
                haveError = true;
                break;
            }
        }
        if(haveError) {
            $ionicPopup.alert({
                title: "خطا",
                template: $scope.emptyError,
                okText: "باشه"
            });
            return false;
        }
        $ionicLoading.show();
        var sendData = $.param({
            userId: $scope.userId,
            sl: $scope.sl,
            selectAnswers: $scope.selectAnswers
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/vote/registerVote',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config) {
            $ionicLoading.hide();
            if(data.status == "success") {
                var alertPopup = $ionicPopup.alert({
                    title: "پیام",
                    template: $scope.successMsg,
                    okText: "باشه"
                });
                $localstorage.setObjectNoExpired('selectAnswers'+$scope.pageId, $scope.selectAnswers);
                $localstorage.setObjectNoExpired('answerResult'+$scope.pageId, data.results);
                $localstorage.setNoExpired('isVoted'+$scope.pageId, 'yes');
                $scope.isVoted = true;
                if($scope.show_results == 1) {
                    $scope.vote_btn = $scope.viewResults;
                }
                else {
                    $scope.vote_btn_class = 'vote-btn-hidden';
                }
                alertPopup.then(function(res) {
                    if($scope.show_results == 1) {
                        $scope.updateResults();
                    }
                });
            }
            else {
                $ionicPopup.alert({
                    title: "خطا",
                    template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                    okText: "باشه"
                });
            }
        }).error(function (data, status, headers, config) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
        });
    };

    $scope.updateResults = function() {
        $ionicLoading.show();
        var sendData = $.param({
            sl: $scope.sl
        });
        $http({
            method: 'POST',
            url: url + '/api/v1/widget/post/vote/getResults',
            data: sendData,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'}
        }).success(function (data, status, headers, config) {
            $ionicLoading.hide();
            if(data.status == "success")
            {
                $localstorage.setObjectNoExpired('answerResult'+$scope.pageId, data.results);
                if(typeof data.results != "undefined") {
                    $scope.answerResult = data.results;

                    /*Iman new*/
                    var newid = "";
                    var sum = 0;
                    for(var p in $scope.answerResult)
                    {
                        newid = p.replace("id", "apid");
                        if( newid.indexOf('total') !== -1 )
                        {
                            sum += $scope.answerResult[p];
                        }
                    }
                    if( sum === 0 )
                    {
                        $localstorage.setNoExpired('isVoted'+$scope.pageId, 'no');
                        $localstorage.setObjectNoExpired('selectAnswers'+$scope.pageId, {});
                        $localstorage.setObjectNoExpired('answerResult'+$scope.pageId, {});
                        $scope.answerResult = {};
                    }
                    /*Iman new*/

                    var id = "";
                    for(var p in $scope.answerResult) {
                        id = p.replace("id", "apid");
                        $( "#"+id ).animate({
                            width: $scope.answerResult[p]+"%"
                        }, 800, function() {
                        });
                    }
                }
            }
            else {
                if($scope.show_results == 1) {
                    $ionicPopup.alert({
                        title: "خطا",
                        template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                        okText: "باشه"
                    });
                }
            }
            $scope.ctrlVotePage();
        }).error(function (data, status, headers, config) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: "خطا",
                template: "عملیات موفقیت آمیز نبود، لطفا دوباره تلاش کنید.",
                okText: "باشه"
            });
            $scope.ctrlVotePage();
        });
    };
});