angular.module('tiNavBar', ['ionic'])



.directive('tiFadeInNavBarOnScroll', function (tiNavBarDelegate, $rootScope, $ionicScrollDelegate, $timeout, $localstorage) {
  return {
    restrict: 'A',
    link: function ($scope, $element, $attr) {
      $timeout(function(){
        $element.css({top: 0});
        var targetRgbs = $attr.fadeToRgb.split(',');
        var navbars = tiNavBarDelegate.getNavBars();
        tiNavBarDelegate.makeNavBarTransparent();


        var opacity = 0;
        var ost = window.screen.height - 66;
        var ozst = ost - 20;
        function onScroll(event) {
          var scrollTop = $ionicScrollDelegate.$getByHandle($attr.delegateHandle).getScrollPosition().top;
          if (scrollTop <= ost) {
            handleNavBarFade(scrollTop);
          } else {
            opacity = 1;
            ionic.requestAnimationFrame(function () {
              tiNavBarDelegate.resetNavBar(targetRgbs);
            });
          }


        }

        $element.bind('scroll', onScroll);

        function handleNavBarFade(scrollTop) {
          if (scrollTop <= 20) {
            opacity = 0;
          } else if (scrollTop > 20 && scrollTop <= ost) {
            opacity = (scrollTop - 20) / ozst;
          } else {
            opacity = 1;
          }
          setOpacityToNavBar();
        }

        function setOpacityToNavBar() {
          $(".card-bar").css({boxShadow:"none"});
          ionic.requestAnimationFrame(function () {
            $(".card-bar").css({
              borderColor: 'rgba(' + targetRgbs[0] + ', ' + targetRgbs[1] + ', ' + targetRgbs[2] + ', ' + opacity + ')',
              backgroundColor: 'rgba(' + targetRgbs[0] + ', ' + targetRgbs[1] + ', ' + targetRgbs[2] + ', ' + opacity + ')',
              boxShadow: 'none'
            })
          });
        }

        $rootScope.$on('$stateChangeStart', function (event, toState, toParams) {
          if (toParams.id != $attr.stateName) {
            tiNavBarDelegate.resetNavBar(targetRgbs);
          }
        });

        $scope.$on('cardLoaded', function (event, toParams, isNotLoaded) {
          if(isNotLoaded) {
            handleNavBarFade(0);
            return true;
          }
          $ionicScrollDelegate.$getByHandle('card').resize();
          scr = $ionicScrollDelegate.$getByHandle('card').getScrollPosition().top;

          if (scr <= ost) {
            handleNavBarFade(scr);
          } else {
            ionic.requestAnimationFrame(function () {
              tiNavBarDelegate.resetNavBar(targetRgbs);
            });
          }
        })
      }, 0);
    }
  }
})
.service('tiNavBarDelegate', function ($document) {
  var navbars = $document[0].body.querySelectorAll('.nav-bar-block ion-header-bar');
  return {
    makeNavBarTransparent: function () {
      $(".card-bar").attr("style", "background-color: transparent;border-color:transparent;box-shadow:none");
    },
    resetNavBar: function (targetRgbs) {
      $(".card-bar").attr("style", 'box-shadow:0 0 4px 0 rgba(0,0,0,0.12), 0 4px 4px 0 rgba(0,0,0,0.24); background-color: rgb(' + targetRgbs[0] + ', ' + targetRgbs[1] + ', ' + targetRgbs[2] + ') !important;');
    },
    getNavBars: function () {
      return navbars;
    }
  }
});


